/**未登录，或非会员 有活动时显示活动提示**/
define(function(require, exports, module) {
    var utils = require('../utils');
    var normalizer = require('./urlFactory').createNormalizer();
    var appVersion = utils.getAppVersion();
    var DEFAULT_TIPS_NOTLOGIN ="登录后可同步VIP特权";
    var DEFAULT_TIPS_NOTVIP ="您还不是VIP会员";
    var DEFAULT_TIPS_EXPIRE ="您的VIP会员已过期";

    function _getConfigAjax() {
        var platform = utils.getPlatform();
        var url = [normalizer('http://pay.video.qq.com/fcgi-bin/get_config?name=449019&otype=json&platform='),platform,"&version=", appVersion].join('');
        var $defer = $.Deferred();
        $.ajax({
                url: url,
                dataType: 'jsonp'
            })
            .done(function(json) {
                if (json && json.result && json.result.code == 0) {
                    $defer.resolve(json);
                } else {
                    $defer.reject();
                }
            })
            .fail(function() {
                $defer.reject();
            });
        return $defer.promise();
    }

    function _initTipsShow(endTime) {
        utils.isAccountLogin(function() {
            _getConfigAjax().done(function(json){
                if (json && json.a_title) {
                    $('.js_tips_notVip').html(json.a_title);
                    $('.js_bind_account').hide();
                    $('.user_status').show();
                } else {
                    _setNotVipDefaultTips(endTime);
                }
            }).fail(function(){
                _setNotVipDefaultTips(endTime);
            });
        }, function() {
            _getConfigAjax().done(function(json){
                if (json && json.a_title) {
                    $('.js_tips_notlogin').html(json.a_title);
                } else {
                    $('.js_tips_notlogin').html(DEFAULT_TIPS_NOTLOGIN);
                }
            }).fail(function(){
                $('.js_tips_notlogin').html(DEFAULT_TIPS_NOTLOGIN);
            });
        });
    }

    function _setNotVipDefaultTips(endTime) {
        if (endTime == '') {//非会员
            $('.js_tips_notVip').text(DEFAULT_TIPS_NOTVIP);
        } else {//过期会员
            $('.js_tips_notVip').text(DEFAULT_TIPS_NOTVIP);
        }
        $('.js_bind_account').hide();
        $('.user_status').show();
    }

    module.exports = {
        init: _initTipsShow
    };
});
