/**
 *个人中心首页-展示每个套餐可用代金券列表
 */
define(function(require, exports, module) {
    var utils = require('../utils');
    var localStorage = window.localStorage;

     function _getCouponEndDate(dateTime) {
        var endTime = new Date(dateTime * 1000);
        var endTimeDate = endTime.getFullYear() + '-' + _add0(endTime.getMonth() + 1) + '-' + _add0(endTime.getDate());
        return endTimeDate;
    }

    // 日期左补0
    function _add0(n) {
        return n < 10 ? '0' + n : n;
    }


    //展示每个套餐可用代金券列表
    function showCouponPacList(packPrice,currentDom,pass_coupon_ext) {
        utils.getCouponPackageAjax(packPrice, function(json) {
            if (json.match_item && json.match_item.length > 0) {
                var couponList = json.match_item[0].vouchers_list;
                if (couponList && couponList.length > 0) {
                    var couponListTpl = "";
                    var selIndex = 0;
                    for (var i = 0; i < couponList.length; i++) {
                        var item = couponList[i];                       
                        couponListTpl += '<li class="item js_cpopon_chk" data-coupon-ext="' + item.coupons_ext + '" data-coupon-info="' + item.coupons_info + '" data-voucher-value="'+item.vouchers_value+'" data-voucher-leastPrice="'+item.least_price+'">';
                        if (item.coupons_ext == pass_coupon_ext) {
                            selIndex = i;
                            couponListTpl += '<a href="javascript:;" class="link_chk select">';
                        } else {
                            couponListTpl += '<a href="javascript:;" class="link_chk">';
                        }
                        couponListTpl += ' <span class="name">优惠券</span>';
                        couponListTpl += ' <span class="price">' + item.vouchers_value / 100 + '元</span>';
                        couponListTpl += ' <span class="time">有效期至' + _getCouponEndDate(item.end_time) + '</span>';
                        couponListTpl += ' <i class="icon_chk"></i>';
                        couponListTpl += ' </a>';
                        couponListTpl += ' </li>';
                    }
                    if (couponListTpl.length > 0) {
                        $('.js_coupon_list').html(couponListTpl);
                        $('.m_layer_mask').show();
                        $('.js_g_pop_coupon').show();
                        var itemHeight = $('.js_cpopon_chk').height();
                        var scrollHeight = itemHeight*selIndex;
                        $('.js_coupon_list').scrollTop(scrollHeight);
                    }

                    //点击事件
                    $('.js_cpopon_chk').unbind('click');
                    $('.js_cpopon_chk').bind('click', function() {
                        $(this).siblings().find('a').removeClass('select');
                        $(this).find('a').addClass('select');
                        //更改代金券参数
                        var couponInfo = $(this).attr("data-coupon-info");
                        var couponExt = $(this).attr("data-coupon-ext");
                        var value = $(this).attr("data-voucher-value");
                        var leastPrice = $(this).attr("data-voucher-leastPrice");
                        var curIndex = $(".js_cpopon_chk").index(this);
                        if (couponExt && couponExt.length > 0) {
                            //TODO:更改代金券信息             
                            $(document).trigger('coupons_show',{"couponExt":couponExt,"couponInfo":couponInfo,"couponValue":value,"couponLp":leastPrice,"itemSource":currentDom});                
                        }
                        setTimeout(function() {
                            $('.js_g_pop_coupon').hide();
                            $('.m_layer_mask').hide();
                        }, 100);
                        return false;
                    });
                }
            }
        });
    }



    module.exports = {
        init: showCouponPacList
    };
});
