/**app个人中心页好友排名列表**/
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();

    //获取好友关系链请求
    function _getFirendsAjax(suCb, failCb) {
        var platform = utils.getPlatform();
        utils.getGtk(function(g_tk) {
            $.ajax({
                url: [normalizer('http://pay.video.qq.com/fcgi-bin/get_growth_rank?cmd=60540&star_index=0&need_friend_count=4&platform1='), platform, "&appver=", utils.getAppVersion(), "&low_login=1&otype=json&g_tk=", g_tk].join(''),
                dataType: "jsonp",
                success: function(json) {
                    if (json && json.result && json.result.code == 0) {
                        suCb && suCb(json);
                    } else {
                        failCb && failCb();
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    failCb && failCb();
                }
            });
        });
    }

    function _reqMyWorldRank() {
        var $defer = $.Deferred();

        $.ajax({
            url: normalizer('http://pay.video.qq.com/fcgi-bin/get_growth_rank?cmd=60542&low_login=1&otype=json'),
            dataType: 'jsonp',
            data: {
                platform1: utils.getPlatform()
            }
        }).done(function(res) {
            if (res && res.result && res.result.code == 0) {
                $defer.resolve(res.my_world_rank);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });

        return $defer.promise();
    }

    function getMyWorldRank() {
        _reqMyWorldRank().done(function(rank) {
            $('.js_world_rank').text(rank);
        });
    }

    function showFriendsVip() {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽个人资产通栏
                $('.js_growth_section').hide();
            } else {
                showFriendsVipCb();
                getMyWorldRank();
            }
        });
    }
    //显示好友关系链
    function showFriendsVipCb() {
        utils.isAccountLogin(function() {
            _getFirendsAjax(function(json_friends) {
                if (json_friends.my_friend_rank) {
                    $('.js_friends_rank').text(json_friends.my_friend_rank);
                    $('.js_friends_txt').show();
                } else {
                    $('.js_friends_txt').hide();
                }
                var firends = json_friends.friend_item;
                var firendsFilter = firends.filter(function(item) {
                    return item.user_identity != 2;
                }).slice(0, 3);
                if (firendsFilter.length > 0) {
                    $('.js_friends_count').text(json_friends.friend_count);
                    var list_tpl = "";
                    for (var i = 0; i < firendsFilter.length; i++) {
                        var item = firendsFilter[i];
                        /*if (item.user_identity==2) {//将自己排除
                            continue;
                        }*/
                        var faceUrl = "";
                        if (item.face_url && item.face_url.length > 0) {
                            faceUrl = normalizer(item.face_url);
                        } else {
                            faceUrl = "style/app_v/img/user/default_160.png";
                        }
                        list_tpl += '<li><img src="' + faceUrl + '" alt=" "></li>';
                    }
                    if (list_tpl.length > 0) {
                        $('.js_friends_list').html(list_tpl);
                        $('.js_friends_section').show();
                    }
                } else {
                    $('.js_friends_section').hide();
                }
            }, function() {
                $('.js_friends_section').hide();
            });
        });
    }

    //隐藏好友关系链
    function hideFriendsLink() {
        $('.js_friends_section').hide();
    }

    module.exports = {
        init: showFriendsVip,
        hideFriends: hideFriendsLink
    };
});
