/*
个人中心首页头图展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage;
    var utils = require('../utils');
    var reportConf = require('./report/report_conf').hottagConf;
    var normalizer = require('./urlFactory').createNormalizer();
    var ptagBuilder = require('./ptagBuilder');

    function initHeadPic() {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽头图
                $('.js_mod_tips_link').hide();
            } else {
                initHeadPicCalbck();
            }
        });
    }

    function initHeadPicCalbck() {
        if (storage.getItem("app_hlw_user_headpic_new")) {
            var headpic = JSON.parse(storage.getItem("app_hlw_user_headpic_new"));
            if (headpic.length > 0) {
                buildHeadPic(headpic);
            }
        }
        getHeadPic(function(json) {
            if (json.items.length > 0) {
                buildHeadPic(json.items);
                storage.setItem("app_hlw_user_headpic_new", JSON.stringify(json.items));
            } else {
                if (storage.getItem("app_hlw_user_headpic_new")) {
                    storage.removeItem("app_hlw_user_headpic_new");
                }
            }
        }, function() {
            $('.js_mod_tips_link').hide();
        });
    }

    function getHeadPic(suCb, failCb) {
        $.ajax({
            url: normalizer('http://mobile.video.qq.com/fcgi-bin/dout_iphone?otype=json&auto_id=1317&platform=7&version=0'),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);

                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function _getPtagAdd() {
         var ptagAdd = "ad.kttop.apho";
         if (utils.isIosPf()) {
            ptagAdd = "ad.kttop.ipho";
         }
         return ptagAdd;
    }

    function buildHeadPic(items) {
        var aid = utils.getUrlParam('aid') || '';
        aid = decodeURIComponent(aid);
        var hotTagPre = reportConf.headpic;
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            if (item.condition == '' || aid.indexOf(item.condition) >= 0) {
                var url  = ptagBuilder.addPtag(item.url,_getPtagAdd());
                $('.js_head_pic').attr('src', normalizer(item.icon_url));
                $('.js_tips_txt').text(item.banner_txt);
                $('.js_tips_link').attr('data-url', normalizer(url));
                $('.js_tips_link').attr('hottag', hotTagPre+"_"+_getPtagAdd());
                $('.js_tips_link').attr('f_resource', item.banner_txt);
                var ptag = utils.getUrlParam2(url,'ptag');
                if (ptag) {
                    $('.js_tips_link').attr('f_pagetag', ptag);
                }               
                $('.js_mod_tips_link').show();
                break;
            }
        };
    }

    exports.init = initHeadPic;
});
