/**app个人这中心页热点问题列表**/
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();
    var storage = window.localStorage;

    //热门问题创建
    function getHotList() {
        var hotListInfo = null;
        if (storage.getItem('vip_hotList')) {
            hotListInfo = JSON.parse(storage.getItem('vip_hotList'));
            if (hotListInfo.ret == 0) {
                _createHotList(hotListInfo);
            }
        }
        $.ajax({
            url: normalizer('http://pay.video.qq.com/fcgi-bin/help?otype=json'),
            dataType: 'jsonp',
            success: function(json) {
                var newJson = JSON.stringify(json);
                if (newJson != storage.getItem('vip_hotList') && newJson != null) {
                    storage.setItem('vip_hotList', newJson);
                    _createHotList(json);
                }
            },
            error: function(err) {

            }
        });
    }

    function _createHotList(json) {
        var problems = json.list;
        var hotList = $('.js_help_list');
        var proList = '';
        var itemCount = 0;
        for (var i = 0; i < problems.length; i++) {
            var hotTag = "";
            var item = problems[i];
            if (utils.isIosPf() && item.platformname == 'iOS' && itemCount<3) {
                itemCount+=1;
                hotTag = ["hlw_app_problem_",item.id].join('');
                proList += '<li class="item"><a href="javascript:;" data-url="https://kf.qq.com/touch/sappfaq/' + item.id + '.html" hottag="'+hotTag+'"><p class="txt">' + item.title + '</p></a></li>'
            } else if (utils.isAndroidPf() && item.platformname == 'Android'&& itemCount<3) {
                itemCount+=1;
                hotTag = ["hlw_app_problem_",item.id].join('');
                proList += '<li class="item"><a href="javascript:;" data-url="https://kf.qq.com/touch/sappfaq/' + item.id + '.html" hottag="'+hotTag+'"><p class="txt">' + item.title + '</p></a></li>'
            }
        }
        hotList.html(proList);
    }

    exports.init = getHotList;
});
