/**ios 代充**/
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();

    var appVersion = utils.getAppVersion();

    function _getWhiteList(sucb) {
        var d_deviceInfo = $.Deferred();
        var d_accountLogin = $.Deferred();

        $.when(d_deviceInfo, d_accountLogin).done(function(guid, isLogin) {
            _getWhiteListAjax(guid, isLogin).done(function(json) {
                sucb && sucb(json);
            });
        });
        utils.getDeviceInfo(function(json) {
            var guid = json.guid;
            d_deviceInfo.resolve(guid);
        }, function() {
            d_deviceInfo.resolve("");
        });

        utils.isAccountLogin(function() {
            d_accountLogin.resolve(true);
        }, function() {
            d_accountLogin.resolve(false);
        });
    }

    function _getWhiteListAjax(guid, isLogin) {
        var platform = utils.getPlatform();
        var name = "white_list2";
        if (isLogin) {
            name = "white_list";
        }
        var url = [normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name='), name, "&cmd=1&rule=instead_ios&otyps=json&app_ver=", appVersion, "&platform=", platform].join('');
        if (guid) {
            url = [url, "&dev_guid=", guid].join('');
        }
        var $defer = $.Deferred();
        $.ajax({
                url: url,
                dataType: 'jsonp'
            })
            .done(function(json) {
                if (json && json.ret == 0) {
                    $defer.resolve(json);
                } else {
                    $defer.reject();
                }
            })
            .fail(function() {
                $defer.reject();
            });
        return $defer.promise();
    }

    function _initEntranceShow() {
        $('.js_package_svip').hide();

        $(document).undelegate(".js_svip_pay", "tap").delegate('.js_svip_pay', 'tap', function(event) {
            var param = {
                month: $(this).attr('data-amount'),
                id: $(this).attr('data-id')
            };
            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        });

    }

    function initIosSvipPay() {
        var isIos = utils.isIosPf();
        if (isIos) {
            utils.getAppInfo(function(json_app) {
                if (json_app.isJBOS != 1) {
                    utils.getIapType(function(json_iap) {
                        if (json_iap.useh5 != 1) {
                            _getWhiteList(function(json) {
                                if (json.has_auth && json.has_auth == 1) {
                                    _initEntranceShow();
                                } else {
                                    $('.js_package_svip').hide();
                                }
                            });
                        }
                    }, function() {
                        $('.js_package_svip').hide();
                    });
                } else {
                    $('.js_package_svip').hide();
                }
            }, function() {
                $('.js_package_svip').hide();
            });
        }
    }

    function logoutClear() {
        $('.js_package_svip').hide();
    }


    module.exports = {
        init: initIosSvipPay,
        logoutClear: logoutClear
    };
});
