/**站内信**/
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();
    var appVersion = utils.getAppVersion();
    var MESSAGE_DETAIL_URL = normalizer('http://film.qq.com/weixin/h5/vip_messages/message.html');

    function _getUnreadMsgNum() {
        var url = normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name=webmsg&cmd=17&otype=json');
        var $defer = $.Deferred();
        $.ajax({
                url: url,
                dataType: 'jsonp'
            })
            .done(function(json) {
                if (json && json.ret == 0) {
                    $defer.resolve(json.count);
                } else {
                    $defer.reject();
                }
            })
            .fail(function() {
                $defer.reject();
            });
        return $defer.promise();
    }

    function _showMessageBar() {
        _getUnreadMsgNum().done(function(unReadNum) {
            unReadNum = unReadNum ? unReadNum : 0;
            var param = {};
            param.unReadNum = unReadNum;
            param.url = MESSAGE_DETAIL_URL;
            param.show = 1;
            utils.showMessageButton(param);
        });
    }

    function _initEntranceShow(vip_json) {
        utils.isAccountLogin(function() { //登录显示站内信入口
            if (utils.isAndroidPf()) {
                _showMessageBar();
            } else if (utils.isIosPf()) {
                if (vip_json && vip_json.visitor && vip_json.visitor.vip == 1) {
                    //游客会员不展示
                } else {
                    _showMessageBar();
                }
            }
        });
    }

    function initMessageEntrance(vip_json) {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，不请求站内信接口
                //do nothing
            } else {
                _initEntranceShow(vip_json);
            }
        });
    }

    function hideMessageEntrance() {
        var param = { "show": 0 };
        utils.showMessageButton(param);
    }

    module.exports = {
        init: initMessageEntrance,
        hide: hideMessageEntrance
    };
});
