define(function (require, exports, module) {
	var ua = navigator.userAgent;
	var isIos = ua.indexOf("iPhone") > -1 ? true : false;
    var isAndroid = ua.indexOf("Android") > -1 ? true : false;
	var normalizer = require('./urlFactory').createNormalizer();
	var newPriv = {};
    var reportConf = require('./report/report_conf').hottagConf;

	newPriv.init = function(){

		buildNav();
	}

	var defaultPriv = [
		{"classify":"内容特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571499_1.jpg","platform":"","title":"院线新片","titleid":"80404"},
		{"classify":"内容特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571503_1.jpg","platform":"","title":"独家美剧","titleid":"80405"},
		{"classify":"内容特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571572_1.jpg","platform":"","title":"全球纪录片","titleid":"80406"},
		{"classify":"内容特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571547_1.jpg","platform":"","title":"热剧看全集","titleid":"80407"},
		{"classify":"内容特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571544_1.jpg","platform":"","title":"赠观影券","titleid":"80408"},
		{"classify":"观影特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571507_1.jpg","platform":"","title":"免广告","titleid":"80409"},
		{"classify":"观影特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571541_1.jpg","platform":"","title":"1080P画质","titleid":"80410"},
		{"classify":"观影特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571563_1.jpg","platform":"","title":"尊贵身份","titleid":"80411"},
		{"classify":"观影特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571556_1.jpg","platform":"","title":"赠送影片","titleid":"80412"},
		{"classify":"直播特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571560_1.jpg","platform":"","title":"演唱会道具","titleid":"80413"},
		{"classify":"直播特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160527/i1464335037_1.jpg","platform":"android","title":"直播折扣","titleid":"80416"},
		{"classify":"下载特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571550_1.jpg","platform":"","title":"极速缓存","titleid":"80414"},
		{"classify":"下载特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571581_1.jpg","platform":"","title":"边下边播","titleid":"80415"},
		{"classify":"游戏特权","hottag":"priv_detail","pic":"https://i.gtimg.cn/qqlive/images/20160425/i1461571575_1.jpg","platform":"android","title":"游戏礼包","titleid":"80466"}
	];

	function buildNav(){
		$.ajax({
            url: normalizer('http://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=2358&otype=json'),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {

                	var newPriv = filtPriv(json.privs);

                	initPriv(newPriv);

                } else {
                    var newPriv = filtPriv(defaultPriv);

               		initPriv(newPriv);
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                var newPriv = filtPriv(defaultPriv);

                initPriv(newPriv);
            }
        });
	}


	function filtPriv(priv){
		var newPriv = [];

    	for(var i = 0; i < priv.length; i ++){
    		if(priv[i].pic !== "" && priv[i].title !== ""){

    			if(!isAndroid && priv[i].platform == "android"){
					continue;
    			}

    			newPriv.push(priv[i]);
    		}
    	}

    	return newPriv;
	}


	function buildLi(data) {
        var li = '';

        li += '<li class="item">';
        li += '<a href="javascript:void(0);" data-url="https://film.qq.com/weixin/user_privilege.html?fromapp=1&title=' + encodeURIComponent(data.title) + '" class="a_item" hottag="' + reportConf.priv_detail + '" f_resource="'+data.title+'">';
        //li += '<span class="icon_privilege" style="background-image:url(' + data.pic + ');background-size: 40px;"></span>';
        li+= '<img class="pic" src="'+normalizer(data.pic)+'" alt=" ">';
        li += '<p class="name">' + data.title + '</p>';
        li += '</a>';
        li += '</li>';

        return li;
    }



	function initPriv(priv) {

        var count = priv.length;
        var firstcount = Math.round(count / 2);

        var html = '<ul class="privilege_list">';

        for (var i = 0; i < firstcount; i++) {
            html += buildLi(priv[i]);
        }

        html += '</ul><ul class="privilege_list">';

        for (i = firstcount; i < count; i++) {
            html += buildLi(priv[i]);
        }

        html += '</ul>';
        $(".privilege_slide_inner").html(html);
    }

	module.exports = newPriv;
});
