// 付费来源统计report api
define(function (require,exports,module) {

	var ua = navigator.userAgent;
	var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var appVersion = getAppVersion();

	var reportCgi = 'https://btrace.qq.com/collect',
		reportAction,
		reportPv,
		defaultPageType = 5,
		PAGE_TYPE = {
			web: 1,      // web
			bp: 2,   // 客户端
			act: 3,   // 活动 （活动统一先报到web）
			wx: 4,    // 微信
			app: 5,
			tv: 6
		};

	function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }

            }
        }
        return versionCode;
    }


	function factory (paramsStr, defaultParams, seq) {
		var reportParams = {};

		$.each(paramsStr.split(' '), function (idx, val) {
			reportParams[val] = '';
		});
		$.extend(reportParams, defaultParams);
		return function (param) {
			var defer = $.Deferred();
			var params = $.extend({}, reportParams, param);
			var img = new Image();
			var data = [];
			var e = encodeURIComponent;

			$.each(params, function (key, val) {
				data[seq[key]] = e(key) + '=' + e(val);
			});

			data.push('rand=' + Math.random());

			img.src = reportCgi + '?' + data.join('&');

			img.onload = function () {
				defer.resolve();
			};

			img.onerror = function () {
				defer.reject();
			};

			return defer.promise();
		};
	}

	function getPlatForm() {
		var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        return platform;
	}

	//新版aid上报规则
	var actionSeq2 = {
		sIp: 0,
		iQQ: 1,
		sBiz: 2,
		sOp: 3,
		iSta: 4,
		iTy: 5,
		iFlow: 6,
		sUrl: 7,
		sRef: 8,
		iPageid: 9,
		cid: 10,
		vid: 11,
		channel: 12,
		platform: 13,
		version: 14,
		source1: 15,
		pid: 16,
		source2: 17,
		typeid: 18,
		listid: 19,
		aid_version: 20,
		mid: 21,
		scene: 22,
		pr: 23
	};

	reportAction2 = factory('sIp iQQ sBiz sOp iSta iTy iFlow sUrl sRef iPageid cid vid channel platform version source1 pid source2 typeid listid aid_version mid scene pr', {
		iTy: 2928,
		sUrl: location.href,
		sRef: document.referrer,
		iPageid: defaultPageType,
		platform : getPlatForm(),
		version : getAppVersion()
	}, actionSeq2);


	module.exports = {
		report_action: reportAction2,
	};
});
