define(function (require, exports, module) {
    /*
    var login = F.login,
        $ = jQuery;
    */
    var LEVELS_MAP = [0, 600, 1800, 3600, 6000, 10800,32400];
    var TICKETS = [2, 2, 4, 4, 5, 5, 6];

    function PayVip (data) {
        this.data = data || {};
    }

    PayVip.prototype = {
        isVip: function () {
            return !!this.data.vip;
        },

        isYear: function () {
            // 年费VIP的判定：先判断是否vip，再判断是否年费
            return this.isVip() && !!this.data.annualvip;
        },

        prevScore: function () {
            if (this.isMax()) {
                return LEVELS_MAP.slice(-2,-1) || 0;
            }
            return LEVELS_MAP[this.level() - 1] || 0;
        },

        score: function () {
            return this.data.score;
        },

        level: function () {
            return this.data.level;
        },

        nextScore: function () {
            // if (!this.isVip()) {
            //     return 0;
            // }
            if(this.level() >=LEVELS_MAP.length) {
                return LEVELS_MAP[this.level()-1] || Infinity;
            }
            if (this.level() == 0) {
                return LEVELS_MAP[this.level()+1] || Infinity;
            }
            return LEVELS_MAP[this.level()] || Infinity;
        },

        ratio: function (type) {
            type = type || 'update';

            if (type === 'total') {
                return Math.min(this.score() / _.last(LEVELS_MAP), 1);
            } else {
                var prev = this.prevScore();

                return Math.min((this.score() - prev) / (this.nextScore() - prev) , 1);
            }
        },

        percent: function (type) {
            return this.ratio(type) * 100 + '%';
        },
        /*
        nick: function () {
            return login.getNick();
        },

        avatar: function (size) {
            size = size || 100;
            return login.getAvatar(size);
        },
        */
        toYear: function () {
            return Math.max(Math.ceil(this.data.annualneedtime / (3600 * 24 * 31)), 1);
        },

        toSmartYear: function () {
            var month = this.toYear();

            if (month === 2 || month === 3) {
                return 3;
            }

            if (month >= 8) {
                return 12;
            }

            return month;
        },

        levelUp: function (format) {
            format = format || 'days';
            var up = this.data.dailyscore,
                leftDays = Math.ceil((this.nextScore() - this.score()) / up);

            return levelChange(leftDays, format);
        },

        degrade: function (format) {
            format = format || 'days';

            // this.prevScore() 返回的是该等级的临界积分，实际上并未降级，所以prevScore应该再减一
            var prev = this.prevScore() - 1;
            var leftDays = Math.ceil((this.score() - prev) / Math.abs(this.data.dailyscore));

            return levelChange(leftDays, format);
        },

        inRange: function () {
            return this.score() <= _.last(LEVELS_MAP);
        },

        isMax: function () {
            return this.level() === LEVELS_MAP.length;
        },

        maxLevel: function () {
            return LEVELS_MAP.length;
        },

        tickets: function () {
            var v = this.level();
            return TICKETS[v - 1];
        }
    };

    function levelChange (leftDays, format) {
        if (format === 'days') {
            return leftDays;
        }

        var date = new Date();
        date.setDate(date.getDate() + leftDays);

        return _.dateFormat(date, format);
    }

    var exps = function (data) {
        var defer = $.Deferred();

        if (data) {
            defer.resolve(new Vip(data));
        } else {
            seajs.use('hw.request', function (req) {
                req.vip().done(function (data) {
                    if (data.result.code === 0) {
                        defer.resolve(new Vip(data));
                    } else {
                        defer.reject(data);
                    }
                }).fail(function () {
                    defer.reject();
                });
            });
        }

        return defer;
    };

    module.exports = PayVip;//exps;
});