/*
 *@author   kellyqchen
 *@date     2016/10/24
 */
define(function(require, exports, module) {
    'use strict';
    var utils = require('../utils');

    function _updateQueryStringParameter(uri, key, value) {
        var re = new RegExp("([?&])" + key + "=.*?(&|#|$)", "i");
        if (uri.match(re)) {
            return uri.replace(re, '$1' + key + "=" + value + '$2');
        } else {
            var hash = '';
            if (uri.indexOf('#') !== -1) {
                hash = uri.replace(/.*#/, '#');
                uri = uri.replace(/#.*/, '');
            }
            var separator = uri.indexOf('?') !== -1 ? "&" : "?";
            return uri + separator + key + "=" + value + hash;
        }

    }

    function addPtag(linkUrl,pf_tag) {
        var ptag = utils.getUrlParam('ptag');
        if (ptag) {
            return linkUrl;
        } else {
           return _updateQueryStringParameter(linkUrl, "ptag", pf_tag);
        }
    }
    module.exports = {
        addPtag: addPtag
    };
});
