define(function(require, exports, module) {
    var Boss = require('./Boss');
    var utils = require('../../utils');
    var aidUtil = require('./aid');

    var EVENT_CLICK = 'click',
        EVENT_EXPOSE = 'expose';

    var _ua = navigator.userAgent,
        _platform = utils.getPlatform(),
        _hasInit = false,
        _queue = [],
        _cfg= {};

    var url = location.pathname;
    var dm = "film.qq.com";//离线包用虚拟域名

    var _bossFactory = function(bossType) {
        bossType = bossType||"click";
        if ("expose" == bossType) {
            return new Boss({bossId:"3754",pwd:"598288292"});
        } else {
            return new Boss({bossId:"3753",pwd:"1449912345"});
        }
    }

    var _presetParams = {
        f_url: url,
        f_dm: dm,
        f_url_param: location.href.split('?')[1] ? decodeURIComponent(location.href.split('?')[1]).replace(/\$/g, '|||') : '',        
        _dc: Math.random(),
        f_pt: _platform,
        f_version: utils.getAppVersion(),
        f_platform:_getPlatformStr()
    }



    function _getPlatformStr() {
        if (utils.isAndroidPf()) {
            return "android.app";
        }
        return "ios.app";
    }

    function init(cfg,bossType) {
        bossType = bossType||"click";
        _hasInit = true;

        var d_mainCookie = $.Deferred();
        var d_appInfo = $.Deferred();
        $.when(d_mainCookie,d_appInfo).always(function(json_user,guid){
            if (json_user) {
                var uid = '';
                var appid = '';
                var cookieStr = json_user.cookie;
                if (json_user.type && json_user.type == 'wx') {
                    _presetParams.f_logintype = json_user.type;
                    uid = utils.getCookieParam(cookieStr, "openid");
                    appid = utils.getCookieParam(cookieStr, 'appid');
                    _presetParams.f_uid = uid;
                    _presetParams.f_appid = appid;
                } else if (json_user.type && json_user.type == 'qq') {
                    _presetParams.f_logintype = json_user.type;
                    uid = utils.getCookieParam(cookieStr, "uin");
                    _presetParams.f_uid = uid;
                }
            }
            if (guid) {
                _presetParams.hc_pvid = guid;
            }
            _initCb(cfg,bossType);
        });

        utils.getMainCookie(function(json_user) {
            d_mainCookie.resolve(json_user);
        }, function() {
            d_mainCookie.reject({});
        });

        utils.getDeviceInfo(function(json) {
            var guid = json.guid;
            d_appInfo.resolve(guid);
        }, function() {
            d_appInfo.reject("");
        });

    }

    function _initCb(cfg,bossType) {
        bossType = bossType||"click";
        //var aid = aidUtil.init(cfg.f_aid);
        var _boss = _bossFactory(bossType);
        _boss.report($.extend(cfg,_presetParams));
    }

    function report(params,bossType) {
        if (!_hasInit) {
            _queue.push(params);
            return
        }
        _bossFactory(bossType).report(params);
    }

    function click(params) {
        init($.extend(params,{f_event:EVENT_CLICK}),"click");
    }

    function expose(params) {
        init($.extend(params,{f_event:EVENT_EXPOSE}),"expose");
    }

    module.exports = {
        init:init,
        click:click,
        expose:expose
    };
});
