/*
个人中心发放观影tip展示
 */
define(function(require, exports, module) {
    var worldRank = require('./worldRank_tip'),
        normalizer = require('./urlFactory').createNormalizer();
    var tipsShowTid = 0;

    function _ticketUpAjax() {
        var $defer = $.Deferred();
        $.ajax({
                url: normalizer('http://pay.video.qq.com/fcgi-bin/update_info?info_type=ticket&otype=json'),
                dataType: 'jsonp'
            })
            .done(function(res) {
                if (res && res.result && res.result.code == 0) {
                    $defer.resolve(res.ticket);
                } else {
                    $defer.reject();
                }
            })
            .fail(function() {
                $defer.reject();
            });
        return $defer.promise();
    }

    function _ticketShowResetAjax() {
        var $defer = $.Deferred();
        $.ajax({
                url: normalizer('http://pay.video.qq.com/fcgi-bin/update_info?info_type=ticket&reset=1&otype=json'),
                dataType: 'jsonp'
            })
            .done(function(res) {
                if (res && res.result && res.result.code == 0) {
                    $defer.resolve(res);
                } else {
                    $defer.reject();
                }
            })
            .fail(function() {
                $defer.reject();
            });
        return $defer.promise();
    }

    function init() {
        _ticketUpAjax().done(function(ticket_res) {
            if (ticket_res.result && ticket_res.result && ticket_res.result.code == 0 && ticket_res.count) {
                $('.js_ticket_txt').text(ticket_res.count);
                $('.js_ticket_wrapper').css({ "opacity": "0" });
                $('.js_ticket_wrapper').show();
                setTimeout(function() {
                    $('.js_ticket_wrapper').css({ "opacity": "1", "transition": "opacity 2s linear;" });
                }, 0);
                if (tipsShowTid == 0) {
                    tipsShowTid = setTimeout(function() {
                        $('.js_ticket_wrapper').css({ "opacity": "1" });
                        setTimeout(function() {
                            $('.js_ticket_wrapper').css({ "opacity": "0", "transition": "opacity 1s linear;" });
                            //$('.js_ticket_wrapper').hide();
                        }, 0);
                    }, 5e3); //5后消失
                }
                //TODO::
                _ticketShowResetAjax().done(function(res) {});
            } else {
                $('.js_ticket_wrapper').hide();
                worldRank.init();
            }
        }).fail(function() {
            $('.js_ticket_wrapper').hide();
            worldRank.init();
        });
    }

    function clearTicketShow() {
        tipsShowTid = 0;
    }

    module.exports = {
        init: init,
        clearTicketShow: clearTicketShow
    }


});
