/*
 *@author   tonicli
 *@date     2016/11/14
 */
define(function(require, exports, module) {
'use strict';
var urlBuilder = require('./url');
var VIRTUAL_PROTOCOL = 'http://';
var domains = [
        /qq\.com$/,
        /qlogo\.cn$/,
        /gtimg\.com$/,
        /gtimg\.cn$/,
        /qpic\.cn$/,
        /sinaimg\.cn$/
    ],
    _ua = navigator.userAgent,
    _isAndroid = _ua.indexOf('Android') > -1;

function _canSkip(url) {
    var host = urlBuilder.getHost(url);

    return (domains.filter(function (v) {
            return v.test(host);
        }).length === 0);
}

module.exports = {
    createNormalizer: function () {
        return function (url, useRelative, protocol) {
            url = url.replace(/^\/\//, VIRTUAL_PROTOCOL);
            if (!/^(http:|https:)/.test(url) || _canSkip(url)) {
                return url;
            }
            return urlBuilder.normalize(url, _isAndroid ? 'http' : 'https');
        };
    }
};
});
