/*
个人中心首页头图展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage;
    var utils = require('../utils');
    var reportConf = require('./report/report_conf').hottagConf;
    var isAndroid = utils.isAndroidPf();
    var isIos = utils.isIosPf();
    var appVersion = utils.getAppVersion();
    var normalizer = require('./urlFactory').createNormalizer();

    //未登录时初始化活动列表
    function initActivityUnLogin() {
        utils.isAccountLogin(function() {
            //登录，do noting
        }, function() {
            initActivity(false);
        });
    }

    function initActivity(isVip) {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") {
                $('.js_vip_act_section').hide();
            } else {
                getActivityNew(function(json) {
                    var items = json.list;
                    storage.setItem("app_hlw_user_activity", JSON.stringify(items));
                    buidActivity2(items, isVip);
                }, function() {
                    if (storage.getItem("app_hlw_user_activity")) {
                        var items = JSON.parse(storage.getItem("app_hlw_user_activity"));
                        buidActivity2(items, isVip);
                    }
                });
            }
        });
    }

    function buidActivity2(items, isVip) {
        if (items.length > 0) {
            var list = '';
            var plat = 0;
            if (isIos) {
                plat = 1;
            } else if (isAndroid) {
                plat = 2;
            }
            var hotTagPre = reportConf.activity_detail;
            var itemCount = 0;
            var actArr = new Array();
            var isLaiseeTop = false; //红包是否已经是第一个活动
            for (var i = 0; i < items.length; i++) {
                var item = items[i];
                var hottag = hotTagPre;                
                actArr.push(item);
                var ptag = utils.getUrlParam2(item.h5_url,'ptag');
                list += ['<li class="item"><a href="javascript:;" data-url="', item.h5_url, '" class="figure" hottag="', hottag, '" f_resource="'+item.title+'" f_pagetag="'+ptag+'"><span class="figure_pic"><img src="', item.pic_1080x607, '" alt="', item.title, '"></span><span class="figure_title figure_title_multirow">', item.title, '</span><span class="figure_tips">', item.subtitle_text, '</span></a></li>'].join('');
                itemCount += 1;
                //判断红包活动是否放在第一位
                if (item.activityid == 9 /*&& item.h5_url.indexOf('hongbao') != -1*/ && itemCount == 1) {
                    isLaiseeTop = true;
                }
            }
            $('.js_mod_figures_slide').removeClass('mod_figures_slide_2li');
            $('.js_mod_figures_slide').removeClass('mod_figures_slide_1li');
            if (itemCount == 1) {
                $('.js_mod_figures_slide').addClass('mod_figures_slide_1li');
            } else if (itemCount == 2) {
                $('.js_mod_figures_slide').addClass('mod_figures_slide_2li');
            }

            /*判断是否需要红包置顶开始,且是VIP*/
            if (isVip) {
                if (isLaiseeTop) { //如果红包已经在排在第一个活动，无需再执行置顶逻辑
                    //DO NOTHING
                    $('.js_ads_list').html(list);
                    showActivitySlide(itemCount);
                } else {
                    chkLaiseeSatus(function(json) {
                        if (json.order_list && json.order_list.length == 1) { //应该仅返回一条红包记录
                            var laiss_status = json.order_list[0].fetch_result;
                            if (laiss_status == 0) { //有红包资格
                                var spotIndex = -1;
                                var has_hongbao_activity = false;
                                for (var i = 0; i < actArr.length; i++) {
                                    var actItem = actArr[i];
                                    if (actItem.activityid == 9 /*&& actItem.h5_url.indexOf('hongbao') != -1*/ ) { //表示红包活动
                                        has_hongbao_activity = true;
                                        spotIndex = i;
                                        break;
                                    }
                                }                                                        
                                if (has_hongbao_activity) {
                                    var delItem = actArr.splice(spotIndex, 1);
                                    delItem[0].subtitle_text = "您有一个新红包";
                                    actArr.unshift(delItem[0]);
                                }
                                //rebuild list
                                var listNew = "";
                                for (var k = 0; k < actArr.length; k++) {
                                    var actItemNew = actArr[k];
                                    var ptag = utils.getUrlParam2(actItemNew.h5_url,"ptag");
                                    listNew += ['<li class="item"><a href="javascript:;" data-url="', actItemNew.h5_url, '" class="figure" hottag="', hotTagPre, '" f_resource="'+actItemNew.title+'" f_ptag="'+ptag+'"><span class="figure_pic"><img src="', actItemNew.pic_1080x607, '" alt="', actItemNew.title, '"></span><span class="figure_title figure_title_multirow">', actItemNew.title, '</span><span class="figure_tips">', actItemNew.subtitle_text, '</span></a></li>'].join('');
                                }
                                if (listNew.length > 0) {
                                    $('.js_ads_list').html(listNew);
                                }
                            } else {
                                $('.js_ads_list').html(list);
                            }
                        } else {
                            $('.js_ads_list').html(list);
                        }
                        showActivitySlide(itemCount);
                    }, function() {
                        $('.js_ads_list').html(list);
                        showActivitySlide(itemCount);
                    });
                }
            } else {
                $('.js_ads_list').html(list);
                showActivitySlide(itemCount);
            }
            /*判断是否需要红包置顶结束*/
            if (itemCount > 0) {
                //app没有VIP俱乐部的版本隐藏
                if (isAndroid) {
                    if (utils.versionCompare(appVersion, "4.7.0")) {
                        $('.js_vip_club').show();
                    } else {
                        $('.js_vip_club').hide();
                    }
                } else if (isIos) {
                    if (utils.versionCompare(appVersion, "4.6.0")) {
                        $('.js_vip_club').show();
                    } else {
                        $('.js_vip_club').hide();
                    }
                }
            }
        }
    }

    function getActivityNew(suCb, failCb) {
        $.ajax({
            url: normalizer('http://activity.video.qq.com/fcgi-bin/activity_interface?i_type=111&otype=json&platform=') + utils.getPlatform(),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.ret == 0 && Array.isArray(json.list)) {
                    json.list = json.list.map(function (v) {
                        v.h5_url = normalizer(v.h5_url);
                        v.pic_1080x607 = normalizer(v.pic_1080x607);

                        return v;
                    });
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function showActivitySlide(itemCount) {
        if (itemCount > 0) {
            $('.js_vip_act_section').show();
            $('.js_mod_ads_title').show();
            $('.js_mod_ads_slide').show();
        }
    }

    //获取用户是否有红包资格,如果有红包资格，红包活动置顶
    function chkLaiseeSatus(suCb, failCb) {
        $.ajax({
            url: normalizer('http://pay.video.qq.com/fcgi-bin/laisee_orderlist?page_id=3&offset=0&count=1&otype=json'),
            dataType: "jsonp",
            success: function(json) {
                if (json.result && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }

            },
            error: function() {
                failCb && failCb();
            }
        });
    }

    module.exports = {
        init : initActivity,
        initActivityUnLogin : initActivityUnLogin
    }
});
