/*
个人中心广告位展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage;
    var utils = require('../utils');
    var normalizer = require('./urlFactory').createNormalizer();
    var ptagBuilder = require('./ptagBuilder');
    var reportConf = require('./report/report_conf').hottagConf;

    function initAd(cbk) {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽头图
                $('.js_package_ad').hide();
                cbk && cbk();
            } else {
                initAdCalbck(cbk);
            }
        });
    }

    function initAdCalbck(cbk) {
        _getAd().done(function(json) {
            if (json.items.length > 0) {
                _buildAd(json.items);
                cbk && cbk(true);//has ad
            } else {
                $('.js_package_ad').hide();
                cbk && cbk();
            }
        }).fail(function() {
            $('.js_package_ad').hide();
            cbk && cbk();
        });
    }

    function _getAd() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer("http://mobile.video.qq.com/fcgi-bin/dout_iphone?otype=json&auto_id=1319&platform=7&version=0"),
            dataType: "jsonp"
        }).done(function(json) {
            if (json && json.returncode == 0) {
                $defer.resolve(json);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function getParamValue(url, name) {
        var reg = new RegExp('(\\?|&)' + name + '=([^&?]*)', 'i');
        var arr = url.match(reg);
        if (arr) {
            return arr[2];
        }
        return null;
    }

    function _getPtagAdd() {
         var ptagAdd = "ad.kt.apho";
         if (utils.isIosPf()) {
            ptagAdd = "ad.kt.ipho";
         }
         return ptagAdd;
    }


    function _buildAd(items) {
        var plat = utils.getPlatform();
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            if (plat == item.condition) {
                var  link_url  = ptagBuilder.addPtag(item.link_url,_getPtagAdd());
                var reportTag = item.report_tag;
                var ptag = getParamValue(link_url,'ptag');
                var reportTag_click = reportTag;
                if (ptag) {
                    reportTag_click = [ptag, '.', reportTag].join('');
                    $('.js_package_ad').attr('f_pagetag', ptag);
                }
                $('.js_package_ad .js_title').text(item.title);
                if (item.sub_title) {
                    $('.js_package_ad .js_subTitle').text(item.sub_title);
                    $('.js_package_ad .js_subTitle_wrapper').show();
                } else {
                    $('.js_package_ad .js_subTitle_wrapper').hide();
                }
                $('.js_package_ad .js_btn_txt').text(item.btn_txt);
                $('.js_package_ad').attr('data-url', normalizer(link_url));
                $('.js_package_ad').attr('hottag', reportConf.openPay_tuiguang+'_'+reportTag_click);
                $('.js_package_ad').attr('f_resource', item.title);               
                $('.js_package_ad').show();
                break;
            }
        };
    }

    exports.init = initAd;
});
