/*
等级升级pop页面展示
 */
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();

    window.addEventListener('message', _receiveMessage, false);

    function _receiveMessage(e) {
        if (e.origin.indexOf("qq.com") != -1 && e.data == "vip_levelUp_close") {
            $('#levelUp_pop_iframe').remove();
        }
    }

    function _levelUpAjax() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer('http://pay.video.qq.com/fcgi-bin/get_levelupdate?otype=json'),
            dataType: 'jsonp'
        }).done(function(res) {
            if (res && res.result && res.result.code == 0) {
                $defer.resolve(res);
            } else {
                $defer.reject();
            }

        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function init(vip_json) {
        if (vip_json && vip_json.visitor && vip_json.visitor.vip == 1) { //游客会员不显示
            return false;
        }
        _levelUpAjax().done(function() {
            if ($("#levelUp_pop_iframe").length > 0) {
                return;
            }
            var tpl = '<iframe frameborder="0" id="levelUp_pop_iframe" allowtransparency="true" style="position: fixed;left: 0;top: 0;z-index: 99999;width: 100%;height: 100%;" src="' + normalizer('http://film.qq.com/weixin/user_share.html') + '" scrolling="no"></iframe>';
            $('body').append(tpl);
        });
    }

    module.exports = {
        init: function() {
            try {
                init();
            } catch (err) {}
        }
    }
});
