/*
个人中心首页头图展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage;
    var utils = require('../utils');
    var reportConf = require('./report/report_conf').hottagConf;
    var isAndroid = utils.isAndroidPf();
    var isIos = utils.isIosPf();
    var normalizer = require('./urlFactory').createNormalizer();

    function initMovies() {
        getMovies(function(json) {
            var items = json.movie;
            storage.setItem("app_hlw_user_movie", JSON.stringify(items));
            buidMovie(items);
        }, function() {
            if (storage.getItem("app_hlw_user_movie")) {
                var items = JSON.parse(storage.getItem("app_hlw_user_movie"));
                buidMovie(items);
            }
        });
    }

    function buidMovie(items) {
        if (items.length > 0) {
            var list = '';
            var hotTag = reportConf.vipMovie_detail;
            var itemLength = (items.length>3)?3:items.length;
            for (var i = 0; i < itemLength; i++) {
                var item = items[i];
                
                var url = ['tenvideo2://?action=1&cover_id=', item.cid, '&demandVersion=2.6.0'].join('');
                var cover_pic_url = utils.picSizeSet(item.pic,130);
                list += ['<li class="item"><a href="javascript:;" data-movie-url="', url, '" class="figure" hottag="', hotTag, '" f_cid="'+item.cid+'"><span class="figure_pic"><img src="', normalizer(cover_pic_url), '" alt="', item.title, '">', getIconTag(item.img_tag), '</span><span class="figure_title figure_title_multirow">', item.title, '</span></a></li>'].join('');
            };
            $('.js_movie_section .mod_figure').html(list);
            $('.js_movie_wrapper').show();

        }
    }

    function getIconTag(imgTagParam) {
        return utils.getCoverCorner(imgTagParam);
    }

    function getMovies(suCb, failCb) {
        $.ajax({
            url: normalizer('http://mobile.video.qq.com/fcgi-bin/dout_iphone?otype=json&auto_id=1321&platform=7&version=0'),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    module.exports = {
        init: initMovies
    }
});
