/**app个人中心页成长值进度**/
define(function(require, exports, module) {
    var utils = require('../utils');
    var PayVip = require('./payvip');

    //成长值提示
    var tips = ["年费会员15点/天↑", "月费会员10点/天↑", "每日签到5点", "观看影片15点", "开通6个月会员600点", "开通年费会员1800点", "绑手机号100点", "关注公众号100点", "赠送好友影片10点"];
    var tips_startIndex = 0;
    var tips_tid = 0; //成长值滚动tips记录定时器
    var growth_bar_tid = 0; //成长值增长动画定时器

    function initVipGrowthSection(json_vip) {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽个人资产通栏
                $('.js_growth_section').hide();
            } else {
                initVipGrowthSectionCb(json_vip);
            }
        });
    }

    //成长值进度模块
    function initVipGrowthSectionCb(json_vip) {
        utils.isAccountLogin(function() {
            var level = json_vip.level;
            var vip = new PayVip(json_vip);
            var maxLevel = vip.maxLevel();
            var isMax = vip.isMax();
            var scoreVal = json_vip.score > 0 ? json_vip.score : 0;
            //var preLevel = (json_vip.level - 1) > 0 ? (json_vip.level - 1) : 1;
            var nextLevel = (json_vip.level + 1) < 7 ? (json_vip.level + 1) : 7;
            var preScore = vip.prevScore();
            var nextScore = vip.nextScore();
            var preLevel = level;
            if (isMax) {
                preLevel -= 1;
            }
            $('.js_value_lt .tit').text("LV" + preLevel);
            $('.js_value_lt .txt').text(preScore);
            $('.js_value_rt .tit').text("LV" + nextLevel);
            $('.js_value_rt .txt').text(nextScore);
            $('.js_vip_score').text(scoreVal);
            var growthPercent = vip.percent();
            var growthRadio = new Number(vip.ratio()).toFixed(1);
            if (growthRadio > 0.5) {
                $('.js_lv_tips_slide').addClass('lv_tips_slide_lt');
            } else {
                $('.js_lv_tips_slide').removeClass('lv_tips_slide_lt');
            }
            if (json_vip.visitor && json_vip.visitor.vip == 1) { //游客会员

            } else if (json_vip.vip == 1) { //会员                
                $('.js_growth_section').show();
                _initGrowthTips(json_vip, isMax);

                if (growth_bar_tid) {} else {
                    $('.js_growth_bar').removeClass('ani_bar');
                    $('.js_growth_bar').width("0%");
                    growth_bar_tid = setTimeout(function() {
                        $(document).on("package_ready", function() {
                            $('.js_growth_bar').addClass('ani_bar');
                            $('.js_growth_bar').css({ "width": growthPercent});
                        });
                        setTimeout(function() { //如果没有接收到消息
                            var widthBar = $('.js_growth_bar').width();
                            if (widthBar == 0) {
                                $('.js_growth_bar').addClass('ani_bar');
                                $('.js_growth_bar').css({ "width": growthPercent});
                            }
                        }, 1500);
                    }, 0);
                }

            } else { //非会员或过期会员               
                if (json_vip.endTime && json_vip.endTime != "" && json_vip.score > 0) { //过期会员                  
                    $('.js_growth_section').show();
                    _initGrowthTips(json_vip);
                    if (growth_bar_tid) {} else {
                        $('.js_growth_bar').removeClass('ani_bar');
                        $('.js_growth_bar').width("100%");
                        var hasAnimate = false;
                        growth_bar_tid = setTimeout(function() {
                            $(document).on("package_ready", function() {
                                hasAnimate = true;
                                widthBar = $('.js_growth_bar').width();
                                $('.js_growth_bar').addClass('ani_bar');
                                $('.js_growth_bar').css({ "width": growthPercent});
                                //$('.js_growth_bar').css({ "width": growthPercent, "transition": "width .8s ease-in-out;" });
                            });
                            setTimeout(function() { //如果没有接收到消息
                                if (!hasAnimate) {
                                    $('.js_growth_bar').addClass('ani_bar');
                                   $('.js_growth_bar').css({ "width": growthPercent});
                                }
                            }, 1500);
                        }, 0);
                    }
                } else {
                    $('.js_growth_section').hide();
                }
            }
        });
    }

    function _initGrowthTips(json_vip, isMax) {
        if (json_vip.vip == 1) {
            $('.js_growth_tips').text("月费VIP10点/天");
            if (json_vip.annualvip == 1) {
                $('.js_growth_tips').text("年费VIP15点/天");
            }
            $('.js_trend.icon_demote_sm').css('display','none');
            $('.js_trend.icon_up_sm').css('display','inline-block'); //上升

            /*if (tips_tid) { //reinit 会起多个定时器
            } else {
                function _growthTipsSlide() {
                    tips_startIndex += 1;
                    if (tips_startIndex >= tips.length) {
                        tips_startIndex = 0;
                    }
                    $('.js_growth_tips').text(tips[tips_startIndex]);
                    setTimeout(_growthTipsSlide, 5000);
                }
                tips_tid = setTimeout(function() {
                    _growthTipsSlide();
                }, 5000);
            }*/
        } else {
            $('.js_trend.icon_up_sm').css('display','none');
            $('.js_trend.icon_demote_sm').css('display','inline-block'); //下降

            $('.js_growth_tips').text("会员过期，5点/天");
        }
    }

    function clearGrowthTimeout() {
        clearTimeout(tips_tid);
        tips_tid = 0;
        clearTimeout(growth_bar_tid);
        growth_bar_tid = 0;
    }

    function hideGrowthBar() {
        $('.js_growth_section').hide();
    }

    function clearLogout() {
        clearGrowthTimeout();
        //$('.js_growth_bar').width("0%");
        hideGrowthBar();

    }

    module.exports = {
        init: initVipGrowthSection,
        clearGrowthTimeout: clearGrowthTimeout,
        hideGrowthBar: hideGrowthBar,
        clearLogout: clearLogout
    };
});
