/**app个人中心页成长值进度**/
define(function(require, exports, module) {
    var utils = require('../utils');
    var propertyGrowTips = require('./ticketUp_tip');
    var worldRank = require('./worldRank_tip');
    var refreshLock = true;
    var reportConf = require('./report/report_conf').hottagConf;
    var normalizer = require('./urlFactory').createNormalizer();

    function getGiveMovieCount(suCb, failCb) {
        utils.getMainCookie(function(json_msg) {
            if (json_msg) {
                var str_cookie = json_msg.cookie;
                var uin = "";
                var skey = "";
                if (json_msg.type == 'qq') {
                    uin = utils.getUin(utils.getCookieParam(str_cookie, "uin"));
                    skey = utils.getCookieParam(str_cookie, "skey");
                }
                giveMovieAjax(uin, skey, function(json) {
                    suCb && suCb(json);
                }, function() {
                    failCb && failCb();
                });
            }
        }, function() {
            failCb && failCb();
        });
    }
    //获取增片资格
    function giveMovieAjax(uin, skey, suCb, failCb) {
        var url = [normalizer('http://pay.video.qq.com/fcgi-bin/give_movie?otype=json&_t=3&uin='), uin, '&g_tk=', utils.getToken(skey), "&psize=1&pnum=1"].join('');
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    //获取红包数目
    function giftAjax(suCb, failCb) {
        var url = normalizer("http://vip.video.qq.com/fcgi-bin/comm_cgi?name=richred2&cmd=5650&count=1&offset=1");
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.ret==0) {
                    suCb && suCb(json.totalNum);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }
    //获取活动奖品数目
    function awardsAjax(suCb, failCb) {
        var url = normalizer("http://activity.video.qq.com/fcgi-bin/asyn_activity?otype=json&type=27&option=3&act_id=1213");
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json.ret == 0) {
                    if (json.data && json.data.lottery_list) {
                        var totalCount = 0;
                        for (var i = 0;i<json.data.lottery_list.length;i++) {
                            var item = json.data.lottery_list[i];
                            if ("星星碎片"!=item.name) {
                                totalCount+=1;
                            }
                        }
                        suCb && suCb(totalCount);
                    } else {
                        suCb && suCb(0);
                    }                    
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }
    //获取资产合并请求接口:赠片，成长值，优惠券，观影券
    function getPropertyAjax(suCb, failCb) {
        //var url = ['https://pay.video.qq.com/fcgi-bin/vip_info_all?otype=json?g_tk=', utils.getToken(skey)].join('');
        var url = normalizer('http://pay.video.qq.com/fcgi-bin/vip_info_all?otype=json');
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function initUserRelateInfo(json_vip) {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽个人资产通栏
                $(".js_vip_info").hide();
                $('#user_relate_info').hide();
            } else {
                //游客会员按照分接口请求，合并接口不支持游客会员
                if (json_vip.visitor && json_vip.visitor.vip == 1) {
                    initVisitorRelateInfoCb(json_vip);
                } else { //使用合并接口请求
                    initUserRelateInfoCb(json_vip);
                }

            }
        });
    }

    function initUserRelateInfoCb(json_vip) {
        var showCount = 0;
        var isVip = false;
        var isVVip = false;
        var isVipNotUndefine = false;
        if (typeof json_vip != "undefined") {
            isVipNotUndefine = true;
            isVip = (json_vip.vip && json_vip.vip == 1);
        }
        var d_order = $.Deferred();
        var d_gift = $.Deferred();
        var d_property = $.Deferred();
        var d_awards = $.Deferred();
        var d_inreview = $.Deferred();
        $.when(d_order,d_gift, d_property,d_awards, d_inreview).done(function(json_order,json_gift, json_property, json_awrads,verType) {
            var mapInfo = {
                "showCount": 0,
                "showKey": ""
            };
            var json_ticket = "";
            var json_giveMovie = "";
            var json_coupon = "";
            if (json_property.user_ticket && json_property.user_ticket.result.code == 0) {
                json_ticket = json_property.user_ticket.vip_tt;
            }
            if (json_ticket && verType != "1") {
                if (json_ticket > 0) {
                    mapInfo.showCount += 1;
                    mapInfo.showKey = "ticket;";
                    mapInfo.ticket = json_ticket;
                } else {
                    if (isVip) { //观影券为零VIP显示
                        mapInfo.showCount += 1;
                        mapInfo.showKey = "ticket;";
                        mapInfo.ticket = 0;
                    }
                }

            }
            var totalOrder = json_order+json_gift;
            if (totalOrder > 0 && verType != "1") {
                mapInfo.showCount += 1;
                mapInfo.showKey += "order;";
                mapInfo.order = totalOrder;
            }

            if (isVipNotUndefine && json_vip.score >= 0 && verType != "1") {
                var score_num = json_vip.score
                if (score_num > 0) {
                    mapInfo.showCount += 1;
                    mapInfo.showKey += "score;";
                    mapInfo.score = score_num;
                } else {
                    if (isVip) { //成长值为零VIP显示
                        mapInfo.showCount += 1;
                        mapInfo.showKey += "score;";
                        mapInfo.score = 0;
                    }
                }
            }

            if (json_property.give_movie && json_property.give_movie.result.code == 0) {
                json_giveMovie = json_property.give_movie.leftnum;
            }
            if (json_giveMovie && verType != "1") {
                var leftNum = json_giveMovie;
                if (leftNum > 0) {
                    mapInfo.showCount += 1;
                    mapInfo.showKey += "giveMovie;";
                    mapInfo.giveMovie = leftNum;
                } else if (leftNum == 0) {
                    if (isVip) { //赠片记录为零VIP显示
                        mapInfo.showCount += 1;
                        mapInfo.showKey += "giveMovie;";
                        mapInfo.giveMovie = 0;
                    }
                }

            }

            if (json_property.vip_vouchers && json_property.vip_vouchers.result.code == 0) {
                json_coupon = json_property.vip_vouchers.total_effective_count;
            }
            if (json_coupon >= 0 && verType != "1") {
                var couponNum = json_coupon;
                if (couponNum >= 0) {
                    if (couponNum > 0) {
                        mapInfo.showCount += 1;
                        mapInfo.showKey += "coupon;";
                        mapInfo.coupon = couponNum;
                    } else {
                        // if (isVip) {
                        mapInfo.showCount += 1;
                        mapInfo.showKey += "coupon;";
                        mapInfo.coupon = 0;
                        // }
                    }
                }
            }

            if (json_awrads >= 0 && verType != "1") {
                mapInfo.showCount += 1;
                mapInfo.showKey = "awards";
                mapInfo.awards = json_awrads;
            }
            if (isVip) { //VIP
                bindUserRelateInfo(true, mapInfo, false);
                propertyGrowTips.init();
            } else { //非VIP
                if (isVipNotUndefine && json_vip.endTime == "") { //非VIP
                    bindUserRelateInfo(false, mapInfo, false);
                } else { //过期VIP
                    bindUserRelateInfo(false, mapInfo, false);
                }
                propertyGrowTips.init();
            }
        });

        utils.getOrderNumNetwork(function(json) {
            if (json != "") {
                if (json.total <= 0) {
                    d_order.resolve(0);
                } else {
                    d_order.resolve(json.total);
                }
            } else {
                d_order.resolve(0);
            }
        }, function() {
            d_order.resolve();
        });

        giftAjax(function(json) {
            d_gift.resolve(json);
        }, function() {
            d_gift.resolve();
        });
        getPropertyAjax(function(json) {
            d_property.resolve(json);
        }, function() {
            d_property.resolve();
        });
        awardsAjax(function(json) {
            if (json) {
                d_awards.resolve(json);
            } else {
                d_awards.resolve(0);
            }
        }, function() {
            d_awards.resolve();
        });
        utils.isInreviewVer(function(verType) {
            d_inreview.resolve(verType);
        });
    }



    function initVisitorRelateInfoCb(json_vip) {
        //游客没有赠片资格
        var showCount = 0;
        var isVip = false;
        var isVVip = false;
        var isVipNotUndefine = false;
        if (typeof json_vip != "undefined") {
            isVipNotUndefine = true;
            isVip = (json_vip.vip && json_vip.vip == 1);
            isVVip = (json_vip.visitor && json_vip.visitor.vip == 1);
        }
        var d_ticket = $.Deferred();
        var d_order = $.Deferred();
        var d_inreview = $.Deferred();
        $.when(d_ticket, d_order, d_inreview).done(function(json_ticket, json_order,verType) {
            var mapInfo = {
                "showCount": 0,
                "showKey": ""
            };
            if (json_ticket >= 0 && verType != "1") {
                if (json_ticket >= 0) {
                    mapInfo.showCount += 1;
                    mapInfo.showKey = "ticket;";
                    mapInfo.ticket = json_ticket;
                }
            }
            if (json_order > 0 && verType != "1") {
                mapInfo.showCount += 1;
                mapInfo.showKey += "order;";
                mapInfo.order = json_order;
            }

            if (isVVip) { //游客VIP
                bindUserRelateInfo(false, mapInfo, true);
            }
        });

        utils.getTicketNum(function(json) {
            d_ticket.resolve(json);
        }, function() {
            d_ticket.resolve();
        });

        utils.getOrderNum(function(json) {
            if (json != "") {
                if (json <= 0) {
                    d_order.resolve(0);
                } else {
                    d_order.resolve(json);
                }
            } else {
                d_order.resolve(0);
            }
        }, function() {
            d_order.resolve();
        });

        utils.isInreviewVer(function(verType) {
            d_inreview.resolve(verType);
        });
    }

    function bindUserRelateInfo(isVip, config, isVVip) {
        if (config.showCount == 1) {
            var rootContainer = $("#user_relate_info");
            rootContainer.removeClass();
            var hintMsg = "";
            var className = "pay_records js_vip_info_single";
            $("#user_relate_info").addClass(className);
            if (isVVip) {
                $("#user_relate_info .icon_arrow").hide();
            }
            if (config.order && config.order > 0) {
                hintMsg = "买赠纪录";
                rootContainer.addClass('js_order_item');
                rootContainer.attr("hottag", reportConf.userInfo_order);
                if (isVVip) {
                    hintMsg = "购买纪录";
                    $("#user_relate_info .js_user_info").text(config.order);
                }
            } else if (config.score && config.score > 0) {
                hintMsg = "VIP成长值";
                rootContainer.addClass('js_score_item');
                rootContainer.attr("hottag", reportConf.userInfo_score);
                if (isVVip) {
                    $("#user_relate_info .js_user_info").text(config.score);
                }
            } else if (config.ticket && config.ticket > 0) {
                hintMsg = "VIP观影券";
                rootContainer.addClass('js_ticket_item');
                rootContainer.attr("hottag", reportConf.userInfo_ticket);
                if (isVVip) {
                    $("#user_relate_info .js_user_info").text(config.ticket);
                }
            } else if (config.giveMovie != "undefined" && config.giveMovie > 0) {
                hintMsg = "赠片资格";
                rootContainer.addClass('js_giveMovie_item');
                rootContainer.attr("hottag", reportConf.userInfo_giveMovie);
                if (isVVip) {
                    $("#user_relate_info .js_user_info").hide();
                }
            } else if (config.coupon != "undefined" && config.coupon >= 0) {
                hintMsg = "优惠券";
                rootContainer.addClass('js_coupon_item');
                rootContainer.attr("hottag", reportConf.userInfo_coupon);
                if (isVVip) {
                    $("#user_relate_info .js_user_info").hide();
                }
            } else if (config.awards != "undefined" && config.awards > 0) {
                hintMsg = "活动奖品";
                rootContainer.addClass('js_awards_item');
                rootContainer.attr("hottag", reportConf.userInfo_awards);
                if (isVVip) {
                    $("#user_relate_info .js_user_info").hide();
                }
            } else {
                $(".js_vip_info").hide();
                rootContainer.hide();
                return;
            }
            $("#user_relate_info .txt_info").text(hintMsg);
            rootContainer.attr("f_resource", hintMsg);
            $(".js_vip_info").hide();
            rootContainer.show();
        } else if (config.showCount > 1) {
            $("#user_relate_info").hide();
            var vipInfoRoot = $(".js_user_info_list");
            vipInfoRoot.removeClass("info_list_2li");
            vipInfoRoot.removeClass("info_list_3li");
            vipInfoRoot.removeClass("info_list_4li");
            vipInfoRoot.removeClass("info_list_more");
            var showCount = config.showCount;
            if (typeof config.order != "undefined") {
                $(".user_order").text(config.order);
                $(".js_order_item .txt").text("买赠记录");
                $(".js_order_item").attr("f_resource","买赠记录");
                $(".js_order_item").show();
            } else {
                $(".js_order_item").hide();
            }
            if (typeof config.score != "undefined") {
                $(".user_score").text(config.score);
                $(".js_score_item").show();
            } else {
                $(".js_score_item").hide();
            }
            if (typeof config.ticket != "undefined") {
                $(".user_ticket").text(config.ticket);
                $(".js_ticket_item").show();
            } else {
                $(".js_ticket_item").hide();
            }
            if (typeof config.giveMovie != "undefined") {
                $(".user_give_movie").text(config.giveMovie);
                $(".js_giveMovie_item").show();
            } else {
                $(".js_giveMovie_item").hide();
            }
            if (typeof config.coupon != "undefined") {
                $(".user_coupon").text(config.coupon);
                $(".js_coupon_item").show();
            } else {
                $(".js_coupon_item").hide();
            }
            if (typeof config.awards != "undefined") {
                $(".user_awards").text(config.awards);
                $(".js_awards_item").show();
            } else {
                $(".js_awards_item").hide();
            }

            if (showCount == 2) {
                vipInfoRoot.addClass('info_list_2li');
            } else if (showCount == 3) {
                vipInfoRoot.addClass('info_list_3li');
            } else if (showCount == 4) {
                vipInfoRoot.addClass('info_list_4li');
            } else if (showCount >= 5) {
                vipInfoRoot.addClass('info_list_more');
            }
            $("#user_relate_info").hide();
            $(".js_vip_info").show();
        } else {
            $(".js_vip_info").hide();
            $('#user_relate_info').hide();
        }
    }

    function clearProperty() {
        //VIP会员资产通栏显示
        $(".js_vip_info").hide();
        $('.js_ticket_item .user_ticket').html("");
        $('.js_score_item .user_score').html("");
        $('.js_order_item .user_order').html("");
        $('.js_giveMovie_item .user_give_movie').html("");
        $('.js_coupon_item .user_coupon').html("");
        $('#user_relate_info').hide();
        $('.js_user_info').html("");
        worldRank.clearWorldRankStorage();
        propertyGrowTips.clearTicketShow();
    }

    module.exports = {
        init: initUserRelateInfo,
        clearProperty: clearProperty
    };
});
