define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var PayVip = require('./common/payvip');
    var lazyLoad = require('./common/lazyload');
    var utils = require('utils');
    //aid,上报相关
    var reportApi_new = require('./common/report/client');
    var reportConf_new = require('./common/report/report_conf');
    var reportConf_hottag = require('./common/report/report_conf').hottagConf;
    var aidReport = require('./common/report/aid').init();
    var normalizer = require('./common/urlFactory').createNormalizer();

    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var hasLoadMore = false;
    var totalPage = 0;
    var pageNum = 1;

    var appVersion = getAppVersion();
    var appVersionBuild = getAppVersionBuild();
    var g_isVipVisitor = getUrlParam('isVisitor') || false;
    var g_isVip = "no";
    var g_guid = "";
    var PAGE_SZIE = 10;
    var isVipReport = false;

    $(document).ready(function() {
        window.reload = function() {
            location.reload();
        };
        window.reinit = function() {};

        init();
        initReport();

        $(document).delegate("[data-tag=pick-movie]", "tap", function() {
            var hotTag = "vipMovie_more";
            initClickReport({f_hottag:hotTag});

            var url = "";
            url = ["tenvideo2://?action=3&channelId=100120&filter=channel_type",
                encodeURIComponent("="), "movie",
                encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
                encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "type", encodeURIComponent("="), "1"
            ].join('');
            if (isAndroid) {
                //url = "txvideo://v.qq.com/VideoListExhibitActivity?&channelId=100120&filter=channel_type%3Dmovie%26sort%3D2%26iarea%3D-1%26itype%3D3%26iyear%3D-1%26iattribute%3D-1&channelTitle=好莱坞&uiType=6";
                var channelTitle = "好莱坞";
                if (utils.versionCompare(appVersion, "4.8.5")) {
                    channelTitle = "VIP会员";
                }
                url = ["txvideo://v.qq.com/VideoListExhibitActivity?&channelId=100120&filter=channel_type",
                    encodeURIComponent("="), "movie",
                    encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
                    encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "type", encodeURIComponent("="), "1",
                    "&channelTitle=", channelTitle, "&uiType=6"
                ].join('');
            }
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openView', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
            return false;
        });


        $(".js_nonetwork").tap(function() {
            if ($(".js_nonetwork").is(":visible")) {
                pageNum = 1;
                init();
            }
        });

        $(document).delegate('[data-url]', 'tap', function() {
            var url = $(this).attr('data-url');
            var openLink = url;
            var checkupGrade = $(this).attr('data-checkup');
            if (checkupGrade != "4") {
                return false;
            }
            if (isAndroid) {
                openLink = ["txvideo://v.qq.com/Html5Activity?url=", encodeURIComponent(url)].join('');
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke('openView', {
                            url: openLink
                        }, function(json_msg) {});
                    } catch (err) {
                        location.href = url;
                    }
                }, 0);
            } else {
                openUrl(openLink, 0);
            }

            return false;
        });

        $(document).delegate('[data-tag=open-vip]', 'tap', function() {
            var hotTag = "openPay_hvipMonth";
            initClickReport({f_hottag:hotTag});

            if (getUrlParam('back')) {
                var url = 'tenvideo2://?action=20';
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("openView", {
                            url: url
                        }, function(json_msg) {});
                    } catch (err) {
                        location.href = url;
                    }
                }, 0);
            } else {
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("goBack");
                    } catch (err) {}
                }, 0);
            }
        });

        $('.js_renew').on('tap', function() {
            if (getUrlParam('back')) {
                var url = 'tenvideo2://?action=20';
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("openView", {
                            url: url
                        }, function(json_msg) {});
                    } catch (err) {
                        location.href = url;
                    }
                }, 0);
            } else {
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("goBack");
                    } catch (err) {}
                }, 0);
            }
        });

    });

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function initReport() {
        try {
            reportApi_new.expose({ f_aid: aidReport.replace(/\$/g, '|||'),f_hottag:"giveMovie_page"});
        } catch (err) {}
    }

    function initClickReport(params) {
        var hotTag = params.f_hottag || "";
        var isVip = 0;
        if (isVipReport) {
            isVip = 1;
        }
        var f_module = reportConf_new.getModule(hotTag);
        if (!params.f_aid) {
            params.f_aid = aidReport.replace(/\$/g, '|||');
        } else {
            params.f_aid = params.f_aid.replace(/\$/g, '|||');
        } 
        try {
            reportApi_new.click($.extend(params, { f_module: f_module, f_vip: isVip }));
        } catch (err) {}

    }

    function getDefaultAid() {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var aidDefault = ['V0$$1:0$2:', platform, '$3:', getAppVersion(), '$11:6'].join('');
        return aidDefault;
    }

    function init() {
        tenvideoReady(function() {
            appCallBack();
        });
    }

    function getGuid() {
        tenvideoReady(function() {
            getDeviceInfo(function(json) {
                g_guid = json.guid;
                storage.setItem("guid", json.guid);
            });
        });

    }

    function appCallBack() {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            var uid = "";
            if (json_msg.type == 'wx') {
                uid = getCookieParam(str_cookie, "openid");
            } else if (json_msg.type == 'qq') {
                uid = getCookieParam(str_cookie, "uin");
            }
            if (uid) {
                var giveMovieKey = ["givemovie_info_", uid].join('');
                if (storage.getItem(giveMovieKey)) {
                    fillGiveNumDom(JSON.parse(storage.getItem(giveMovieKey)));
                }
            }
        });
        giveNumShow();

        loadGiveMovieData();
        initLevel();
        showLoading(false);
    }

    // 赠片资格展示
    function giveNumShow() {
        var skey = '';
        var g_tk = '';
        isAccountLogin(function() {
            getMainCookie(function(json_user) {
                var cookieStr = json_user.cookie;
                var accountType = json_user.type;
                if (accountType == "qq") {
                    skey = getCookieParam(cookieStr, "skey");
                }
                g_tk = getToken(skey);
                getGiveNumData(g_tk, function(json) {
                    fillGiveNumDom(json);
                });
            });
        });
    }

    function fillGiveNumDom(json) {
        var giveNumItem = '';
        if (json.expire_info) {
            for (var i = 0, l = json.expire_info.length; i < l; i++) {
                giveNumItem += '<li class="list_item"><span class="txt">赠片资格<span class="time">' + json.expire_info[i].end_date + '</span>过期</span><span class="num">' + json.expire_info[i].count + '</span></li>';
            }
            if (giveNumItem != '') {
                $('.coupon_list').html(giveNumItem);
                $('.mod_coupon_no').hide();
            } else {
                $('.mod_coupon_no').show();
                $('.js_pick_movie_div').hide();
            }
        } else {
            $('.mod_coupon_no').show();
            $('.js_pick_movie_div').hide();
        }
    }

    // 获取赠片资格信息
    function getGiveNumData(g_tk, suCb, failCb) {
        $.ajax({
            url: normalizer("https://pay.video.qq.com/fcgi-bin/give_movie?otype=json"),
            data: {
                _t: 7,
                g_tk: g_tk
            },
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    getMainCookie(function(json_msg) {
                        var str_cookie = json_msg.cookie;
                        var uid = "";
                        if (json_msg.type == 'wx') {
                            uid = getCookieParam(str_cookie, "openid");
                        } else if (json_msg.type == 'qq') {
                            uid = getCookieParam(str_cookie, "uin");
                        }
                        if (uid) {
                            var key = ["givemovie_info_", uid].join('');
                            storage.setItem(key, JSON.stringify(json));
                        }
                    });
                    suCb && suCb(json);
                    showNetErr(false);
                } else {
                    if (json && json.result.code == -50001009 || json.result.code == -50001010) {
                        suCb && suCb(json);
                        showNetErr(false);
                    } else {
                        failCb && failCb();
                        showNetErr(true);
                    }
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
                showNetErr(true);
            }
        });
    }

    function initLevel() {
        getPayVip(function(json) {
            $(".js_rule_list li").removeClass('current');
            if (json.vip == 1) {
                var level = json.level;
                $([".js_rule_list .lv_", level].join('')).addClass('current');
                isVipReport = true;
            } else {
                $(".js_rule_list .lv_0").addClass('current');
                isVipReport = false;
            }
            if (json.vip == 1 && json.nextgivedate > 0) {
                var nextTime = new Date(json.nextgivedate * 1000);
                var nextTimeDate = nextTime.getFullYear() + '-' + pad(nextTime.getMonth() + 1) + '-' + pad(nextTime.getDate());
                $('.js_next_time .num').text(nextTimeDate);
                $('.js_next_time').show();
            }
        });
    }

    function loadGiveMovieData() {
        if ((pageNum > totalPage) && (pageNum != 1)) {
            return;
        }
        getGiveMovieRecord(pageNum, function(record_json) {
            var totalCount = record_json.total;
            if (totalCount == 0) {
                $('.js_give_movie_title').hide();
                return;
            }
            totalPage = (totalCount % PAGE_SZIE) == 0 ? (totalCount / PAGE_SZIE) : (Math.floor(totalCount / PAGE_SZIE) + 1);
            bindGiveRecord(record_json.record, record_json.vipid).then(function() {
                lazyLoad.reset();
                lazyLoad.init(["img"]);
                var imgElements = $("img");
                var len = imgElements.length;
                var $lastImg = imgElements[len - 1];
                var offset = $($lastImg).offset().top;
                if (!!hasLoadMore) {
                    lazyLoad.more.reset(offset);
                } else {
                    hasLoadMore = true;
                    lazyLoad.more.init(offset, function() {
                        pageNum++;
                        loadGiveMovieData();
                    });
                }
            });

        });
    }

    function getGiveMovieRecord(pnum, suCb, failCb) {
        getMainCookie(function(json_msg) {
            if (json_msg) {
                var str_cookie = json_msg.cookie;
                var uin = "";
                var skey = "";
                var uid = "";
                if (json_msg.type == 'wx') {
                    openid = getCookieParam(str_cookie, "openid");
                    appid = getCookieParam(str_cookie, "appid");
                    uid = openid;
                } else if (json_msg.type == 'qq') {
                    uin = getUin(getCookieParam(str_cookie, "uin"));
                    skey = getCookieParam(str_cookie, "skey");
                    uid = uin;
                }
                var key = ["hlw_give_movie_record_", uid].join('');
                var recordCache = "";
                if (storage.getItem(key) && pageNum == 1) {
                    recordCache = JSON.parse(storage.getItem(key));
                    suCb && suCb(recordCache);
                }
                giveMovieRecordAjax(uin, skey, pnum, function(json) {
                    if (pnum == 1) {
                        $('.js_mod_record_list').html("");
                        storage.setItem(key, JSON.stringify(json));
                    }
                    suCb && suCb(json);

                }, function() {
                    failCb && failCb();
                });
            }
        });
    }

    function bindGiveRecord(records, vipid) {
        var record_count = records.length;
        var $defer = $.Deferred();
        if (record_count == 0) {
            return $defer.reject();
        }
        return getIconTag2(records).then(function(data) {
            var imgTasArr = [];
            imgTagArr = data.map(function(element) {
                var imgTag = "";
                if (element.fields && element.fields.aphone40_imgtag) {
                    imgTag = element.fields.aphone40_imgtag
                }
                var tagTpl = '<span class="mark_flag special">\
                       <img src="{param2}" alt="{text}">\
                   </span>';
                return utils.getCoverCorner(imgTag, tagTpl);
            });
            _giveRecordRender(records, imgTagArr);
            
            return $defer.resolve();
        });
    }

    function _giveRecordRender(records, imgTagArr) {
        var tpl = "";
        for (var i = 0; i < records.length; i++) {
            var item = records[i];
            var url = [normalizer("https://film.qq.com/weixin/givemovie.html?cid="), item.cid, "&giveuin=", item.uin, "&taskid=", item.tid].join('');
            tpl += '<div class="record_list">';
            tpl += '<dl class="list_item cf" data-url="' + url + '" data-checkup="' + item.checkup + '">';
            tpl += '<dt>';
            tpl += '<span class="figure_pic">';
            tpl += '<span class="pic" style="background-image: url(' + normalizer(getPosterUrl(item.pic)) + ');"></span>';
            tpl += '<img style="display:none:;" src="" alt="">'; //加载需要         
            tpl += '</span>';
            tpl += '</dt>';
            tpl += '<dd>';
            tpl += '<p class="tit">' + item.title;
            if (imgTagArr && imgTagArr[i]) {
                tpl += imgTagArr[i];
            }            
            tpl += '</p>';
            tpl += '<p class="txt">已被' + item.takenum + '个好友领取</p>';
            if (item.checkup == "4") {
                tpl += '<i class="icon_arrow js_icon_arrow"></i>';
            }
            tpl += '</dd>';
            tpl += '</dl>';
            tpl += '</div>';
        }
        if (tpl.length > 0) {
            if (pageNum == 1) {
                $(".js_mod_record_list").html(tpl);
            } else {
                $(".js_mod_record_list").append(tpl);
            }
            $('.js_give_movie_title').show();
        }
        if (pageNum >= 1 && pageNum < totalPage) {
            $("#data_loading").show();
        } else {
            $("#data_loading").hide();
        }
    }

    //获取赠片记录
    function giveMovieRecordAjax(uin, skey, pnum, suCb, failCb) {
        var url = [normalizer('https://pay.video.qq.com/fcgi-bin/give_movie?otype=json&_t=3&uin='), uin, '&g_tk=', getToken(skey), "&psize=", PAGE_SZIE, "&pnum=", pnum].join('');
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json.result && json.result.code == 0) {
                    $("#data_loading").hide();
                    suCb && suCb(json);
                } else {
                    $("#data_loading .more_loading .txt").html("数据加载失败");
                    $("#data_loading").show();
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                $("#data_loading").hide();
                failCb && failCb();
            }
        });
    }




    function getPosterUrl(picUrl) {
        var suffixIndex = picUrl.lastIndexOf(".");
        if (suffixIndex != -1) {
            var picPrefix = picUrl.substring(0, suffixIndex);
            var picSurfix = picUrl.substring(suffixIndex);
            var newUrl = [picPrefix, "_e", picSurfix].join('');
            return newUrl;
        }
    }

    function getIconTag(info) {
        var tag = "";
        if (info.pay_status && info.pay_status != 0) {
            var status = info.pay_status;
            if (status == 5 || status == 6) {
                tag = '<sup class="mark_vip_free">会员</sup>';
            } else if (status == 4) {
                tag = '<sup class="mark_vip_coupon">用券</sup>';
            } else if (status == 7) {
                tag = '<sup class="mark_vip_coupon">付费</sup>';
            }
        }
        return tag;
    }

    function getIconTag2(info) {
        var $defer = $.Deferred();
        var idList = [];
        idList = info.map(function(element) {
            return element.cid;
        });
        if (idList.length > 0) {
            var idListStr = idList.join(',');
            $.ajax({
                url: normalizer("http://union.video.qq.com/fcgi-bin/data?tid=818&appid=10001006&appkey=fa6a9c72f0adb5f2&otype=json&idlist=") + idList,
                dataType: 'jsonp'
            }).done(function(res) {
                if (res && res.errorno == 0) {
                    $defer.resolve(res.results);
                } else {
                    $defer.reject(res);
                }
            }).fail(function(err) {
                $defer.reject(err);
            });
        } else {
            $defer.reject();
        }
        return $defer.promise();
    }

    function getStartDate(dateStr) {
        return dateStr.substr(0, 10);
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq", "wx"]
        }, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            //alert(JSON.stringify(json));
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }


    function getAppInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                storage.setItem("app_info_isjbos", json.result.isJBOS);
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }


    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function time33(skey) {
        // 哈希time33算法
        for (var i = 0, len = skey.length, hash = 5381; i < len; ++i) {
            hash += (hash << 5) + skey.charAt(i).charCodeAt();
        };
        return hash & 0x7fffffff;
    }

    function getToken(skey) {
        return time33(skey);
    }

    function openUrl(url, style) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", {
                    url: url,
                    style: style
                }, function(json_msg) {
                    //location.href = url;
                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function getAbsoluteUrl(url) {
        var div = document.createElement('div');
        div.innerHTML = ['<a href=', url, '></a>'].join('');
        return div.firstChild.href;
    }

    function showLoading(isShow) {
        if (isShow) {
            $('.g_container_loading').show();
            $('.js_giveMovie_container').hide();
        } else {
            $('.g_container_loading').hide();
            $('.js_giveMovie_container').show();
        }
    }

    // 日期左补0
    function pad(n) {
        return n < 10 ? '0' + n : n;
    }

    function showNetErr(isShow) {
        if (isShow) {
            $('.app_nonetwork').show();
            $('.app_container').hide();
        } else {
            $('.app_nonetwork').hide();
            $('.app_container').show();
        }
        $('.app_nonetwork').on('tap', function() {
            location.reload();
        });
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var ua = navigator.userAgent;
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }
            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = [normalizer("https://btrace.qq.com/collect?&sIp="),
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }

    function reportPay(payParam) {
        try {
            var accountType = "";
            var pay_uin = "";
            var openid = "";
            var appid = "";
            var type = 1;
            var step = 1;
            var days = payParam.month * 31;
            var ap = payParam.ap;
            var renew = 1;
            if (ap == 1) {
                renew = 3;
            }
            var payitem = "" + renew + "*" + days;

            getMainCookie(function(json_msg) {
                if (json_msg) {
                    var str_cookie = json_msg.cookie;
                    if (json_msg.type == 'wx') {
                        accountType = 2;
                        openid = getCookieParam(str_cookie, "openid");
                        appid = getCookieParam(str_cookie, "appid");
                    } else if (json_msg.type == 'qq') {
                        accountType = 1;
                        pay_uin = getCookieParam(str_cookie, "uin");
                    }
                    reportQA(pay_uin, openid, appid, type, accountType, payitem, step);
                }
            });
        } catch (ex) {}
    }

    function reportQA(pay_uin, openid, appid, type, accounttype, payitem, step) {
        var url = normalizer("https://pay.video.qq.com/fcgi-bin/payreport?otype=json");
        var guid = "";
        var plat = 7;
        var appBuildVerion = "";
        if (isAndroid) {
            plat = 8;
            appBuildVerion = getAppVersionBuild();
        }
        var reportCgi = [url,
            "&pay_uin=", getUin(pay_uin),
            "&openid=", openid,
            "&appid=", appid,
            "&type=", type,
            "&accounttype=", accounttype,
            "&payitem=", payitem,
            "&step=", step,
            "&plat=", plat,
            "&versioncode=", appBuildVerion
        ].join('');
        getDeviceInfo(function(json) {
            guid = json.guid;
            reportCgi = [reportCgi, "&guid=", guid].join('');
            reportQARequest(reportCgi);
        }, function() {
            reportQARequest(reportCgi);
        });
    }

    function reportQARequest(url) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {} else {}
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }

    function filterXSS(str) {
        return str.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\'/g, "&apos;");
    }

    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }

    function consolelog(txt) {
        var url = normalizer("https://film.qq.com/weixin/?log=") + txt;
        $.get(url);
    }
});
