define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var slide = require('./common/slide');
    var cookie = require('./common/cookie');
    //aid,上报相关
    var reportApi_new = require('./common/report/client');
    var reportConf_new = require('./common/report/report_conf');
    var reportConf_hottag = require('./common/report/report_conf').hottagConf;
    var aidApi = require('./common/report/aid');
    var aidReport = require('./common/report/aid').init();

    var bossReporter = require('./common/pay_report_api');
    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var isiPad = ua.indexOf("iPad") != -1 ? true : false;
    var appVersion = getAppVersion();

    var RetCode = require('./common/retcode');
    var utils = require('utils');
    var vip_priv = require('./common/new_priv');

    //头图展示
    var headPic = require('./common/headPic');
    //广告位展示
    var ads = require('./common/vipAd');
    //成长值进度
    var vipGrowth = require('./common/vip_growth');
    //vip资产信息
    var vipProperty = require('./common/vip_property');
    //好友排名
    var friendsRank = require('./common/friends_rank');
    //vip活动
    var vipActivity = require('./common/vipActivity');
    //vip大片
    var vipMovies = require('./common/vipMovies');
    //等级升级pop
    var vipLevelUpPop = require('./common/vipLevelUp_showOff.js');
    //显示代金券列表
    var couponListWin = require('./common/couponList');
    //ios代充
    var iosPaySvip = require('./common/ios_svip_pay');
    //站内信
    var message = require('./common/message');
    //未登录，非会员活动提示
    var act_tips_notvip = require('./common/act_tips_notvip');
    //tv svip入口展示
    var tv_svip = require('./common/tv_svip_entrance');
    var normalizer = require('./common/urlFactory').createNormalizer();
    var appVersionBuild = getAppVersionBuild();
    var qqUin = "";
    var qqSkey = "";
    var qqVipShiftInfo = "";
    var g_importFlag = false;
    var NETWOKR_ERR = "网络请求超时，请稍后重试";
    var g_isVisitorVip = false;
    var is1y15tClick = false;
    var isOverseas = "no";
    var pay_tag = "";
    var pay_sBIZ = "";
    var tap_package_count = 0;
    var isItemClick = false;
    var isVipReport = false;
    var g_hlw_param = "";
    var default_hlw_param = utils.getDefaultHlwParam();
    var g_pay_wx_offerId = "";
    var g_pay_qq_offerId = "";
    var wxOfferId = "1450002155";
    var qqOfferId = "1450005771";
    var g_mpid = ""; //ma
    var g_annual_productId = "";
    var g_annual_qqOfferid = "";
    var g_annual_wxOfferid = "";
    //代金券信息
    var g_coupons_ext = "";
    var g_coupons_info = "";
    var bindFlag = "0";
    var g_hasRenewReport = false; //标记管理自动续费是否上报，防止频繁刷新页面重复上报
    var g_isPayDialogOpen = false;
    var g_autoPayParam = 0;

    var package_discount = {
        "aphone_discount": [{
            "desc": "1个月20元",
            "month": "1",
            "id": "1100-1001",
            "code": "1100",
            "discount": "10",
            "package_price": "20"
        }, {
            "desc": "3个月45元(15元/月)",
            "month": "3",
            "id": "1100-1002",
            "code": "1100",
            "discount": "45",
            "package_price": "45"
        }, {
            "desc": "年费168元(14元/月)",
            "month": "12",
            "id": "1100-1003",
            "code": "1100",
            "discount": "192",
            "package_price": "168"
        }],
        "iphone_discount": [{
            "desc": "25元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "5",
            "package_price": "25"
        }, {
            "desc": "60元(20元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "30",
            "package_price": "60"
        }, {
            "desc": "198元(16.5元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "162",
            "package_price": "198"
        }],
        "iphone_discount_break": [{
            "desc": "20元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "10",
            "package_price": "20"
        }, {
            "desc": "45元(15元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "45",
            "package_price": "45"
        }, {
            "desc": "168元(14元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "192",
            "package_price": "168"
        }]
    };

    //新版aid上报字段映射
    var reportMap = {
        key1: 'channel',
        key2: 'platform',
        key3: 'version',
        key4: 'source1',
        key5: 'cid',
        key6: 'vid',
        key7: 'pid',
        key8: 'source2',
        key9: 'typeid',
        key10: 'listid',
        key11: 'scene',
        key12: 'pr' //未解析的ptag||referr
    };

    var useh5pay = false;
    var pay_type = "0";
    var g_isJBOS = false;
    var g_isDefaultPrice = false;

    //成长值提示
    var tips = ["年费会员15点/天；月费会员10点/天", "每日签到5点", "观看影片15点", "开通6个月会员600点", "开通年费会员1800点", "绑手机号100点", "关注公众号100点", "赠送好友影片10点"];
    var tips_startIndex = 0;
    var tips_tid = 0; //成长值滚动tips记录定时器
    var growth_bar_tid = 0; //成长值增长动画定时器
    $(document).ready(function() {
        if (isAndroid) {
            $('.js_aphone_show').show();
            $('.js_gamePri_link').show();
        }

        window.reinit = function(rtnSection) {
            log("reinit");
            //以下接口会刷新页面
            if ("getPayVip" == rtnSection) { //vip信息
                getPayVipRefresh();
            } else if ("getTicketNum" == rtnSection) { //券的信息
            } else if ("getOrderNum" == rtnSection) { //购买记录信息
            } else { //登录登出会全部刷新页面
                init();
            }

        };

        window.reload = function() {
            location.reload();
        };
        init();
        headPic.init();
        //ads.init();
        tv_svip.init();
        vipActivity.initActivityUnLogin();
        vipMovies.init();
        initOverseasTag();
        initAutoPayParam();
        initReport();
        initCDKshow();
        initQAshow();
        //特权配置
        vip_priv.init();
        //iap连续包月登录回调
        _iosSeiralPayLoginFinishCbk();



        //2s后强制显示界面
        setTimeout(function() {
            if ($('.g_container_loading').is(":visible")) {
                $('.app_container').show();
                $('.g_container_loading').hide();
            }
        }, 2000);


        $('.btn_login').tap(function() {
            TenvideoJSBridge.invoke("actionLogin", {
                "type": "tv" //get multi-account login entrance
            }, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {
                    //登录成功后会调用reinit
                    //init();
                }
            });
        });

        $('.jc_user_face').tap(function(e) {
            //阻止事件冒泡
            if ($(e.target).hasClass("js_open_renew")) {
                return false;
            }
            if (g_isVisitorVip) {
                return false;
            }
            var param = null;
            var hotTag = reportConf_hottag.userInfo_face_logout;
            initClickReport({ f_hottag: hotTag, f_resource: "头像" });
            if (isAndroid) {
                if (utils.versionCompare(appVersion, "4.3.1")) {
                    param = {
                        "needBack": false
                    };
                }
            } else if (isIos) {
                if (utils.versionCompare(appVersion, "4.2.5")) {
                    param = {
                        "needBack": false
                    };
                }
            }
            TenvideoJSBridge.invoke("logout", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {
                    logoutClear();
                } else {}
            });
        });

        $('#link_migrate_qq').tap(function() {
            TenvideoJSBridge.invoke("openMigrateVip", {
                "type": "qq"
            }, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        });

        $('#link_migrate_wx').tap(function() {
            TenvideoJSBridge.invoke("openMigrateVip", {
                "type": "wx"
            }, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        });

        $(document).delegate(".link_pay", "tap", function() {
            var code = '';
            var uin = "";
            if (isAndroid) {
                code = $(this).attr('data-code');
            }
            var hotTag = $(this).attr("hottag");
            var f_resource = $(this).attr("f_resource");
            var param = {
                month: $(this).attr('data-amount'),
                day: $(this).attr('data-amount'),
                id: $(this).attr('data-id'),
                product_price: $(this).attr('data-month-price'),
                product_single_price: $(this).attr('data-single-price'),
                code: code,
                product_type: $(this).attr('data-pay-type'),
                qq_offerid: $(this).attr('data-qq-offerid'),
                wx_offerid: $(this).attr('data-wx-offerid'),
                //代金券信息
                couponInfo: $(this).attr("data-coupon-info"),
                couponExt: $(this).attr("data-coupon-ext"),
                ios_pay_type: $(this).attr("data-ios-payType"), //表明是否是绕iap还是ios代充
                //hottag
                hottag: hotTag,
                f_resource: f_resource
            };

            if (storage.getItem("isOverseas")) {
                isOverseas = storage.getItem("isOverseas");
            }
            if (isOverseas == "yes") {
                pay_tag = "month";
                openPayOverseas(param);
                return;
            }

            //data report
            reportPay(param);
            pay_sBIZ = "package";
            bossReport();
            if (isIos) {
                if (useh5pay) {
                    isAccountLogin(function(json_login) {
                        goH5Pay(param);
                    }, function() {
                        TenvideoJSBridge.invoke("actionLogin", {
                            "type": "tv"
                        }, function(json_msg) {
                            log("actionLogin:" + json_msg);
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {}
                        });
                    });
                } else {
                    if (g_isJBOS) { //越狱手机走h5
                        isAccountLogin(function(json_login) {
                            goH5Pay(param);
                        }, function() {
                            TenvideoJSBridge.invoke("actionLogin", {
                                "type": "tv" //get multi-account login entrance
                            }, function(json_msg) {
                                var json = JSON.parse(json_msg);
                                if (json.errCode == 0) {}
                            });
                        });
                    } else {
                        param.aid = aidApi.init({ isPay: 1 });
                        //iap点击上报
                        if (param.hottag) {

                            initClickReport({ f_hottag: param.hottag, f_aid: param.aid, f_resource: f_resource });
                        }
                        if (param.product_type == "day") {
                            if (utils.versionCompare(appVersion, "4.5.1")) {
                                TenvideoJSBridge.invoke("openPayByDay", param, function(json_msg) {
                                    var json = JSON.parse(json_msg);
                                    if (json.errCode == 0) {} else {}
                                });
                            }
                        } else {
                            param.serialpay = 0;
                            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                                var json = JSON.parse(json_msg);
                                if (json.errCode == 0) {} else {}
                            });
                        }
                    }
                }

            } else {
                openPayAndroid(param);
            }
        });

        $(document).delegate(".js_link_payByDay", "tap", function() {
            var code = '';
            var uin = "";
            var param = {
                month: $(this).attr('data-amount'),
                day: $(this).attr('data-amount'),
                id: $(this).attr('data-id'),
                code: code
            };
            if (isIos) {
                param.product_type = $(this).attr('data-product-type');
            }
            if (isIos) {
                if (param.product_type == "day") {
                    if (utils.versionCompare(appVersion, "4.5.1")) {
                        TenvideoJSBridge.invoke("openPayByDay", param, function(json_msg) {
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {} else {}
                        });
                    }
                }
            }
        });


        $('.js_ticket_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                openUrl(["ticket.html?isVisitor=", isVisitor].join(''), 1, function() {
                    isItemClick = false;
                });
            }
        });
        $('.js_ticket_link').tap(function() {
            if ($(".js_vip_info").is(":visible")) {
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                openUrl(["ticket.html?isVisitor=", isVisitor].join(''), 1);
            }
        });

        $('.js_score_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                if (g_isVisitorVip) {
                    return false;
                }
                var scoreUrl = "https://film.qq.com/weixin/user_grade.html";
                openUrl(scoreUrl, 1, function() {
                    isItemClick = false;
                });
            }
        });

        $('.js_order_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                var isVisitor = false;
                var urlOrder = "https://film.qq.com/weixin/h5/gift/list.html";
                if (g_isVisitorVip) {
                    isVisitor = true;
                    urlOrder = ["order.html?isVisitor=", isVisitor].join('');
                }

                openUrl(urlOrder, 1, function() {
                    isItemClick = false;
                });
            }
        });
        $('.js_giveMovie_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                openUrl(["givemovie.html?isVisitor=", isVisitor].join(''), 1, function() {
                    isItemClick = false;
                });
            }
        });
        $('.js_giveMovie_link').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                openUrl(["givemovie.html?isVisitor=", isVisitor].join(''), 1, function() {
                    isItemClick = false;
                });
            }
        });
        $('.js_coupon_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                var couponList = "https://film.qq.com/weixin/v3/voucher/list.html";
                //var couponList = "https://film.qq.com/weixin/topic/vouchers.html";;
                openUrl(couponList, 1, function() {
                    isItemClick = false;
                });
            }
        });
        $('.js_awards_item').tap(function() {
            if ($(".js_vip_info").is(":visible") && !isItemClick) {
                isItemClick = true;
                var isVisitor = false;
                if (g_isVisitorVip) {
                    isVisitor = true;
                }
                var awardsList = "https://film.qq.com/weixin/4y/chunwan.html";
                openUrl(awardsList, 1, function() {
                    isItemClick = false;
                });
            }
        });

        $('.js_gamePri_link').tap(function() {
            if (isAndroid) {
                var url = 'http://iwan.qq.com/m/vadr/game_center.html?_bid=22';
                openUrl(url, 1);
            }
        });

        $('#user_relate_info').tap(function() {
            if ($("#user_relate_info").is(":visible")) {
                var className = $(this).attr("class");
                var isVisitor = false;
                if (className.indexOf("js_order_item") != -1) {
                    var urlOrder = "https://film.qq.com/weixin/h5/gift/list.html";
                    if (g_isVisitorVip) {
                        isVisitor = true;
                        urlOrder = ["order.html?isVisitor=", isVisitor].join('');
                    }
                    openUrl(urlOrder, 1);
                } else if (className.indexOf("js_score_item") != -1) {
                    if (g_isVisitorVip) {
                        return false;
                    }
                    var scoreUrl = "https://film.qq.com/weixin/user_grade.html";
                    openUrl(scoreUrl, 1, function() {
                        isItemClick = false;
                    });
                } else if (className.indexOf("js_ticket_item") != -1) {
                    if (g_isVisitorVip) {
                        isVisitor = true;
                    }
                    openUrl(["ticket.html?isVisitor=", isVisitor].join(''), 1);
                } else if (className.indexOf("js_giveMovie_item") != -1) {
                    if (g_isVisitorVip) {
                        isVisitor = true;
                    }
                    openUrl(["givemovie.html?isVisitor=", isVisitor].join(''), 1);
                } else if (className.indexOf("js_coupon_item") != -1) {
                    if (g_isVisitorVip) {
                        isVisitor = true;
                    }
                    var couponList = "https://film.qq.com/weixin/topic/vouchers.html";
                    openUrl(couponList, 1);
                } else if (className.indexOf("js_awards_item") != -1) {
                    if (g_isVisitorVip) {
                        isVisitor = true;
                    }
                    var awardsList = "https://film.qq.com/weixin/4y/award.html";
                    openUrl(awardsList, 1);
                }
            }

        });

        $('.link_term').tap(function() {
            openUrl('https://film.qq.com/weixin/term.html', 1);
        });

        $('.js_bind_zhifubao').tap(function() {
            openUrl('https://cy.qq.com/p/caiyun/3091.html ', 1);
        });

        $('.js_link_term_serialpay').tap(function() {
            openUrl('https://film.qq.com/weixin/term.html#serialpay', 1);
        });

        $('.js_que_link').tap(function(e) {
            var ptag = "help.user.ipho";
            if (isAndroid) {
                ptag = "help.user.apho";
            }
            var f_resource = "VIP帮助服务中心";
            initClickReport({ f_hottag: reportConf_hottag.help, f_pagetag: ptag, f_resource: f_resource });
            var url = "https://film.qq.com/weixin/h5/support/help.html?ptag=" + ptag;
            openUrl(url, 0);
        });

        $('.js_open_renew').tap(function(e) {
            if ($('.js_open_renew').css("display") != "none") {
                var linkType = $('.js_open_renew').attr('data-open-renew');
                var url = "https://kf.qq.com/touch/sappfaq/1511276NjMj6151127VNJjQ3.html";
                if ("hlwhf" == linkType) { //预付费用户
                    url = "https://kf.qq.com/touch/sappfaq/150920n6VRZ3150920zYfmiU.html?platform=15";

                }
                if (isAndroid) {
                    url = ["txvideo://v.qq.com/Html5Activity?url=", encodeURIComponent(url)].join('');
                }
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke('openView', {
                            url: url
                        }, function(json_msg) {});
                    } catch (err) {
                        location.href = url;
                    }
                }, 0);

                var hotTag = $(this).attr('hottag');
                var f_resource = $(e.target).text();
                initClickReport({ f_hottag: hotTag, f_resource: f_resource });
            }
        });


        $('.js_head_pic').tap(function(e) {
            var url = $(this).attr('data-url');
            if (url) {
                openUrl(url, 1);
            }
            return false;
        });

        $('.js_Agio_tag').tap(function() {
            if ($('.js_Agio_tag').is(":visible")) {
                var linkTarget = $(this).attr("data-id");
                var aid = getUrlParam('aid') || '';
                if (storage.getItem("isOverseas")) {
                    isOverseas = storage.getItem("isOverseas");
                }
                if (isOverseas == "yes") {
                    var param = {
                        "target": linkTarget
                    };
                    pay_tag = "agio";
                    openPayOverseas(param);
                    return;
                }

                pay_sBIZ = "agio";
                bossReport();
                if (linkTarget == "open") { //已有订单，开通VIP
                    //TODO:: go open
                    openUrl(['https://film.qq.com/weixin/agio.html?aid=', aid].join(''), 1);
                } else if (linkTarget == "order") { //没有订单购买页面
                    //TODO:: go order
                    openUrl(['https://film.qq.com/weixin/tvlist.html?aid=', aid].join(''), 1);
                }
            }
        });

        $(".js_more_movie").tap(function() {
            var url = "";
            url = ["tenvideo2://?action=3&channelId=100120&filter=channel_type",
                encodeURIComponent("="), "movie",
                encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
                encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "type", encodeURIComponent("="), "1"
            ].join('');
            if (isAndroid) {
                //url = "txvideo://v.qq.com/VideoListExhibitActivity?&channelId=100120&filter=channel_type%3Dmovie%26sort%3D2%26iarea%3D-1%26itype%3D3%26iyear%3D-1%26iattribute%3D-1&channelTitle=好莱坞&uiType=6";
                url = ["txvideo://v.qq.com/VideoListExhibitActivity?&channelId=100120&filter=channel_type",
                    encodeURIComponent("="), "movie",
                    encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
                    encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
                    encodeURIComponent("&"), "type", encodeURIComponent("="), "1",
                    "&channelTitle=VIP会员&uiType=6"
                ].join('');
            }
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openView', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
        });


        $(document).delegate("[data-url]", "tap", function() {
            var url = $(this).attr('data-url');
            if ($(this).hasClass('a_item')) {
                openUrl(url, 1);
            } else {
                utils.openUrlCommon(url);
            }
            return false;
        });

        $(document).delegate("[data-movie-url]", "tap", function() {
            var url = $(this).attr('data-movie-url');
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openView', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
            return false;
        });

        $(document).delegate("[hottag]", "tap", function(e) {
            if ($(e.target).parent().hasClass("package_item_1") || $(e.target).parent().hasClass("link_pay") || $(e.target).parent().hasClass("js_link_paySerial")) { //支付点击的单独上报，aid需要改变
                return false;
            }
            var hotTag = $(this).attr('hottag');
            var params = { f_hottag: hotTag };
            var f_resource = $(this).attr('f_resource');
            if (!f_resource) {
                f_resource = $(e.target).text();
            }
            if (f_resource) {
                params.f_resource = f_resource;
            }
            var f_cid = $(this).attr('f_cid');
            if (f_cid) {
                params.f_cid = f_cid;
            }
            var f_ptag = $(this).attr('f_pagetag');
            if (f_ptag) {
                params.f_pagetag = f_ptag;
            }
            initClickReport(params);
            return false;
        });

        $(document).delegate(".js_act_duihuan", "tap", function() {
            var url = "https://film.qq.com/weixin/coupon.html?ptag=wx.menu.coupon";
            isAccountLogin(function(json_login) {
                openUrl(url, 0);
            }, function() {
                TenvideoJSBridge.invoke("actionLogin", {
                    "type": "tv"
                }, function(json_msg) {
                    var json = JSON.parse(json_msg);
                    if (json.errCode == 0) {}
                });
            });
            return false;
        });

        $(document).delegate(".js_act_gift", "tap", function(e) {
            var url = "https://film.qq.com/weixin/h5/gift/index.html";
            openUrl(url, 0);            
            return false;
        });

        $('.js_vip_club').tap(function(e) {
            openUrl("https://film.qq.com/weixin/h5/club/", 0);
            var hotTag = $(this).attr('hottag');
            var f_resource = $(e.target).text();
            initClickReport({ f_hottag: hotTag, f_resource: f_resource });
            return false;
        });

        $('.js_package_info').tap(function() {
            tap_package_count += 1;
            if (tap_package_count == 5) {
                $.getJSON("info.json", function(data) {
                    alert(["packageId:", data.packageId, " version:", data.version].join(''));
                    tap_package_count = 0;
                });
            }
        });


        $(document).delegate('.js_link_paySerial', 'click', function(e) {
            var hottag = $(this).attr("hottag");
            var param = {
                price: $(this).attr('data-price'),
                product_price: $(this).attr('data-price'),
                product_single_price: $(this).attr('data-price'),
                qq_offerid: $(this).attr('data-qq-offerid'),
                wx_offerid: $(this).attr('data-wx-offerid'),
                hottag: hottag
            };
            if (isIos && !useh5pay) {
                param = {
                    month: 1,
                    //id: $(this).attr('data-product-id'),                    
                    product_price: $(this).attr('data-price'),
                    product_single_price: $(this).attr('data-price'),
                    serialpay: 1,
                    hottag: hottag
                };
                param.aid = aidApi.init({ isPay: 1, isSerial: 1 });
                //iap点击上报
                if (param.hottag) {
                    var f_resource = $(this).attr("f_resource");
                    initClickReport({ f_hottag: param.hottag, f_aid: param.aid, f_resource: f_resource });
                }
                var ios_qq_offerid = $(this).attr('data-qq-offerid');
                var ios_wx_offerid = $(this).attr('data-wx-offerid');
                var ios_visitor_offerid = $(this).attr('data-productId-visitor');
                utils.getMainCookie(function(json_user) {
                    if (g_isVisitorVip) {
                        param.id = ios_visitor_offerid;
                    } else {
                        if (json_user.type == 'wx') {
                            param.id = ios_wx_offerid;
                        } else if (json_user.type == 'qq') {
                            param.id = ios_qq_offerid;
                        }
                    }
                    _ios_serial_iapPay(param, json_user.type);

                }, function() { //游客模式
                    param.id = ios_visitor_offerid;
                    _ios_serial_iapPay(param);
                });

            } else {
                isAccountLogin(function(json_login) {
                    goSerialPay(param);
                }, function() {
                    TenvideoJSBridge.invoke("actionLogin", {
                        "type": "tv"
                    }, function(json_msg) {
                        log("actionLogin:" + json_msg);
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {}
                    });
                });
            }
        });

        $('.js_growth_section').tap(function() {
            var url = "https://film.qq.com/weixin/user_grade.html";
            openUrl(url, 1);
        });

        $('.js_friends_section').tap(function() {
            var hotTag = $(this).attr('hottag');
            initClickReport({ f_hottag: hotTag });
            var url = "https://film.qq.com/weixin/user_friends.html";
            openUrl(url, 0);
            return false;
        });

        if (/ QQLiveBrowser\//.test(navigator.userAgent) == false) {
            $('.app_container').show();
            $('.g_container_loading').hide();
        }

        //接收代金券选择参数
        $(document).on("coupons_show", function(e, data) {
            e.preventDefault();
            var ext = data.couponExt;
            var info = data.couponInfo;
            var value = data.couponValue;
            var leastPrice = data.couponLp;
            var currentDom = data.itemSource;
            var selIndex = data.selIndex; //记录选中的优惠券位置，便于下次定位
            //更改优惠金额
            currentDom.find(".js_voucher_value").text(value / 100);
            currentDom.find(".js_voucher_leastPrice").text(leastPrice / 100);
            //更改开通传递代金券参数
            var packDom = currentDom.parent().siblings('.link_pay');
            packDom.attr("data-coupon-ext", ext);
            packDom.attr("data-coupon-info", info);

        });

        version();
    });

    function initReport() {
        var isVip = 0;
        if (isVipReport) {
            isVip = 1;
        }
        try {
            reportApi_new.expose({ f_aid: aidReport.replace(/\$/g, '|||'), f_vip: isVip });
        } catch (err) {}
    }

    function initClickReport(params) {
        var hotTag = params.f_hottag || "";
        var isVip = 0;
        if (isVipReport) {
            isVip = 1;
        }
        var f_module = encodeURIComponent(reportConf_new.getModule(hotTag));
        if (!params.f_aid) {
            params.f_aid = aidReport.replace(/\$/g, '|||');
        } else {
            params.f_aid = params.f_aid.replace(/\$/g, '|||');
        }
        
        if (params.f_resource) {
            params.f_resource =$.trim(decodeURIComponent(params.f_resource));
        }
        try {
            reportApi_new.click($.extend(params, { f_module: f_module, f_vip: isVip }));
        } catch (err) {}

    }

    function init() {
        appCallBack();
    }

    function getRenewHint(json_vip) {
        tenvideoReady(function() {
            isAccountLogin(function() {
                initRenewHint(json_vip, function(isAutoRenew) {
                    bindRenewData(isAutoRenew);
                }, function() {
                    $('.js_open_renew').css("display", "none");
                });
            });
        });
    }

    function getMaiUserInfoRefresh() {
        tenvideoReady(function() {
            getMainUserInfo(function(json) {
                if (g_isVisitorVip) {
                    return;
                }
                var data = json.userInfo;
                var accountType = json.type;
                var uin = "";
                $('#user_icon').removeClass(); //icon hint
                if (data) {
                    var defaultFace = "style/app_v/img/user/default_160.png";
                    var nick = data.nickname;
                    var face = data.headImgUrl ? normalizer(data.headImgUrl) : defaultFace;
                    $('.user_face').attr('src', face);
                    $('.user_nick').text(nick);
                    if ("qq" == accountType) {
                        $('#user_icon').addClass("u_icon_qq");
                        uin = data.uin;
                    } else if ("wx" == accountType) {
                        $('#user_icon').addClass("u_icon_wx");
                        uin = data.openId;
                    }
                    //report(uin);
                } else {
                    //report(0);
                }
            }, function() {
                //report(0);
            });
        });

    }

    function getPayVipRefresh() {
        tenvideoReady(function() {
            getPayVip(function(json) {
                //以下为更新等级信息
                if (json.result) {
                    if (json.result.code == 0) {
                        getMainUserInfo(function(json_main) {
                            if (json.uin && json.uin > 0) { //判断用户状态是否一致
                                getPayVipCb(json);
                            } else {
                                //return;
                                initDiscountConfigNew();
                                userLoginModChk();
                            }
                        }, function() {
                            getPayVipCb(json);
                        });
                    } else {
                        initDiscountConfigNew();
                        userLoginModChk();
                    }
                } else {
                    initDiscountConfigNew();
                    //iphone退出登录后会执行该方法
                    logoutClear();
                    initAgioTag();
                    userLoginModChk();
                    isAccountLogin(function() {
                        try { //显示通栏信息：微信非VIP没有返回vipInfo
                            vipProperty.init();
                        } catch (err) {}
                    });

                }
            }, function() {
                initDiscountConfigNew();
                userLoginModChk();
            });
        });

    }


    function appCallBack() {
        getMaiUserInfoRefresh();
        if (isIos) {
            isAccountLogin(function() {
                getPayVipRefresh();
            }, function() {
                initDiscountConfigNew();
                userLoginModChk();
            });
            //getPayVipRefresh();
        } else {
            getPayVipRefresh();
        }
        //IOS代充
        iosPaySvip.init();

    }

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function initDiscountConfigNew(json_vip) {
        var isInitDiscount = false;
        tenvideoReady(function() {
            //getPayVip(function(json_vip) {
            if (isIos) {
                var canGoSerialPay = false;
                if (utils.versionCompare(appVersion, "5.3.1")) {
                    canGoSerialPay = true;
                }
                getAppInfo(function(json_app) {
                    if (json_app.isJBOS == 1) {
                        //获取非iap价格
                        g_isJBOS = true;
                        useh5pay = true;
                        utils.getHlwDiscountAjax(pay_type, function(json_discounts, isPriceStorage) {
                            if (isPriceStorage) {
                                g_isDefaultPrice = true;
                            } else {
                                g_isDefaultPrice = false;
                            }
                            bindDiscount(json_discounts, json_vip, true);
                        }, function() {
                            utils.getHlwDiscountDefault(true, function(default_pack) {
                                g_isDefaultPrice = true;
                                bindDiscount(default_pack, json_vip, canGoSerialPay);
                            });
                        });
                    } else {
                        utils.getIapType(function(json_iap) {
                            if (json_iap.useh5 == 1) { //绕iap支付：走h5支付
                                useh5pay = true;
                                if (typeof json_vip != "undefined") {
                                    var isVisitorVip = false;
                                    if (json_vip.result) {
                                        if (json_vip.result.code == 0) {
                                            if (json_vip.visitor && json_vip.visitor.vip == 1) {
                                                isVisitorVip = true;
                                                g_isVisitorVip = true;
                                            } else {
                                                g_isVisitorVip = false;
                                            }
                                        }
                                    }
                                    if (isVisitorVip) {
                                        pay_type = 1;
                                        useh5pay = false;
                                    }
                                }
                            } else if (json_iap.useh5 == 2) { //ios代充：iap的价格，走h5支付
                                pay_type = 2;
                                useh5pay = true;
                                if (json_vip && json_vip.result) {
                                    if (json_vip.result.code == 0) {
                                        if (json_vip.visitor && json_vip.visitor.vip == 1) {
                                            g_isVisitorVip = true;
                                        } else {
                                            g_isVisitorVip = false;
                                        }
                                    }
                                }
                            } else { //iap支付
                                pay_type = 1;
                                useh5pay = false;
                                if (json_vip && json_vip.result) {
                                    if (json_vip.result.code == 0) {
                                        if (json_vip.visitor && json_vip.visitor.vip == 1) {
                                            g_isVisitorVip = true;
                                        } else {
                                            g_isVisitorVip = false;
                                        }
                                    }
                                }
                            }
                            utils.getHlwDiscountAjax(pay_type, function(json_discounts, isPriceStorage) {
                                if (isPriceStorage) {
                                    g_isDefaultPrice = true;
                                } else {
                                    g_isDefaultPrice = false;
                                }
                                bindDiscount(json_discounts, json_vip, canGoSerialPay);
                            }, function() {
                                utils.getHlwDiscountDefault(useh5pay, function(default_pack) {
                                    g_isDefaultPrice = true;
                                    if (useh5pay) {
                                        bindDiscount(default_pack, json_vip, canGoSerialPay);
                                    } else {
                                        bindDiscount(default_pack, json_vip, canGoSerialPay);
                                    }
                                });
                            });
                        }, function() {
                            utils.getHlwDiscountAjax(pay_type, function(json_discounts, isPriceStorage) {
                                if (isPriceStorage) {
                                    g_isDefaultPrice = true;
                                } else {
                                    g_isDefaultPrice = false;
                                }
                                bindDiscount(json_discounts, json_vip, canGoSerialPay);
                            }, function() {
                                utils.getHlwDiscountDefault(useh5pay, function(default_pack) {
                                    g_isDefaultPrice = true;
                                    bindDiscount(default_pack, json_vip, canGoSerialPay);
                                });
                            });
                        });
                    }
                });
            } else {
                //由于aphone在h5退出登录不会清除cookie，因此在显示代金券信息时需要先判断用户是否登录
                utils.getHlwDiscountAjax(pay_type, function(json_discounts, isPriceStorage) {
                    var isLogin = false;
                    if (isPriceStorage) {
                        g_isDefaultPrice = true;
                    } else {
                        g_isDefaultPrice = false;
                    }
                    isAccountLogin(function(json_login) {
                        isLogin = true;
                        bindDiscount(json_discounts, json_vip, true, isLogin);
                    }, function() {
                        isLogin = false;
                        bindDiscount(json_discounts, json_vip, true, isLogin);
                    });
                }, function() {
                    utils.getHlwDiscountDefault(true, function(default_pack) {
                        g_isDefaultPrice = true;
                        bindDiscount(default_pack, json_vip, true);
                    });
                });
            }
            //});
        });
    }

    function bindDiscount(discout_list, json_vip, isSerial, isLogin) {
        if (!isSerial) {
            ads.init();
        }
        if (discout_list.hlw_params && discout_list.hlw_params.length > 0) {
            g_hlw_param = discout_list.hlw_params;
        }
        var btnHint = "开通";
        var isVip = false;
        if (typeof json_vip != "undefined") {
            if (json_vip.visitor && json_vip.visitor.vip == 1) {
                btnHint = "续费";
                isVip = true;
            } else if (json_vip.vip && json_vip.vip == 1) {
                btnHint = "续费";
                isVip = true;
            }
        }
        if (discout_list.price_list) {
            var payInfo = discout_list.price_list;
            var productPackage = "";
            var qqOfferid_serial = "";
            var wxOfferid_serial = "";
            var origanl_price_serial = "";
            for (var i = 0; i < payInfo.length; i++) {
                var item = payInfo[i];
                qqOfferid_serial = item.qq_offerid;
                wxOfferid_serial = item.wx_offerid;
                g_pay_wx_offerId = item.wx_offerid;
                g_pay_qq_offerId = item.qq_offerid;
                var html = '';
                var hotTagPay = "";
                //代金券信息
                var couponExt = "";
                var couponInfo = "";
                var prefix = [item.amount, '个月'].join('');
                var _f_resource = prefix;
                hotTagPay = [reportConf_hottag.openPay_hvipMonth, "_", item.amount].join('');
                if (item.type == "day") { //按天开通
                    hotTagPay = [reportConf_hottag.openPay_hvipDay, "_", item.amount].join('');
                }
                var package_desc = item.icon_desc;
                var price_desc = item.price_desc;
                if (item.amount && item.amount == "12" && item.type == "month") {
                    prefix = "年费";
                    g_annual_productId = item.product_id;
                    g_annual_qqOfferid = item.qq_offerid;
                    g_annual_wxOfferid = item.wx_offerid;
                }
                if (item.amount && item.amount == "1" && item.type == "month") {
                    origanl_price_serial = item.original_price;
                }
                var productId = "";
                if (item.product_id && item.product_id.length > 0) {
                    productId = item.product_id;
                } else { //默认productID
                    if (isIos && !g_isJBOS) {
                        if (item.month == 1) {
                            productId = "com.tenvideoios.OneMonthPay1";
                        } else if (item.month == 3) {
                            productId = "com.tenvideoios.ThreeMonthPay1";
                        } else if (item.month == 12) {
                            productId = "com.tenvideoios.OneYearPay1";
                            g_annual_productId = productId;
                        }
                    } else {
                        if (item.month == 1) {
                            productId = "1000";
                        } else if (item.month == 3) {
                            productId = "1001";
                        } else if (item.month == 12) {
                            productId = "1002";
                            g_annual_productId = productId;
                        }
                    }

                }

                //var itemHtml = ['<li class="package_item_1" data-amount="', item.amount, '" data-id="', productId, '" data-month-price="', item.single_price, '" data-pay-type="', item.type, '" data-qq-offerid="', item.qq_offerid, '" data-wx-offerid="', item.wx_offerid, '" data-single-price="', item.single_price, '" hottag="', hotTagPay, '">'].join('');
                var itemHtml = '<li class="package_item_1">';
                itemHtml += '<div class="txt_info">';
                if (item.type == "day") {
                    itemHtml += ['<span class="txt">', '<span class="num">', item.price, '</span>元体验', item.amount, '天</span>'].join('');
                    _f_resource = item.amount + "天";
                } else {
                    if (item.product_desc && item.product_desc.length > 0) {
                        prefix = item.product_desc;
                        _f_resource = prefix;
                    }
                    itemHtml += ['<span class="txt">', prefix, '<span class="num">', item.price, '</span>元</span>'].join('');
                    if (item.original_price && item.original_price > 0) {
                        itemHtml += '   <span class="ori_price">' + [item.original_price, "元"].join('') + '</span>';
                    }
                }
                if (package_desc && package_desc.length > 0) {
                    itemHtml += ['<span class="mark_flag">', package_desc, '</span>'].join('');
                } else {
                    itemHtml += '<span class="mark_flag" style="display:none;"></span>';
                }
                itemHtml += '</div>';
                //代金券信息优先展示,aphone需要判断是否有登录
                if (item.coupons && item.coupons.pay_info && !g_isDefaultPrice) { //缓存不显示代金券信息
                    if (isAndroid && !isLogin) { //安卓未登录不显示代金券信息
                        if (price_desc.length > 0) {
                            itemHtml += '<div class="txt_tips">';
                            itemHtml += '<a class="link" href="javascript:;">' + price_desc + '</a>';
                            itemHtml += '</div>';
                        }
                    } else {
                        var couponsInfo = item.coupons.pay_info;
                        couponExt = couponsInfo.coupons_ext;
                        couponInfo = couponsInfo.coupons_info;
                        if (item.coupons.count) {
                            var coupon_pay_tag = [hotTagPay, '_coupon'].join('');
                            itemHtml += '<div class="txt_tips">';
                            if (item.coupons.least_price) {
                                itemHtml += '<a class="link link_color2 js_coupon_detail_item" href="javascript:;"  data-pack-price="' + item.price + '" hottag="' + coupon_pay_tag + '">优惠券&nbsp;满<span class="num js_voucher_leastPrice">' + item.coupons.least_price / 100 + '</span>元立减<span class="num js_voucher_value">' + item.coupons.max_value / 100 + '</span>元<i class="icon_arrow"></i></a>';
                            } else {
                                itemHtml += '<a class="link link_color2 js_coupon_detail_item" href="javascript:;"  data-pack-price="' + item.price + '" hottag="' + coupon_pay_tag + '">优惠券&nbsp;立减<span class="num js_voucher_value">' + item.coupons.max_value / 100 + '</span>元<i class="icon_arrow"></i></a>';
                            }

                            itemHtml += '</div>';
                        }
                    }

                } else if (price_desc.length > 0) {
                    itemHtml += '<div class="txt_tips">';
                    itemHtml += '<a class="link" href="javascript:;">' + price_desc + '</a>';
                    itemHtml += '</div>';
                }
                if (couponExt && couponExt.length > 0) {
                    itemHtml += ['<a class="link_info link_pay" href="javascript:;" title="', btnHint, '" data-amount="', item.amount, '" data-id="', productId, '" data-month-price="', item.single_price, '" data-pay-type="', item.type, '" data-qq-offerid="', item.qq_offerid, '" data-wx-offerid="', item.wx_offerid, '" data-single-price="', item.single_price, '" data-coupon-info="', couponInfo, '" data-coupon-ext="', couponExt, '" hottag="', hotTagPay, '" f_resource="' + _f_resource + '">', '<span class="txt">', btnHint, '</span>', '</a></li>'].join('');
                } else {
                    itemHtml += ['<a class="link_info link_pay" href="javascript:;" title="', btnHint, '" data-amount="', item.amount, '" data-id="', productId, '" data-month-price="', item.single_price, '" data-pay-type="', item.type, '" data-qq-offerid="', item.qq_offerid, '" data-wx-offerid="', item.wx_offerid, '" data-single-price="', item.single_price, '" hottag="', hotTagPay, '" f_resource="' + _f_resource + '">', '<span class="txt">', btnHint, '</span>', '</a></li>'].join('');
                }
                productPackage += itemHtml;
            }
            if (productPackage.length > 0) {
                if (isSerial) {
                    initSerialPacDom(isVip, productPackage);
                } else {
                    $('.js_package_list').html(productPackage);
                    showPage();
                    $(document).trigger("package_ready"); //通知成长值升级动画
                }
            }

            //审核期间获取申请价格信息
            //initVertypePackage();

            //代金券详情
            $(document).undelegate('.js_coupon_detail_item', 'click')
            $(document).delegate('.js_coupon_detail_item', 'click', function(event) {
                var currentDom = $(this);
                var packPrice = $(this).attr("data-pack-price");
                var curDomIndex = $(".js_coupon_detail_item").index(this);
                var packDom = $(this).parent().siblings('.link_pay');
                var coupon_ext = packDom.attr("data-coupon-ext");
                couponListWin.init(packPrice * 100, currentDom, coupon_ext);
            });
        }
    }

    function openPayAndroid(param) {
        if (utils.versionCompare(appVersion, "4.2.0")) {
            isAccountLogin(function(json_login) {
                goH5Pay(param);
            }, function() {
                TenvideoJSBridge.invoke("actionLogin", {
                    "type": "tv" //get multi-account login entrance
                }, function(json_msg) {
                    var json = JSON.parse(json_msg);
                    if (json.errCode == 0) {}
                });
            });

        } else {
            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        }
    }

    function goH5Pay(param, extraParam) {
        //utils.getAutoPayParam().done(function(autoPayParam) {
        param.ap = g_autoPayParam;
        extraParam = extraParam || "";
        getAppInfo(function(json_app) {
            var appInfo_param = {};
            appInfo_param.appInfo = json_app;
            appInfo_param.isPay = "1";
            if (useh5pay && isIos) {
                if (pay_type == 1) {
                    appInfo_param.useH5 = "1";
                } else if (pay_type == 2) {
                    appInfo_param.useH5 = "2";
                }
            }
            $.extend(param, appInfo_param);
            if (isAndroid) { //aphone 4.9.0版本cookie有问题，不支持弹窗
                if (utils.versionCompare(appVersion, "4.9.0")) {
                    goPayLinkDialog(param, extraParam);
                } else {
                    goPayLink(param, extraParam);
                }

            } else {
                goPayLinkDialog(param, extraParam);
            }
        });
        //});
    }

    function initAutoPayParam() {
        utils.getAutoPayParam().done(function(autoPayParam) {
            g_autoPayParam = autoPayParam;
        }).fail(function() {
            g_autoPayParam = 0;
        });
    }

    function goPayLink(param, extraParam) {
        var aid = aidApi.init(param);
        var ru = encodeURIComponent('https://film.qq.com/app/payback.html');
        var url = normalizer('http://pay.qq.com/h5/index.shtml?m=buy&as=1&hh=1&showwxpaytitle=1' + '&wxAppid=wx68ff4e3ba9f84df4');
        if (isNewSdkVersion()) {
            //传sdkpay=1不需要传wxAppid参数
            url = normalizer('http://pay.qq.com/h5/index.shtml?m=buy&as=1&hh=1&showwxpaytitle=1');
            url += '&sdkpay=1&_newservice=1';
            wxOfferId = "1450002788";
        }
        var month = param.month;
        var ap = param.ap;
        var isSerial = param.isSerial; //是否是连续包月，连续包月：param.isSerial=1；
        var d_cookie = $.Deferred();
        if (isSerial == "1") {
            url += "&service_name=%E8%85%BE%E8%AE%AF%E8%A7%86%E9%A2%91VIP";
            var serialParam = {};
            serialParam.isSerial = "1";
            $.extend(param, serialParam);
            aid = aidApi.init(param);
        }
        //点击上报
        if (param && param.hottag) {
            initClickReport({ f_hottag: param.hottag, f_aid: aid });
        }
        $.when(d_cookie).done(function(json_cookie) {
            var cookieStr = json_cookie.cookie;
            var productid = param.id;
            if (!productid) {
                if (month == 1) {
                    productid = '1000';
                } else if (month == 3) {
                    productid = '1001';
                } else if (month == 12) {
                    productid = '1002';
                }
            }
            if (json_cookie.type == "wx") {
                var openid = getCookieParam(cookieStr, "openid");
                var access_token = getCookieParam(cookieStr, "access_token");
                var appid = getCookieParam(cookieStr, "appid");
                wxOfferId = param.wx_offerid;
                if (isSerial == "1") {
                    url += ['&c=subscribe&service=TXSP&appid=', wxOfferId, '&openid=', openid, '&openkey=', access_token, '&sessionid=hy_gameid&sessiontype=wc_actoken&wxAppid2=', appid, '&pf=wechat_wx-2001-wx-2011-hlw'].join('');
                } else {
                    url += ['&c=subscribe&service=TXSP&appid=', wxOfferId, '&productid=', productid, '&openid=', openid, '&openkey=', access_token, '&sessionid=hy_gameid&sessiontype=wc_actoken&wxAppid2=', appid, '&pf=wechat_wx-2001-wx-2011-hlw'].join('');
                }
            } else {
                qqOfferId = param.qq_offerid;
                var uin = getUin(getCookieParam(cookieStr, "uin"));
                if (!uin || uin <= 10000) {
                    uin = parseInt(getCookieParam(cookieStr, "uin").replace(/^o0*/g, ""), 10);
                }
                if (isSerial == "1") {
                    url += ["&c=qqsubscribe&service=TXSP&pf=wechat_wx-2001-wx-2011-hlw&appid=", qqOfferId, "&u=", uin, '&wxAppid2=', 'wxca942bbff22e0e51'].join('');
                } else {
                    url += ["&c=qqsubscribe&service=TXSP&pf=wechat_wx-2001-wx-2011-hlw&appid=", qqOfferId, "&u=", uin, '&productid=', productid].join('');
                }

            }
            if (isSerial == "1") {
                url += "&continousmonth=1";
            } else {
                //低价开通标识
                if (param.product_type && param.product_type == "month") { //按月开通平均价格小于10元
                    if (param.product_single_price && param.product_single_price < 10) {
                        url += "&lp=1";
                    }
                } else if (param.product_type && param.product_type == "day") { //按天开通天数小于31天
                    if (param.day && param.day < 31) {
                        url += "&lp=1";
                    }
                }
                //按天支付
                if (param.product_type && param.product_type == "day") {
                    url += "&paybyday=1&dc=mcard,hfpay,qqcard&hideap=1";
                }
                //代金券信息
                if (param.couponExt && param.couponExt.length > 0) {
                    url += ["&coupons_ext=", encodeURIComponent(param.couponExt), "&coupons_info=", encodeURIComponent(param.couponInfo)].join('');
                }
                url += ["&ap=", ap].join('');
            }
            url += ["&aid=", encodeURIComponent(aid), "&ru=", ru, "&aph=1&showad=1&hct=1"].join('');
            if (g_hlw_param.length > 0) {
                url += "&hlw_params=" + encodeURIComponent(g_hlw_param);
            } else {
                url += "&hlw_params=" + encodeURIComponent(default_hlw_param);
            }
            if (isIos) {
                openUrlBySdk(url, 1, "1");
            } else {
                openUrl(url, 1);
            }
        });

        getMainCookie(function(json_cookie) {
            d_cookie.resolve(json_cookie);
        }, function() {
            d_cookie.resolve();
        });
    }

    function goPayLinkDialog(param, extraParam) {
        var isDialog_param = {};
        isDialog_param.isDialog = "1";
        $.extend(param, isDialog_param);
        var aid = aidApi.init(param);
        var openParam = {};
        openParam.ru = normalizer('https://film.qq.com/app/payback.html');
        openParam.as = 1;
        openParam.hh = 1;
        openParam.showwxpaytitle = 1;
        if (isNewSdkVersion()) {
            //传sdkpay=1不需要传wxAppid参数
            wxOfferId = "1450002788";
            openParam.sdkpay = 1;
        } else {
            openParam.wxAppid = "wx68ff4e3ba9f84df4";
        }
        var month = param.month;
        var ap = param.ap;
        var d_cookie = $.Deferred();
        $.when(d_cookie).done(function(json_cookie) {
            var cookieStr = json_cookie.cookie;
            var productid = param.id;
            if (!productid) {
                if (month == 1) {
                    productid = '1000';
                } else if (month == 3) {
                    productid = '1001';
                } else if (month == 12) {
                    productid = '1002';
                }
            }
            if (json_cookie.type == "wx") {
                var openid = getCookieParam(cookieStr, "openid");
                var access_token = getCookieParam(cookieStr, "access_token");
                var appid = getCookieParam(cookieStr, "appid");
                wxOfferId = param.wx_offerid;
                openParam.account = "wechat";
                openParam.service = "TXSP";
                openParam.appid = wxOfferId;
                openParam.productid = productid;
                openParam.openid = openid;
                openParam.openkey = access_token;
                openParam.sessionid = "hy_gameid";
                openParam.sessiontype = "wc_actoken";
                openParam.wxAppid2 = appid;
                openParam.pf = "wechat_wx-2001-wx-2011-hlw";
            } else {
                qqOfferId = param.qq_offerid;
                var uin = getUin(getCookieParam(cookieStr, "uin"));
                if (!uin || uin <= 10000) {
                    uin = parseInt(getCookieParam(cookieStr, "uin").replace(/^o0*/g, ""), 10);
                }
                openParam.account = "qq";
                openParam.service = "TXSP";
                openParam.pf = "wechat_wx-2001-wx-2011-hlw";
                openParam.appid = qqOfferId;
                openParam.productid = productid;
                openParam.u = uin;
            }
            //低价开通标识
            if (param.product_type && param.product_type == "month") { //按月开通平均价格小于10元
                if (param.product_single_price && param.product_single_price < 10) {
                    openParam.lp = 1;
                }
            } else if (param.product_type && param.product_type == "day") { //按天开通天数小于31天
                if (param.day && param.day < 31) {
                    openParam.lp = 1;
                }
            }
            //按天支付
            if (param.product_type && param.product_type == "day") {
                openParam.paybyday = 1;
                openParam.dc = "mcard,hfpay,qqcard";
                openParam.hideap = 1;
            }
            //代金券信息
            if (param.couponExt && param.couponExt.length > 0) {
                openParam.coupons_ext = param.couponExt;
                openParam.coupons_info = param.couponInfo;
                $.extend(param, { "couponId": utils.getParam(param.couponExt, "card_id") });
                aid = aidApi.init(param);
            }
            openParam.ap = ap;
            openParam.aid = aid;
            /*openParam.aph = 1;
            openParam.showad = 1;
            openParam.hct = 1;*/
            openParam.hideInfo = 1;
            if (g_hlw_param.length > 0) {
                openParam.hlw_params = g_hlw_param;
            } else {
                openParam.hlw_params = default_hlw_param;
            }
            //TODO:设置测试环境
            if (utils.isSandbox()) {
                //openParam.sandbox = true;
            }
            openParam.onClose = function() {
                g_isPayDialogOpen = false;
                //TODO::关闭窗口
                utils.refreshVipInfo(function() {
                    //g_isPayDialogOpen = false;
                });
            }
            if (!g_isPayDialogOpen) {
                Midas.openSubscribe(openParam);
                g_isPayDialogOpen = true;
                if (Midas.openSubscribe._dlg) {
                    Midas.openSubscribe._dlg.stream.on('QQLiveBrowser-redirect-url', function(data) {
                        openUrl(data.url, 1);
                    });
                }
            }

            //点击上报
            if (param && param.hottag) {
                initClickReport({ f_hottag: param.hottag, f_aid: aid, f_resource: param.f_resource });
            }
        });

        getMainCookie(function(json_cookie) {
            d_cookie.resolve(json_cookie);
        }, function() {
            d_cookie.resolve();
        });
    }


    function getAppInfo(suCb, failCb) {
        var isCallback = false;
        if (storage.getItem("app_info")) {
            var appInfo = JSON.parse(storage.getItem("app_info"));
            isCallback = true;
            suCb && suCb(appInfo);
        }
        TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
            log(['getAppInfo:', json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                //storage.setItem("app_info_isjbos", json.result.isJBOS);
                storage.setItem("app_info", JSON.stringify(json.result));
                !isCallback && suCb && suCb(json.result);
            } else {
                !isCallback && failCb && failCb();
            }
        });
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq", "wx"]
        }, function(json_msg) {
            log(["getUserInfo:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            log(["getMainUserInfo:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            log(["hlw_getPayVip:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getTicketNum(suCb, failCb) {
        TenvideoJSBridge.invoke("getTicketNum", null, function(json_msg) {
            log(["getTicketNum:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                var num = json.result.num;
                suCb && suCb(num);
            } else {
                failCb && failCb();
            }
        });
    }

    function getOrderNum(suCb, failCb) {
        //获取缓存数据
        /*getcacheOrderNum(function(cache_num){
            suCb && suCb(cache_num);
        });*/
        TenvideoJSBridge.invoke("getOrderNum", null, function(json_msg) {
            log(["getOrderNum:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                var num = json.result.num;
                //cacheOrderNum(num);
                suCb && suCb(num);
            } else {
                failCb && failCb();
            }
        });
    }

    function cacheOrderNum(orderNum) {
        getMainCookie(function(json_user) {
            var cookieStr = json_user.cookie;
            var accountType = json_user.type;
            var uid = "";
            if (json_user.type == 'wx') {
                uid = getCookieParam(cookieStr, "openid");
            } else if (json_user.type == 'qq') {
                uid = getCookieParam(cookieStr, "uin");
            }
            if (uid) {
                var key = ["order_num_", uid].join('');
                storage.setItem(key, orderNum);
            }
        });
    }

    function getcacheOrderNum(suCb) {
        getMainCookie(function(json_user) {
            var cookieStr = json_user.cookie;
            var accountType = json_user.type;
            var uid = "";
            if (json_user.type == 'wx') {
                uid = getCookieParam(cookieStr, "openid");
            } else if (json_user.type == 'qq') {
                uid = getCookieParam(cookieStr, "uin");
            }
            var key = ["order_num_", uid].join('');
            if (storage.getItem(key)) {
                suCb && suCb(storage.getItem(key));
            }
        });
    }

    function getDiscount(suCb, failCb) {
        $.ajax({
            url: normalizer("https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1793&otype=json"),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getDiscountConfig(suCb, failCb) {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var hlw_param = ['pf=', platform, "&app=qqlive&appver=", appVersion].join('');
        default_hlw_param = encodeURIComponent(hlw_param);
        if (storage.getItem("app_hlw_user_discounts_new")) {
            var discounts = JSON.parse(storage.getItem("app_hlw_user_discounts_new"));
            suCb && suCb(discounts);
        }
        $.ajax({
            url: [normalizer("https://pay.video.qq.com/fcgi-bin/price-month?otype=json&hlw_params="), encodeURIComponent(hlw_param)].join(''),
            dataType: "jsonp",
            success: function(json) {
                if (json.result && json.result.code == 0) {
                    storage.setItem("app_hlw_user_discounts_new", JSON.stringify(json));
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            log(["getMainCookie:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function refreshVipInfo() {
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("refreshVipInfo");
            } catch (err) {}
        }, 0);
    }

    function qqVip2WXLogin(suCb, failCb) {
        TenvideoJSBridge.invoke("qqVip2WX", null, function(json_msg) {
            log(["qqVip2WX:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb(json);
            }
        });
    }

    function isQQInstalled(suCb, failCb) {
        var pkgName = "";
        if (isIos) {
            pkgName = "mqq";
        } else {
            pkgName = "com.tencent.mobileqq";
        }
        var pkgUrl = "mqq://";
        TenvideoJSBridge.invoke("isInstalled", {
            "pkgName": pkgName,
            "pkgUrl": pkgUrl
        }, function(json_msg) {
            log(["isInstalled:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb(json);
            }
        });
    }

    function shiftQQVip2WX(param, suCb, failCb) {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        getDeviceInfo(function(json) {
            var guid = json.guid;
            var url = [normalizer("https://pay.video.qq.com/fcgi-bin/transuin2wx?otype=json&platform="), platform, "&guid=", guid, "&", param].join('');
            shiftQQVip2WXCb(url, suCb, failCb);
        }, function() {
            var url = [normalizer("https://pay.video.qq.com/fcgi-bin/transuin2wx?otype=json&platform="), platform, "&", param].join('');
            shiftQQVip2WXCb(url, suCb, failCb);
        });
    }

    function shiftQQVip2WXCb(url, suCb, failCb) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb(json);
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function showErrToast(msg) {
        $('#shit_err_msg').text(msg);
        $('.m_layer_mask').show();
        $('#qq_to_wx_err_layer').show();
    }

    function showSucToast(msg) {
        $("#shit_success_msg").text(msg);
        $('.m_layer_mask').show();
        $("#qq_to_wx_success_layer").show();
    }

    function getPayVipCb(json) {
        //获取价格信息
        initDiscountConfigNew(json);
        //获取自动续费信息
        getRenewHint(json);
        //获取成长值增长模块
        vipGrowth.init(json);
        //获取升级pop
        vipLevelUpPop.init(json);
        //获取好友关系链
        friendsRank.init();
        //帐号通栏信息
        vipProperty.init(json);
        //站内信
        message.init(json);

        $('#link_user').show();
        if ($('.js_user_vipinfo').is(":visible")) {
            $('.js_user_vipinfo').show();
            $('.user_status').hide();
            $('.js_bind_account').hide();
        } else if ($('.user_status').is(":visible")) {
            $('.user_status').show();
            $('.js_user_vipinfo').hide();
            $('.js_bind_account').hide();
        }
        if (json.visitor && json.visitor.vip == 1) {
            g_isVisitorVip = true;
            $('.js_taocan_hint').text('VIP套餐');
            $('#user_level').removeClass();
            $('#user_icon').removeClass(); //icon hint hide
            $('.user_face').attr('src', "style/app_v/img/user/default_160.png");
            $('.user_nick').text("游客");
            $('.user_expire').text(json.visitor.endTime.substr(0, 10));
            $('#user_level').addClass('u_icon_vip vip_0');

            $('.user_status').hide();
            $('.js_bind_account').hide();
            $('.js_user_vipinfo').show();
            isAccountLogin(function(json_account) {
                var data = json_account.userInfo;
                var uin = data.uin;
                var openId = data.openId;
                if (uin) { //qq imgrate
                    $('#qq_txt_account').text('QQ');
                    $('#link_migrate_qq').text(['转移到QQ帐号(', uin, ')'].join(''))
                        .parent().addClass('btn_1row');
                    $('#link_migrate_wx').hide();
                } else if (openId) { //wx imgrate
                    $('#qq_txt_account').text('微信');
                    var nickname = data.nickname;
                    $('#link_migrate_wx').text(['转移到微信帐号(', nickname, ')'].join(''))
                        .parent().addClass('btn_1row');
                    $('#link_migrate_qq').hide();
                }
                $('.shift_qq_wx').show();
            }, function() {
                $('#qq_txt_account').text('QQ或微信');
                $('#link_migrate_qq').text('转移到QQ帐号').parent().removeClass('btn_1row');
                $('#link_migrate_wx').text('转移到微信帐号').parent().removeClass('btn_1row');
                $('#link_migrate_wx').show();
                $('#link_migrate_qq').show();
                $('.shift_qq_wx').show();
            });
            //$('.package_list .link_pay').text('续费');
            $('#link_user').hide();
            $('.mod_user_logout').hide();
            $('.js_mod_user_login').show();
            bindLayout("1");
            $(".js_Agio_tag").hide();
        } else if (json.vip == 1) {
            g_isVisitorVip = false;
            $('.shift_qq_wx').hide();
            $('.js_taocan_hint').text('续费延长VIP有效期');
            $('#user_level').removeClass();
            if (json.annualvip == 1) {
                $('#user_level').addClass('u_icon_vip_year');
            } else {
                if (json.annualendtime != "0") { //年费会员过期，但是依旧是会员
                    $('#user_level').addClass('u_icon_vip_year_past');
                } else {
                    $('#user_level').addClass('u_icon_vip');
                }
            }
            $('#user_level').addClass(['vip_', json.level].join(''));
            $('.user_score').text(json.score);
            if (json.servicetype == 'HLWHF') {
                $('.user_expire').text(json.endmsg);
            } else {
                $('.user_expire').text(json.endTime.substr(0, 10));
            }

            $('.user_upgrade').text(json.score);
            //$('.package_list .link_pay').text('续费');
            $('.user_status').hide();
            $('.js_bind_account').hide();
            $('.js_user_vipinfo').show();

            $('.mod_user_logout').hide();
            $('.js_mod_user_login').show();

            bindLayout("1");
            $(".js_Agio_tag").hide();
            isVipReport = true;
        } else {
            g_isVisitorVip = false;
            isVipReport = false;
            $('.shift_qq_wx').hide();
            isAccountLogin(function(json_msg) {
                //$('#user_level').removeClass();
                $('.js_taocan_hint').text('VIP套餐');
                var uid = "";
                var data = json_msg.userInfo;
                var accountType = json_msg.type;
                if (data) {
                    if ("qq" == accountType) {
                        uid = data.uin;
                    } else if ("wx" == accountType) {
                        uid = data.openId;
                    }
                }
                $('#user_level').removeClass();
                if (uid) {
                    if (json.level > 0) {
                        if (json.annualendtime != "0") { //过期的年费会员，会员也过期
                            $('#user_level').addClass(['u_icon_vip_year_lost vip_', json.level].join(''));
                        } else {
                            $('#user_level').addClass(['u_icon_vip_lost vip_', json.level].join(''));
                        }
                    } else {
                        if (json.endTime != "") { //过期会员，成长值将为0
                            $('#user_level').addClass('u_icon_vip_lost vip_0');
                        }
                    }
                    $('.js_user_vipinfo').hide();
                    showBindAccount(json.endTime);
                }
                $('.mod_user_logout').hide();
                $('.js_mod_user_login').show();
                bindLayout("0");

                //非VIP补差价/买剧
                initAgioTag();
            }, function() {
                showLoginMod();
                initAgioTag();
            });
        }
    }

    function initRenewHint(json_vip, suCb, failCb) {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，管理我的自动续费
                $(".js_open_renew").css("display", "none");
            } else {
                initRenewHintCallbck(json_vip, suCb, failCb)
            }
        });
    }

    function initRenewHintCallbck(json, suCb, failCb) { //json为vvipInfo
        tenvideoReady(function() {
            //getPayVip(function(json) {
            if (json.visitor && json.visitor.vip == 1) { //游客VIP隐藏
                $(".js_open_renew").css("display", "none");
            } else if (json.vip == 1) {
                getRenewTag(json, function(json_renew) {
                    if (json_renew && json_renew.result.code == 0) {
                        var isAutoPay = json_renew.autopay;
                        if (json_renew.forcehide && json_renew.forcehide == 1) {
                            $(".js_open_renew").css("display", "none");
                            saveRenewData(2);
                        } else if (json_renew.servicetype && json_renew.servicetype == "HLWHF" && !!json_renew.vip) { //话费VIP
                            $(".js_open_renew").css("display", "block");
                            $(".js_open_renew").html("退订话费包月&nbsp;&gt;");
                            $(".js_open_renew").attr("data-open-renew", "hlwhf");
                            $(".js_open_renew").attr("hottag", reportConf_hottag.userInfo_renew + "_after");
                            //曝光上报
                            if (!g_hasRenewReport) {
                                g_hasRenewReport = true;
                                var hotTag = $(".js_open_renew").attr("hottag");
                            }
                        } else {
                            $(".js_open_renew").css("display", "block");
                            $(".js_open_renew").attr("data-open-renew", "autopay");
                            saveRenewData(isAutoPay);
                            suCb && suCb(isAutoPay);
                        }
                    }
                });
            } else {
                failCb && failCb();
            }
            /*}, function() {
                failCb && failCb();
            });*/
        });
    }

    function bindRenewData(isAutoRenew) {
        var statusHint = "";
        if ($('.js_open_renew').css("display") != "none") {
            if (isAutoRenew) {
                statusHint = "已开启自动续费&nbsp;&gt;";
                $(".js_open_renew").attr("hottag", reportConf_hottag.userInfo_renew + "_open");
            } else {
                statusHint = "管理自动续费&nbsp;&gt;";
                $(".js_open_renew").attr("hottag", reportConf_hottag.userInfo_renew + "_manage");
            }
            $(".js_open_renew").html(statusHint);
        }

        //曝光上报
        if (!g_hasRenewReport) {
            g_hasRenewReport = true;
            var hotTag = $(".js_open_renew").attr("hottag");
        }


    }

    function getRenewTag(json_cookie, suCb, failCb) {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        getDeviceInfo(function(json) {
            var guid = json.guid;
            var url = [normalizer("https://pay.video.qq.com/fcgi-bin/autopay?otype=json&platform="), platform, "&guid=", guid, "&versioncode=", appVersionBuild].join('');
            requestRenewTag(url, suCb, failCb);
        }, function() {
            var url = [normalizer("https://pay.video.qq.com/fcgi-bin/autopay?otype=json&platform="), platform, "&versioncode=", appVersionBuild].join('');
            requestRenewTag(url, suCb, failCb);
        });
    }

    function requestRenewTag(url, suCb, failCb) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getUserId() {
        getMainCookie(function(json_msg) {
            var str_cookie = json_cookie.cookie;
            var openid = "";
            if (json_cookie.type == 'wx') {
                openid = getCookieParam(str_cookie, "openid");
            } else if (json_cookie.type == 'qq') {
                openid = getCookieParam(str_cookie, "uin");
            }
        });
    }

    function isQQ2WXShow(isShow) {
        if (isShow) {
            $('.mod_shift_wx').show();
        } else {
            $('.mod_shift_wx').hide();
        }
    }

    function showTicketNum(ticketNum) {
        if (ticketNum != "") {
            $('.user_ticket').text(ticketNum);
            if (ticketNum <= 0) {
                $('.span_ticket').hide();
            } else {
                $('.span_ticket').show();
            }
        } else {
            $('.span_ticket').hide();
            $('.user_ticket').text('0');
        }
    }

    function userLoginModChk() {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") {
                $('.js_vip_pri_section').hide();
            } else {
                $('.js_vip_pri_section').show();
            }
        });
        getMainUserInfo(function(json) {
            var data = json.userInfo;
            var accountType = json.type;
            var uin = "";

            $('#user_icon').removeClass(); //icon hint
            if (data) {
                var defaultFace = "style/app_v/img/user/default_160.png";
                var nick = data.nickname;
                var face = data.headImgUrl ? data.headImgUrl : defaultFace;
                $('.user_face').attr('src', face);
                $('.user_nick').text(nick);
                if ("qq" == accountType) {
                    $('#user_icon').addClass("u_icon_qq");
                } else if ("wx" == accountType) {
                    $('#user_icon').addClass("u_icon_wx");
                }

                $('#user_level').removeClass();
                $('.js_user_vipinfo').hide();
                //showBindAccount();
                $('.mod_user_logout').hide();
                $('.js_mod_user_login').show();
            } else {
                showLoginMod();
            }
        }, function() {
            showLoginMod();
        });
    }

    function showBindAccount(endTime) {
        var endTime = endTime || '';
        getBindAccount(function(json_bind) {
            $('.js_user_vipinfo').hide();
            if (json_bind && json_bind.isVip == 1) {
                if (json_bind.bind_type == 'qq') {
                    $('.js_bind_account .js_account').text('QQ');
                } else {
                    $('.js_bind_account .js_account').text('微信');
                }
                $('.js_bind_account .acc_name').text(json_bind.account_id);
                $('.user_status').hide();
                $('.js_bind_account').show();
            } else {
                act_tips_notvip.init(endTime);
            }
        }, function() {
            act_tips_notvip.init(endTime);
        });
    }

    function getBindAccount(suCb, failCb) {
        $.ajax({
            url: normalizer("https://pay.video.qq.com/fcgi-bin/check_bindaccount?otype=json"),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function showLoginMod() {
        $('.mod_user_logout').show();
        $('.js_mod_user_login').hide();
        //$('.package_list .link_pay').text('开通');
        act_tips_notvip.init();
    }

    function shiftQQ2WXLoginChk() {
        isQQInstalled(function(json_msg) {
            var isInstalled = json_msg.installed;
            if (!isInstalled) {
                var timestamp = (new Date()).valueOf();
                var ptLoginChkSrc = ["https://film.qq.com/app/ptlogincheck.html?stamp=", timestamp].join('');
                createPtLoginChkFrame(ptLoginChkSrc);
                var backUrl = encodeURIComponent(location.toString());
                //consolelog(backUrl);
                var openPtLogin = ["https://film.qq.com/app/ptlogin.html?ru=", backUrl, "&stamp=", timestamp].join('');
                openUrl(openPtLogin, 1);
            } else {
                transformQQ2WX();
            }
        });
    }

    function transformQQ2WX() {
        qqVip2WXLogin(function(json_msg) {
            var cookieDate = json_msg.cookie;
            qqUin = getCookieParam(cookieDate, "uin");
            qqSkey = getCookieParam(cookieDate, "skey");
            var type = 1;
            var param = ["uin=", qqUin, "&skey=", qqSkey, "&type=", type].join('');
            //show loading
            showLoading(true);
            shiftQQVip2WX(param, function(json_shift) {
                qqVipShiftInfo = json_shift;
                storage.setItem("hlw_qq_shift_info", JSON.stringify(json_shift));
                //storage.setItem("hlw_qq_shift_cookie_info",JSON.stringify(json_msg));
                var wxAccount = json_msg.wx;
                var qqAccount = json_msg.qq;
                var SHIFT_INFO = {};
                SHIFT_INFO.uin = qqUin;
                SHIFT_INFO.skey = qqSkey;
                var defaultFace = "style/app_v/img/user/default_160.png";
                SHIFT_INFO.qq = {
                    "nickname": qqAccount.nickname ? qqAccount.nickname : qqAccount.nickName,
                    "headImgUrl": qqAccount.headImgUrl ? qqAccount.headImgUrl : defaultFace
                };
                SHIFT_INFO.wx = {
                    "nickname": wxAccount.nickname ? wxAccount.nickname : wxAccount.nickName,
                    "headImgUrl": wxAccount.headImgUrl ? wxAccount.headImgUrl : defaultFace
                };
                storage.setItem("hlw_qq_shift_cookie_info", JSON.stringify(SHIFT_INFO));
                setTimeout(function() {
                    showLoading(false);
                    openUrl("shift.html", 1);
                }, 100);

            }, function(json_shift_err) {
                showLoading(false);
                if (json_shift_err) {
                    var errCode = json_shift_err.result.code;
                    var msg = getErrMsg(errCode, getUin(qqUin));
                    showErrToast(msg);
                } else {
                    showErrToast(NETWOKR_ERR);
                }

            });
        }, function(json_err) {
            showLoading(false);
        });
    }

    function shiftFromPt(uin, skey) {
        var type = 1;
        var param = ["uin=", uin, "&skey=", skey, "&type=", type].join('');
        showLoading(true);
        shiftQQVip2WX(param, function(json_shift) {
            storage.setItem("hlw_qq_shift_info", JSON.stringify(json_shift));
            //storage.setItem("hlw_qq_shift_cookie_info",JSON.stringify(json_msg));
            getShiftInfo(uin, skey, function(shift_info) {
                storage.setItem("hlw_qq_shift_cookie_info", JSON.stringify(shift_info));
            });
            setTimeout(function() {
                showLoading(false);
                openUrl("shift.html", 1);
            }, 200);

            setTimeout(function() {
                removePtLoginChkFrame();
            }, 100);

        }, function(json_shift_err) {
            showLoading(false);
            if (json_shift_err) {
                var errCode = json_shift_err.result.code;
                var msg = getErrMsg(errCode, getUin(qqUin));
                showErrToast(msg);
            } else {
                showErrToast(NETWOKR_ERR);
            }

        });
    }

    function removeOrderCacheData() {
        getMainCookie(function(json_user) {
            var cookieStr = json_user.cookie;
            var accountType = json_user.type;
            var uid = "";
            if (json_user.type == 'wx') {
                uid = getCookieParam(cookieStr, "openid");
            } else if (json_user.type == 'qq') {
                uid = getCookieParam(cookieStr, "uin");
            }
            if (uid) {
                var key = ["order_", uid].join('');
                storage.removeItem(key);
            }
        });
    }

    function saveWXFakeData(data) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                storage.setItem(key, data);
            }
        });
    }

    function removeWXFakeData() {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                if (storage.getItem(key)) {
                    storage.removeItem(key);
                }
            }
        });
    }

    function getWXFakeData(suCb, failCb) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                if (storage.getItem(key)) {
                    var data = JSON.parse(storage.getItem(key));
                    suCb && suCb(data);
                } else {
                    failCb && failCb();
                }
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }


    function getShiftInfo(uin, skey, sucCb, failCb) {
        var d_wx = $.Deferred();
        var d_qq = $.Deferred();
        $.when(d_wx, d_qq).done(function(json_wx, json_qq) {
            log('wx:' + JSON.stringify(json_wx));
            log('qq:' + JSON.stringify(json_qq));
            var SHIFT_INFO = {};
            SHIFT_INFO.uin = uin;
            SHIFT_INFO.skey = skey;
            var defaultFace = "style/app_v/img/user/default_160.png";
            SHIFT_INFO.qq = {
                "nickname": json_qq.nick,
                "headImgUrl": json_qq.qqface ? json_qq.qqface : defaultFace
            };
            var wxAccount = json_wx.userInfo;
            SHIFT_INFO.wx = {
                "nickname": wxAccount.nickname,
                "headImgUrl": wxAccount.headImgUrl ? wxAccount.headImgUrl : defaultFace
            };
            sucCb && sucCb(SHIFT_INFO);
        });
        getQQNick(skey, function(json) {
            d_qq.resolve(json);
        }, function() {
            d_qq.resolve();
        });
        getMainUserInfo(function(json) {
            d_wx.resolve(json);
        }, function() {
            d_wx.resolve();
        });
    }

    function createPtLoginChkFrame(src) {
        $('.app_container').after($("<iframe width='0' height='0' id='ptLoginStorageFrame' scrolling='no' frameborder='0'></iframe>"));
        $("#ptLoginStorageFrame").attr("src", src);
    }

    function removePtLoginChkFrame() {
        $("#ptLoginStorageFrame").remove();
    }

    function bindVipData(json_vip) {
        $('#user_level').removeClass();
        if (json_vip.annualvip == 1) {
            $('#user_level').addClass('u_icon_vip_year');
        } else {
            $('#user_level').addClass('u_icon_vip');
        }
        $('#user_level').addClass(['vip_', json_vip.level].join(''));
        $('.user_vip_level').text(json_vip.level);
        $('.user_score').text(json_vip.score);
        $('.user_expire').text(json_vip.endTime.substr(0, 10));
        $('.user_upgrade').text(json_vip.score);
        //$('.package_list .link_pay').text('续费');
    }

    function getErrMsg(errCode, uin) {
        var errMsg = ["内部错误(错误码:", errCode, ")。"].join('');
        if (errCode == "-11") {
            errMsg = "系统繁忙，请退出并重新登录后再次尝试。";
        } else if (errCode == "10001") {
            errMsg = ["QQ号", uin, "已转移过VIP会员，不能再次转移。"].join('');
        } else if (errCode == "10002") {
            errMsg = "wx没有转移权限。";
        } else if (errCode == "10003") {
            errMsg = "系统繁忙，请稍候重试。";
        } else if (errCode == "11007") {
            errMsg = ["QQ号", uin, "未开通VIP会员，无法转移。"].join('');
        } else if (errCode == "11012") {
            errMsg = "暂时不支持后付费用户转移";
        } else if (errCode == "11013") {
            errMsg = "超过时间范围";
        }
        return errMsg;
    }

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function time33(skey) {
        // 哈希time33算法
        for (var i = 0, len = skey.length, hash = 5381; i < len; ++i) {
            hash += (hash << 5) + skey.charAt(i).charCodeAt();
        };
        return hash & 0x7fffffff;
    }

    function getToken(skey) {
        return time33(skey);
    }

    function getQQNick(skey, sucCb, failCb) {
        $.ajax({
            url: normalizer("https://c.video.qq.com/cgi-bin/login?otype=json&nes=1&low_login=1&callback=jsonp"),
            data: {
                g_tk: getToken(skey)
            },
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {
                    sucCb && sucCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getPricePerMonth(itemStr) {
        var priceStr = "";
        var price = "";
        var retArray = itemStr.split("月");
        if (retArray.length > 1) {
            priceStr = retArray[1];
        } else {
            priceStr = itemStr;
        }
        if (priceStr) {
            price = parseInt(priceStr.replace(/[^0-9]/g, ""), 10);
        }
        return price;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function saveRenewData(data) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            var uid = "";
            if (json_msg.type == 'wx') {
                uid = getCookieParam(str_cookie, "openid");
            } else if (json_msg.type == 'qq') {
                uid = getCookieParam(str_cookie, "uin");
            }
            if (uid) {
                var key = ["app_hlw_user_renew_", uid].join('');
                storage.setItem(key, data);
            }
        });
    }

    function getRenewData(suCb, failCb) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            var uid = "";
            if (json_msg.type == 'wx') {
                uid = getCookieParam(str_cookie, "openid");
            } else if (json_msg.type == 'qq') {
                uid = getCookieParam(str_cookie, "uin");
            }
            if (uid) {
                var key = ["app_hlw_user_renew_", uid].join('');
                if (storage.getItem(key)) {
                    var data = JSON.parse(storage.getItem(key));
                    suCb && suCb(data);
                }
            }
        });
    }

    function initVipSectionPos(isVip) {
        var movieListSection = $(".js_movie_wrapper");
        var vipActDom = $('.js_vip_act_section');
        var vipPriDom = $('.js_vip_pri_section');
        if (isVip == "1") {
            movieListSection.before(vipActDom);
            movieListSection.after(vipPriDom);
        } else {
            movieListSection.before(vipPriDom);
            movieListSection.after(vipActDom);
        }
    }

    function bindLayout(isVip) {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") { //审核期间屏蔽等级特权相关展示
                $('.js_vip_pri_section').hide();
            } else {
                $('.js_vip_pri_section').show();
                if (bindFlag != isVip) {
                    storage.setItem("hlw_user_status", isVip);
                    initVipSectionPos(isVip);
                    bindFlag = isVip;
                }
                //置顶红包活动，为了开通后返回该页面能立刻刷新
                if (isVip == "1") {
                    vipActivity.init(true);
                } else {
                    vipActivity.init(false);
                }
            }
        });
    }

    function initAgioTag() {
        agioTagRequest(function(json) {
            var items = json.items;
            var itemLength = items.length;
            if (itemLength > 0) {
                var confItem = items[0];
                if (confItem && confItem.price) {
                    getAgioRequest(function(json) {
                        bindAgioData(confItem.price, json);
                    }, function() {
                        //未登录显示购剧入口
                        var container = $(".js_Agio_tag .txt_info");
                        container.html('<span class="num">' + confItem.price + '</span>元看剧');
                        $(".js_Agio_tag").attr("data-id", "order");
                        $(".js_Agio_tag").attr("hottag", "hlw_app_open_package_kanju");
                        $(".js_Agio_tag").show();
                    });
                }
            } else {
                //consolelog("no config");
            }
        }, function() {
            //consolelog("agioTagRequest failed");
        });
    }

    function agioTagRequest(suCb, failCb) {
        $.ajax({
            url: normalizer("https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=2113&otype=json"),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    //补差价开通VIP
    function getAgioRequest(suCb, failCb) {
        $.ajax({
            //TODO::test url
            url: normalizer("https://pay.video.qq.com/fcgi-bin/common_cgi?cgiid=38&cginame=agio_info&otype=json"),
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function bindAgioData(price, json) {
        var container = $(".js_Agio_tag .txt_info");
        var data = json.extend.agio;
        var htmlContent = "";
        if (data.can_agio == 1) { //补差价开通
            var diff_price = data.agio_money / 100;
            htmlContent = ['购剧专享：加<span class="num">', diff_price, '</span>元成为VIP会员'].join('');
            $(".js_Agio_tag").attr("data-id", "open");
            $(".js_Agio_tag").attr("hottag", "hlw_app_open_package_bujia");
            if (isIos) {
                getAppInfo(function(json_app) {
                    if (json_app.isJBOS == 1) {
                        container.html(htmlContent);
                        $(".js_Agio_tag").show();
                    } else {
                        utils.getIapType(function(json_iap) {
                            if (json_iap.useh5 == 1) {
                                container.html(htmlContent);
                                $(".js_Agio_tag").show();
                            } else {
                                htmlContent = '<span class="num">' + price + '</span>元看剧';
                                container.html(htmlContent);
                                $(".js_Agio_tag").attr("data-id", "order");
                                $(".js_Agio_tag").attr("hottag", "hlw_app_open_package_kanju");
                                $(".js_Agio_tag").show();
                            }
                        });
                    }
                });

            } else {
                container.html(htmlContent);
                $(".js_Agio_tag").show();
            }
        } else { //购买
            if (data.isvip == "0") {
                htmlContent = '<span class="num">' + price + '</span>元看剧';
                container.html(htmlContent);
                $(".js_Agio_tag").attr("data-id", "order");
                $(".js_Agio_tag").attr("hottag", "hlw_app_open_package_kanju");
                $(".js_Agio_tag").show();
            } else {
                $(".js_Agio_tag").hide();
            }
        }
    }

    function isOverseasRequest(suCb, failCb) {
        $.ajax({
            url: normalizer("https://vv.video.qq.com/checktime?_t=1&otype=json"),
            dataType: "jsonp",
            success: function(json) {
                if (json) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function initOverseasTag() {
        if (storage.getItem("isOverseas")) {
            isOverseas = storage.getItem("isOverseas");
        }
        isOverseasRequest(function(json) {
            if (json.limit == 1) {
                isOverseas = "yes";
            } else {
                isOverseas = "no";
            }
            storage.setItem("isOverseas", isOverseas);
        });

    }

    function openPayOverseas(param) {
        tenvideoReady(function() {
            $(".m_layer_mask").show();
            $(".js_overseas_layer").show();
            $('.js_overseas_buy').tap(function() {
                if ($('.js_overseas_layer').is(":visible")) {
                    $(".m_layer_mask").hide();
                    $(".js_overseas_layer").hide();
                    //TODO::pay
                    overseasPay(param, pay_tag);
                }
            });

            $('.js_overseas_cancel').tap(function() {
                if ($('.js_overseas_layer').is(":visible")) {
                    $(".m_layer_mask").hide();
                    $(".js_overseas_layer").hide();
                }
            });
        });

    }

    function overseasPay(param, tag) {
        if (tag == "agio") { //电视剧点播
            if ($('.js_Agio_tag').is(":visible")) {
                pay_sBIZ = "agio";
                bossReport();
                var linkTarget = param.target;
                var aid = getUrlParam('aid') || '';
                if (linkTarget == "open") { //已有订单，开通VIP
                    //TODO:: go open
                    openUrl(['https://film.qq.com/weixin/agio.html?aid=', aid].join(''), 1);
                } else if (linkTarget == "order") { //没有订单购买页面
                    //TODO:: go order
                    openUrl(['https://film.qq.com/weixin/tvlist.html?aid=', aid].join(''), 1);
                }
            }
            return false;
        } else if (tag == "month") { //开包月
            reportPay(param);
            pay_sBIZ = "package";
            bossReport();
            if (isIos) {
                if (useh5pay) {
                    isAccountLogin(function(json_login) {
                        goH5Pay(param);
                    }, function() {
                        TenvideoJSBridge.invoke("actionLogin", {
                            "type": "tv"
                        }, function(json_msg) {
                            log("actionLogin:" + json_msg);
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {}
                        });
                    });
                } else {
                    if (g_isJBOS && isNewSdkVersion()) { //越狱手机单独传递参数
                        param.sdkpay = 1;
                        var appid = "";
                        getMainCookie(function(json_cookie) {
                            var cookieStr = json_cookie.cookie;
                            if ("wx" == json_cookie.type) {
                                if (g_pay_wx_offerId.length > 0) {
                                    appid = g_pay_wx_offerId;
                                } else {
                                    appid = wx_offerid;
                                }
                            } else if ("qq" == json_cookie.type) {
                                if (g_pay_qq_offerId.length > 0) {
                                    appid = g_pay_qq_offerId;
                                } else {
                                    appid = qq_offerid;
                                }
                            }
                            param.appid = appid;
                            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                                var json = JSON.parse(json_msg);
                                if (json.errCode == 0) {} else {}
                            });

                        });
                    } else {
                        TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {} else {}
                        });

                    }

                }

            } else {
                openPayAndroid(param);
            }
            return false;
        } else if (tag == "serialPay") { //自动续费
            goSerialPay(param, true);
            return false;
        }
    }


    function showLoading(isShow) {
        var delay = 0;
        if (!isShow) {
            delay = 100;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);
    }

    function openUrl(url, style, callback) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        var param = {
            url: normalizer(url),
            style: style
        };
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", param, function(json_msg) {
                    callback && callback();
                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function openUrlBySdk(url, style, mode) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }

        //签约添加参数
        //currentJumpURL_Mode: "1"
        var param = {
            url: url,
            style: style,
            currentJumpURL_Mode: mode
        };

        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", param, function(json_msg) {

                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }


    /**
     * @description 获得相对路径的绝对路径
     * @param {string} url 相对路径
     **/
    function getAbsoluteUrl(url) {
        var div = document.createElement('div');
        div.innerHTML = ['<a href=', url, '></a>'].join('');
        return div.firstChild.href;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.index', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.index', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.index', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = [normalizer("https://btrace.qq.com/collect?&sIp="),
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }

    /**
     * 支付上报
     * @param open_uin 真正开通VIP的qq号
     * @param step  支付进行到的步骤 1：打开支付浮层 2：选择支付渠道 3：开始下单 4：下单结束 5：点击支付 6：支付完成 7：取消支付
     * @param type  支付模式 1：包月支付 2：单片云支付 3：单片券支付 4：好莱坞minipay支付
     * @param paychannel 支付渠道 5：网银 119：q币 126：快捷支付 130：微信支付 129：iap支付
     * @param payitem 支付内容 包月：n*天数  n取值 1:未勾选自动续费，3：勾选了自动续费 例如：1*31 单点：数量*专辑id 例如：1*xj5negx6nzsfmj4
     * @param plat 支付平台 web：0或者1 客户端：2 ipad：5 apad：6 iphone：7 aphone：8 wphone：9 TV：10 wpad：11 H5 iphone：107 H5 aphone：108
     * @param url 支付页面地址
     */
    function reportPay(payParam) {
        try {
            var accountType = "";
            var pay_uin = "";
            var openid = "";
            var appid = "";
            var type = 1;
            var step = 1;
            var days = payParam.month * 31 || payParam.day;
            var ap = payParam.ap;
            var renew = 1;
            if (ap == 1) {
                renew = 3;
            }
            var payitem = "" + renew + "*" + days;
            isAccountLogin(function() {
                getMainCookie(function(json_msg) {
                    if (json_msg) {
                        var str_cookie = json_msg.cookie;
                        if (json_msg.type == 'wx') {
                            if (g_isVisitorVip) {
                                accountType = 3;
                            } else {
                                accountType = 2;
                            }
                            openid = getCookieParam(str_cookie, "openid");
                            appid = getCookieParam(str_cookie, "appid");
                        } else if (json_msg.type == 'qq') {
                            if (g_isVisitorVip) {
                                accountType = 3;
                            } else {
                                accountType = 1;
                            }
                            pay_uin = getCookieParam(str_cookie, "uin");
                        }
                        reportQA(pay_uin, openid, appid, type, accountType, payitem, step, payParam);
                    }
                });
            }, function() {
                if (isIos) {
                    accountType = 3;
                    reportQA(pay_uin, openid, appid, type, accountType, payitem, step, payParam);
                }
            });

        } catch (ex) {}
    }

    function reportQA(pay_uin, openid, appid, type, accounttype, payitem, step, payParam) {
        var url = normalizer("https://pay.video.qq.com/fcgi-bin/payreport?otype=json");
        var guid = "";
        var plat = 7;
        var appBuildVerion = "";
        var aid = payParam.aid || decodeURIComponent(getUrlParam('aid'));
        if (isAndroid) {
            plat = 8;
            appBuildVerion = getAppVersionBuild();
        }
        var reportCgi = [url,
            "&pay_uin=", getUin(pay_uin),
            "&openid=", openid,
            "&appid=", appid,
            "&type=", type,
            "&accounttype=", accounttype,
            "&payitem=", payitem,
            "&step=", step,
            "&plat=", plat,
            "&versioncode=", appBuildVerion,
            "&aid=", aid
        ].join('');
        getDeviceInfo(function(json) {
            guid = json.guid;
            reportCgi = [reportCgi, "&guid=", guid].join('');
            reportQARequest(reportCgi);
        }, function() {
            reportQARequest(reportCgi);
        });
    }

    function reportQARequest(url) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {} else {}
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }

    function filterXSS(str) {
        return str.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\'/g, "&apos;");
    }

    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function removeQueryParam(sourceURL, key) {
        var rtn = sourceURL.split("?")[0],
            param,
            params_arr = [],
            queryString = (sourceURL.indexOf("?") !== -1) ? sourceURL.split("?")[1] : "";
        if (queryString !== "") {
            params_arr = queryString.split("&");
            for (var i = params_arr.length - 1; i >= 0; i -= 1) {
                param = params_arr[i].split("=")[0];
                if (param === key) {
                    params_arr.splice(i, 1);
                }
            }
            rtn = rtn + "?" + params_arr.join("&");
        }
        return rtn;
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }

            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function version() {
        try {
            $.getJSON("info.json", function(data) {
                console.info(["packageId:", data.packageId, " version:", data.version].join(''));
            });
        } catch (ex) {}
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }

    function consolelog(txt) {
        var url = normalizer("https://film.qq.com/weixin/?log=") + txt;
        $.get(url);
    }

    function bossReport() {
        try {
            var aid = decodeURIComponent(getUrlParam('aid'));
            if (!aid) {
                aid = ['V0$$1:0$2:7$3:', json_app.buildVersion, '$11:6'].join('');
            }
            var part = aid.split("$$");
            if (part.length > 1) {
                var sVersion = part[0];
                var keyPart = part[1].split('$');
                var keyMap = {};
                $.each(keyPart, function(idx, value) {
                    var data = value.split(':');
                    if (data.length == 2) {
                        keyMap[reportMap["key" + data[0]]] = data[1];
                    }
                });
                getMainCookie(function(json_user) {
                    var cookieStr = json_user.cookie;
                    var accountType = json_user.type;
                    var uin = "";
                    var openid = "";
                    var appid = "";
                    var logintype = "";
                    if (json_user.type == 'wx') {
                        logintype = "wx";
                        openid = getCookieParam(cookieStr, "openid");
                        appid = getCookieParam(cookieStr, "appid");
                    } else if (json_user.type == 'qq') {
                        logintype = "qq";
                        uin = getCookieParam(cookieStr, "uin");
                    }
                    (bossReporter.report_action($.extend({
                        aid: aid,
                        sOp: "confirm",
                        sBiz: pay_sBIZ,
                        iQQ: getUin(uin),
                        aid_version: sVersion,
                        openid: openid,
                        appid: appid,
                        logintype: logintype
                    }, keyMap))());
                });

            }
        } catch (ex) {}
    }

    function getDefaultAid() {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var aidDefault = ['V0$$1:0$2:', platform, '$3:', getAppVersion(), '$11:6'].join('');
        return aidDefault;
    }

    function getDefaultPrice(callback) {
        try {
            $.getJSON("./js/price_default.json", function(data) {
                callback && callback(data);
            });
        } catch (ex) {}
    }

    function isNewSdkVersion() {
        var isNew = false;
        if (isIos && utils.versionCompare(appVersion, "4.5.5")) {
            isNew = true;
        } else if (isAndroid && utils.versionCompare(appVersion, "4.6.0")) {
            isNew = true;
        }
        return isNew;
    }

    function addCheckVersionPayDom(data, verType) {
        if (isIos) {
            var tpl = '';
            for (var i = 0, l = data.length; i < l; i++) {
                var item = data[i];
                tpl += '<li class="js_vertype_package">';
                tpl += '<div class="txt_info">';
                tpl += '<span class="txt">' + item.product_desc + '<span class="num">' + item.price + '</span>元</span>';
                if (item.icon_desc) {
                    tpl += '<span class="mark_flag">' + item.icon_desc + '</span>';
                }
                tpl += '</div>';
                tpl += '<a class="link_info link_pay" href="javascript:;" title="开通" data-amount="' + item.amount + '" data-id="' + item.product_id + '" data-month-price="' + item.price + '" data-pay-type="' + item.type + '"  data-single-price="' + item.single_price + '"><span class="txt">开通</span></a>';
                tpl += '</li>';
            }
            var $verType_package = $('.js_package_list').find('.js_vertype_package');
            if (verType == 1) {
                if ($verType_package.length > 0) {} else {
                    $('.js_package_list').prepend(tpl);
                }
            } else {
                $verType_package.remove();
            }
        }
    }

    function initVertypePackage() {
        getAppInfo(function(json_app) {
            var vertype = 0;
            if (json_app.isinreview == 1) {
                vertype = 1;
            }
            // vertype = 1;
            if (appVersion >= "4.5.5") {
                try {
                    $.getJSON("./js/price_check_version.json", function(data) {
                        addCheckVersionPayDom(data, vertype);
                    });
                } catch (ex) {}
            }
        });
    }

    //连续包月入口显示：暂时屏蔽iphone
    function initSerialPacDom(isVip, productPackage) {
        if (isNewSdkVersion()) { //新版sdk后支持连续包月
            var serialPriceLi = "";
            utils.getSerialPayConf(useh5pay).done(function(serailPay_conf) {
                var $verType_package = $('.js_package_list').find('.js_serial_package');
                var sel_item = "";
                for (var i = 0; i < serailPay_conf.length; i++) {
                    var item = serailPay_conf[i];
                    if (item.enable == 1) {
                        sel_item = item;
                    }
                    break;
                }
                if (sel_item) {
                    serialPriceLi = renderSerialPayDom(isVip, sel_item);
                }
                serialPriceLi += productPackage;
                if (serialPriceLi) {
                    ads.init(function(hasAd) {
                        $('.js_package_list').html(serialPriceLi);
                        if (!hasAd) {
                            highlightPackage();
                        }
                        showPage();
                        $(document).trigger("package_ready"); //通知成长值升级动画
                    });
                }
            }).fail(function(err) {
                if (err && err.hasAuth == false) {
                    serialPriceLi += productPackage;
                } else {
                    var $verType_package = $('.js_package_list').find('.js_serial_package');
                    serialPriceLi = renderSerialPayDom(isVip);
                    serialPriceLi += productPackage;
                }
                ads.init(function(hasAd) {
                    if (serialPriceLi) {
                        $('.js_package_list').html(serialPriceLi);
                    }
                    if (!hasAd) {
                        highlightPackage();
                    }
                    showPage();
                    $(document).trigger("package_ready"); //通知成长值升级动画
                });
            });
        }
    }

    function renderSerialPayDom(isVip, serialDom) {
        var btnHint = "开通";
        if (isVip) {
            btnHint = "续费";
        }
        var qq_offerid_default = "1450005771";
        var wx_offerid_default = "1450002788";
        if (isIos && !useh5pay) {
            qq_offerid_default = "com.tenvideoios.auto.qq1"; //同iphone 的QQ_productid
            wx_offerid_default = "com.tenvideoios.auto.qq1"; //同iphone 的wx_productid
        }
        var serial_dom = '<li class="js_serial_package">\
                            <div class="txt_info">\
                                <span class="txt">连续包月<span class="num">15</span>元</span>\
                                <span class="ori_price">30元</span>\
                            </div>\
                            <div class="txt_tips">\
                                <a class="link link_color1" href="javascript:;" >尊享15元/月自动续费，可以随时取消</a>\
                            </div>\
                            <a class="link_info js_link_paySerial" href="javascript:;" title="' + btnHint + '" data-qq-offerid="' + qq_offerid_default + '" data-wx-offerid="' + wx_offerid_default + '" hottag="' + reportConf_hottag.openPay_hvipMonth_serial + '"><span class="txt">' + btnHint + '</span></a>\
                        </li>';
        //为了防止iphone显示问题，所以就先不设置默认显示了
        if (isIos) {
            serial_dom = "";
        }
        if (serialDom) {
            var title = serialDom.title;
            var price = serialDom.price;
            var ori_price = serialDom.ori_price;
            var icon_tips = serialDom.icon_tips;
            var sec_title = serialDom.sec_title;
            var qq_offerid = serialDom.qq_offerid || "1450005771"; //同iphone 的QQ_productid
            var wx_offerid = serialDom.wx_offerid || "1450002788"; //同iphone 的wx_productid
            if (isIos && !useh5pay) {
                qq_offerid = serialDom.qq_offerid || "com.tenvideoios.auto.qq1"; //同iphone 的QQ_productid
                wx_offerid = serialDom.wx_offerid || "com.tenvideoios.auto.qq1"; //同iphone 的wx_productid
            }
            var product_id = serialDom.productId_visitor || "com.tenvideoios.auto.yk1"; //iphone 游客_productid
            var ori_price_dom = "";
            if (ori_price && ori_price > 0) {
                ori_price_dom = '<span class="ori_price">' + ori_price + '元</span>';
            }
            $('.js_serial_pay_price').html(price);
            serial_dom = '<li class="js_serial_package">\
                            <div class="txt_info">\
                                <span class="txt">' + title + '<span class="num">' + price + '</span>元</span>' + ori_price_dom + '<span class="mark_flag">' + icon_tips + '</span>\
                            </div>\
                            <div class="txt_tips">\
                                <a class="link link_color1" href="javascript:;">' + sec_title + '</a>\
                            </div>\
                            <a class="link_info js_link_paySerial" href="javascript:;" title="' + btnHint + '" data-qq-offerid="' + qq_offerid + '" data-wx-offerid="' + wx_offerid + '" data-productId-visitor="' + product_id + '" data-price="' + price + '" hottag="' + reportConf_hottag.openPay_hvipMonth_serial + '" f_resource="' + title + '"><span class="txt">' + btnHint + '</span></a>\
                        </li>';

        }
        return serial_dom;
    }

    function highlightPackage() {
        if ($('.js_serial_package').length > 0) {
            $('.js_serial_package').addClass('item_hl');
        }
    }

    function goSerialPay(param, isPass) {
        isPass = isPass || false;
        if (isOverseas == "yes" && !isPass) {
            pay_tag = "serialPay";
            openPayOverseas(param);
            return;
        }
        param.isSerial = "1";
        getAppInfo(function(json_app) {
            var appInfo_param = {};
            appInfo_param.appInfo = json_app;
            appInfo_param.isSerial = "1";
            appInfo_param.isPay = "1";
            var aid = aidApi.init(appInfo_param);
            param.aid = aid;
            $.extend(param, appInfo_param);
            goPayLink(param);
        });
    }



    //退出登录操作
    function logoutClear() {
        //清除头像
        $('.user_face').attr('src', 'style/app_v/img/user/default_160.png');
        $('.js_bind_account').hide();
        bindLayout("0");
        $('.js_taocan_hint').text('VIP套餐');
        g_isVisitorVip = false;
        if (storage.getItem("hlw_renew_show_flag")) {
            storage.removeItem("hlw_renew_show_flag");
        }
        isVipReport = false;
        g_hasRenewReport = false;
        g_isDefaultPrice = false;
        $(".js_open_renew").html("");
        $(".js_coupon_list").html("");
        vipProperty.clearProperty();
        vipGrowth.clearLogout();
        friendsRank.hideFriends();
        iosPaySvip.logoutClear();
        message.hide();
    }

    //获取是否是审核版本
    function isInreviewVer(callback) {
        if (isIos) {
            TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
                var json = JSON.parse(json_msg);
                var vertype = 0;
                if (json.errCode == 0) {
                    if (json.result.isinreview == 1) {
                        vertype = 1;
                    } else {
                        vertype = 0;
                    }
                    callback && callback(vertype);
                } else { //失败了按审核版本走
                    vertype = 1;
                    callback && callback(vertype);
                }
            });
        } else {
            callback && callback();
        }
    }
    //兑换入口iphone审核版本要隐藏
    function initCDKshow() {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") {
                $('.js_duihuan_link').hide();
            } else {
                //if (isAndroid) {
                $('.js_duihuan_link').addClass('mod_more_2link');
                $('.js_act_gift').show();
                //}
                $('.js_duihuan_link').show();
            }
        });
    }
    //常见问题入口iphone审核版本要隐藏
    function initQAshow() {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") {
                $('.js_que_link').hide();
            } else {
                $('.js_que_link').show();
            }
        });
    }

    //ipohne 连续包月开通操作
    function _ios_serial_iapPay(param, accountType) {
        utils.isInreviewVer(function(verType) {
            if (verType == "1") {
                $('.js_ios_serialpayProtocol_layer').removeClass("none");
                $('.m_layer_mask').show();
                $('.js_ios_serialpayProtocol_ok').unbind("click").bind("click", function() {
                    $('.js_ios_serialpayProtocol_layer').addClass("none");
                    $('.m_layer_mask').hide();
                    TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {} else {}
                    });
                });
                $('.js_ios_serialpayProtocol_no').unbind("click").bind("click", function() {
                    $('.js_ios_serialpayProtocol_layer').addClass("none");
                    $('.m_layer_mask').hide();
                });
                $('.js_ios_serialpayProtocol_check').unbind("click").bind("click", function() {
                    $('.js_ios_serialpayProtocol_layer').addClass("none");
                    $('.m_layer_mask').hide();
                    openUrl('https://film.qq.com/weixin/term.html#serialpay', 1);
                });
                $('.js_ios_privacy_check').unbind("click").bind("click", function() {
                    $('.js_ios_serialpayProtocol_layer').addClass("none");
                    $('.m_layer_mask').hide();
                    openUrl('https://m.v.qq.com/about/privacy-policy.html', 1);
                });
            } else {
                utils.getMainUserInfo(function(json) {
                    var userInfo = json.userInfo;
                    //先判断用户是否已经开启连续包月
                    _iapSerialCheckPay(param, userInfo, accountType);
                }, function() {
                    TenvideoJSBridge.invoke("actionLogin", {
                        "type": "tv"
                    }, function(json_msg) {
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {
                            var account = "";
                            if (json && json.result && json.result.type) {
                                account = json.result.type;
                            }
                            storage.setItem("vip_serial_pay_click", "vip_serial_pay_click");
                            storage.setItem("vip_serial_pay_account", account);
                            storage.setItem("vip_serial_pay_param", JSON.stringify(param));
                        }
                    });
                });
            }
        });
    }

    function _iapSerialCheckPay(param, userInfo, accountType) {
        utils.getAutoPayTag().then(function(autopay) {
            $(document).undelegate('#toast_confirm .js_toast_confirm', 'click');
            $(document).delegate('#toast_confirm .js_toast_confirm', 'click', function(event) {
                $("#toast_confirm").hide();
                $('.m_layer_mask').hide();
            });
            if (autopay.servicetype == "HLWHF") { //话费用户
                $("#toast_confirm .txt").html("您正在使用手机话费按月支付中，<br/>无需重复开通");
                $("#toast_confirm .js_toast_confirm").text("好的");
                $("#toast_confirm").show();
                $('.m_layer_mask').show();
            } else {
                if (autopay.iapserial) { //已开启过连续包月
                    $("#toast_confirm .txt").html("您已开通连续包月套餐，<br/>无需重复开通");
                    $("#toast_confirm .js_toast_confirm").text("好的");
                    $("#toast_confirm").show();
                    $('.m_layer_mask').show();
                } else {
                    _ios_serial_iapPay_cbk(param, userInfo, accountType);
                }
            }
        });
    }

    function _ios_serial_iapPay_cbk(param, userInfo, accountType) {
        var account_tip = "游客帐号";
        if (g_isVisitorVip) {
            account_tip = "游客帐号";
        } else if (userInfo) {
            var nick = userInfo.nickname;
            if ("qq" == accountType) {
                account_tip = ["QQ帐号", nick].join('');
            } else if ("wx" == accountType) {
                account_tip = ["微信帐号", nick].join('');
            }
        }
        $('.js_ios_serialpay_layer .js_serialpay_accouont').html(account_tip);
        $('.js_ios_serialpay_layer').removeClass("none");
        $('.m_layer_mask').show();
        $('.js_ios_serialpay_buy').unbind("click").bind("click", function() {
            $('.js_ios_serialpay_layer').addClass("none");
            $('.m_layer_mask').hide();
            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        });
        $('.js_ios_serialpay_cancel').unbind("click").bind("click", function() {
            $('.js_ios_serialpay_layer').addClass("none");
            $('.m_layer_mask').hide();
        });
    }

    function _iosSeiralPayLoginFinishCbk() {
        if (isIos) {
            utils.addTenvideoListener("onActionLoginFinish", function() {
                getPayVipRefresh();
                if (storage.getItem("vip_serial_pay_click")) {
                    var payParam = JSON.parse(storage.getItem("vip_serial_pay_param"));
                    var accountType = storage.getItem("vip_serial_pay_account");
                    storage.removeItem("vip_serial_pay_account");
                    storage.removeItem("vip_serial_pay_click");
                    storage.removeItem("vip_serial_pay_param");
                    utils.getMainUserInfo(function(json) {
                        var userInfo = json.userInfo;
                        _iapSerialCheckPay(payParam, userInfo, accountType);
                    }, function() {
                        TenvideoJSBridge.invoke("actionLogin", {
                            "type": "tv"
                        }, function(json_msg) {
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {}
                        });
                    });
                }
            });
        }
    }

    function showPage() { //套餐ready后展示页面
        $('.app_container').show();
        $('.g_container_loading').hide(); //价格接口返回展示页面
    }

});
