define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var PayVip = require('./common/payvip');

    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var g_importFlag = false;

    var package_discount = {
        "aphone_discount": [{
            "desc": "1个月20元",
            "month": "1",
            "id": "1100-1001",
            "code": "1100",
            "discount": "10"
        }, {
            "desc": "3个月45元(15元/月)",
            "month": "3",
            "id": "1100-1002",
            "code": "1100",
            "discount": "45"
        }, {
            "desc": "12个月198元(16.5元/月)",
            "month": "12",
            "id": "1100-1003",
            "code": "1100",
            "discount": "162"
        }],
        "iphone_discount": [{
            "desc": "25元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "5"
        }, {
            "desc": "60元(20元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "30"
        }, {
            "desc": "198元(16.5元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "162"
        }],
        "iphone_discount_break": [{
            "desc": "20元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "10"
        }, {
            "desc": "45元(15元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "45"
        }, {
            "desc": "198元(16.5元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "162"
        }]
    };

    var useh5pay = false;
    $(document).ready(function() {
        init();

        if (storage.getItem("app_hlw_user_discount")) {
            var discount = JSON.parse(storage.getItem("app_hlw_user_discount"));
            bindDiscount(discount);
        } else {
            if (isIos) {
                if (storage.getItem("app_info_isjbos")) {
                    var isjbos = storage.getItem("app_info_isjbos");
                    if (isjbos == 1) {
                        bindDiscount(package_discount.iphone_discount_break);
                    } else {
                        bindDiscount(package_discount.iphone_discount);
                    }
                } else {
                    bindDiscount(package_discount.iphone_discount);
                }
            } else {
                bindDiscount(package_discount.aphone_discount);
            }
        }

        $('.link_pay').tap(function() {
            var param = {
                month: $(this).attr('data-amount'),
                id: $(this).attr('data-id'),
                code: $(this).attr('data-code'),
                ap: 0
            };
            if (isAndroid) {
                var wx_id = $(this).attr('data-wx-id');
                var wx_code = $(this).attr('data-wx-code');
                param.wx_id = wx_id;
                param.wx_code = wx_code;
            }
            if (isIos) {
                if (useh5pay) {
                    //param.h5 = 1;
                    isAccountLogin(function(json_login) {
                        goH5Pay(param.month, param.ap);
                        //openPayH5(param);
                    }, function() {
                        TenvideoJSBridge.invoke("actionLogin", {
                            "type": "tv"
                        }, function(json_msg) {
                            //log("actionLogin:" + json_msg);
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {
                                //未登录的用户登录后先返回个人中心页面
                                //goH5Pay(param.month, param.ap);

                                //openPayH5(param);
                            }
                        });
                    });
                } else {
                    TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {} else {}
                    });
                }
            } else {
                /*TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                    var json = JSON.parse(json_msg);
                    //alert(JSON.stringify(json));
                    if (json.errCode == 0) {} else {}
                });*/
                openPayAndroid(param);
            }

            reportPay(param);
        });

        $('.btn_logout').tap(function() {
            TenvideoJSBridge.invoke("logout", null, function(json_msg) {
                var json = JSON.parse(json_msg);
                //alert(JSON.stringify(json));
                if (json.errCode == 0) {
                    removeWXFakeData();
                    if (storage.getItem("hlw_renew_show_flag")) {
                        storage.removeItem("hlw_renew_show_flag");
                    }

                } else {}
            });
        });

        $('.mod_card_list .card_item').tap(function() {
            //window.location.href = "https://pay.qq.com/h5/active/myservice.shtml";
            var url = "https://pay.qq.com/h5/active/myservice.shtml";
            openUrl(url, 1);
        });

        window.reload = function() {
            location.reload();
        };
        window.reinit = function() {
            init();
        };
    });

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function init() {
        tenvideoReady(function() {
            appCallBack();
        });

        if (isIos) {
            if (storage.getItem("app_info_isjbos") && storage.getItem("app_info_isjbos") == 1) {} else {
                tenvideoReady(function() {
                    getAppInfo(function(json_app) {
                        if (json_app.isJBOS == 0) {
                            getIapType(function(json_iap) {
                                if (json_iap.useh5 == 1) {
                                    getPayVip(function(json) {
                                        var isVisitorVip = false;
                                        if (json.result) {
                                            if (json.result.code == 0) {
                                                if (json.visitor && json.visitor.vip == 1) {
                                                    isVisitorVip = true;
                                                }
                                            }
                                        }
                                        if (!isVisitorVip) {
                                            useh5pay = true;
                                        } else {
                                            useh5pay = false;
                                        }
                                    });
                                } else {
                                    useh5pay = false;
                                }
                            });
                        }
                    });
                });
            }
        }
    }

    //只有页面加载时触发loading
    var lock = false;


    function appCallBack() {
        if (!lock) {
            lock = true;
            showLoading(true);
            loadData();
        }

        getMainUserInfo(function(json) {
            var data = json.userInfo;
            var accountType = json.type;
            var uin = "";
            $('#user_icon').removeClass(); //icon hint
            if (data) {
                var defaultFace = "style/app_v/img/user/default_160.png";
                var nick = data.nickname;
                var face = data.headImgUrl ? data.headImgUrl : defaultFace;
                $('.user_face').attr('src', face);
                $('.user_nick').text(nick);
                if ("qq" == accountType) {
                    $('#user_icon').addClass("u_icon_qq");
                    uin = data.uin;
                    //添加QQ登录下的自动续费管理入口
                    $('.mod_card_list').show();

                } else if ("wx" == accountType) {
                    $('#user_icon').addClass("u_icon_wx");
                    uin = data.openId;
                }
                report(uin);
            } else {
                report(0);
            }
        }, function() {
            report(0);
        });

        getPayVip(function(json) {
            if (json.result) {
                if (json.result.code == 0) {
                    var canImport = json.canImport;
                    var canImportFlag = false;
                    if (canImport) {
                        canImportFlag = true;
                    }
                    g_importFlag = canImportFlag;

                    $('.tip_dailyscore').show();
                    $('.tip_monthlyticket').show();
                    $('.div_expire').show();
                    $('#user_level').removeClass();
                    if (json.level >= 6) {
                        $('.tip_upgrade_top').show();
                        $('.tip_upgrade').hide();
                    } else {
                        $('.tip_upgrade_top').hide();
                        $('.tip_upgrade').show();
                    }
                    if (json.vip == 1) {
                        getMainCookie(function(json_cookie) {
                            var accountType = json_cookie.type;
                            if (accountType == "wx" && json.level <= 0) {
                                getWXFakeData(function(shiftInfo) {
                                    bindVipData(shiftInfo);
                                }, function() {
                                    bindVipData(json);
                                });
                            } else {
                                if (json.annualvip == 1) {
                                    $('#user_level').addClass('u_icon_vip_year');
                                    $('.mod_btn_list').hide(); //隐藏年费按钮
                                } else {
                                    $('#user_level').addClass('u_icon_vip');
                                }
                                $(['.grade_list .lv_', json.level].join('')).addClass('current');
                                $('#user_level').addClass(['vip_', json.level].join(''));
                                $('.user_vip_level').text(['LV', json.level].join(''));
                                var score = "0";
                                if (json.score > 0) {
                                    score = json.score;
                                }
                                $('.user_score').text(score);
                                if (json.servicetype == 'HLWHF') {
                                    $('.user_expire').text(json.endmsg);
                                } else {
                                    $('.user_expire').text(json.endTime.substr(0, 10));
                                }
                                $('.user_dailyscore').text(json.dailyscore);
                                var payvip = new PayVip(json);
                                $('.user_upgrade').text(payvip.levelUp());
                                $('.icon_down').hide();
                                $('.user_monthlyticket').text(payvip.tickets());

                                if (json.level > 0) {
                                    removeWXFakeData();
                                }
                            }
                        });

                    } else {
                        isAccountLogin(function(json_msg) {
                            var accountType = json_msg.type;
                            //fake data for wx,已经转移到wx但数据未转移完全
                            if ("wx" == accountType && !canImportFlag && json.score <= 0) {
                                getWXFakeData(function(shiftInfo) {
                                    bindVipData(shiftInfo);
                                }, function() {
                                    bindNotVip(json);
                                });

                            } else {
                                var level = "0";
                                if (json.level > 0) {
                                    $('#user_level').addClass(['u_icon_vip_lost vip_', json.level].join(''));
                                    level = json.level;
                                } else {
                                    $('#user_level').addClass('u_icon_vip_lost vip_0');
                                }
                                $('.user_vip_level').text(['LV', level].join(''));
                                if (json.score > 0) {
                                    $('.user_score').text(json.score);
                                    $('.user_dailyscore').text(json.dailyscore);
                                    $('.icon_down').show();
                                    var payvip = new PayVip(json);
                                    $('.user_upgrade').text(payvip.levelUp());
                                    $('.tip_upgrade').html(['<span class="user_upgrade">', payvip.degrade('days'), '</span>天后降级'].join(''));
                                    $('.user_monthlyticket').text('0');
                                } else {
                                    $('.user_score').text("0");
                                    $('.tip_upgrade').hide();
                                    $('.tip_dailyscore').hide();
                                    $('.tip_monthlyticket').hide();
                                }
                                $('.div_expire').hide();
                            }
                        });
                        //$('.div_expire').hide();
                    }
                } else {
                    userLoginModChk();
                }
            } else {
                userLoginModChk();
            }
        }, function() {
            userLoginModChk();
        });

        getTicketNum(function(json) {
            var ticketNum = 0;
            getWXFakeData(function(wxFakeInfo) {
                var fakeTicket = wxFakeInfo.ticket_count;
                if (json <= 0 && !g_importFlag) {
                    ticketNum = fakeTicket;
                } else {
                    ticketNum = json;
                }
                showTicketNum(ticketNum);
            }, function() {
                ticketNum = json;
                showTicketNum(ticketNum);
            });
        }, function() {
            $('.app_container').show();
            showLoading(false);
            setTimeout(function() {
                $('.app_loading').hide();
            }, 100);
        });
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq", "wx"]
        }, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            //alert(JSON.stringify(json));
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getTicketNum(suCb, failCb) {
        TenvideoJSBridge.invoke("getTicketNum", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            //alert(JSON.stringify(json));
            if (json.errCode == 0) {
                var num = json.result.num;
                suCb && suCb(num);
            } else {
                failCb && failCb();
            }
        });
    }

    function openPayH5(param) {
        TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {} else {}
        });
    }


    function goH5Pay(month, ap) {
        getAppInfo(function(json_app) {
            var aid = getUrlParam('aid');
            if (!aid) {
                aid = ['V0$$1:0$2:7$3:', json_app.buildVersion, '$11:6'].join('');
            } else {
                aid = decodeURIComponent(aid);
                if (aid.indexOf('$11:') == -1) {
                    if (json_app.isJBOS == 1) {
                        aid += '$11:4';
                    } else {
                        aid += '$11:6';
                    }
                }
            }

            var url = ['https://film.qq.com/app/pay.html?n=', month, '&ap=', ap, '&aid=', encodeURIComponent(aid)].join('');
            openUrl(url, 1);

            /*
            var ru = encodeURIComponent('https://film.qq.com/app/payback.html');
            getMainCookie(function(json_cookie) {
                var str_cookie = json_cookie.cookie;
                var url = '';
                if (json_cookie.type == 'wx') {
                    var openid = getCookieParam(str_cookie, "openid");
                    var access_token = getCookieParam(str_cookie, "access_token");
                    var appid = getCookieParam(str_cookie, "appid");
                    var productid = '1000';
                    if (month == 3) {
                        productid = '1001';
                    } else if (month == 12) {
                        productid = '1002';
                    }
                    url = ['https://pay.qq.com/h5/index.shtml?m=buy&c=TXSP&as=1&productid=', productid, '&ap=', ap, '&openid=', openid, '&openkey=', access_token, '&sessionid=hy_gameid&sessiontype=wc_actoken&wxAppid=wx68ff4e3ba9f84df4&wxAppid2=', appid, '&appid=&pf=wechat_wx-2001-wx-2011-hlw&hh=1&aid=', encodeURIComponent(aid)].join('');
                    url += ["&ru=", ru].join('');
                } else {
                    var uin = getUin(getCookieParam(str_cookie, "uin"));
                    url = ["https://pay.qq.com/h5/index.shtml?c=txsp&as=1&m=buy&showwxpaytitle=1&pf=2010&n=", month, "&u=", uin, "&ap=", ap, "&wxAppid=wx68ff4e3ba9f84df4", "&hh=1&aid=", encodeURIComponent(aid)].join('');
                    url += ["&ru=", ru].join('');
                }
                //url += "&sandbox=1";
                openUrl(url, 1);
            });
            */
        });
    }

    function openPayAndroid(param) {
        var appVersion = getAppVersion();
        if (appVersion >= "4.2.0") {
            isAccountLogin(function(json_login) {
                goH5Pay(param.month, param.ap);
            }, function() {
                TenvideoJSBridge.invoke("actionLogin", {
                    "type": "tv"
                }, function(json_msg) {
                    var json = JSON.parse(json_msg);
                    if (json.errCode == 0) {}
                });
            });

        } else {
            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        }
    }

    function getAppInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                storage.setItem("app_info_isjbos", json.result.isJBOS);
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }


    function getIapType(suCb, failCb) {
        //var d_login = $.Deferred();
        var d_app = $.Deferred();
        var d_cookie = $.Deferred();

        $.when(d_app, d_cookie).done(function(json_app, json_cookie) {
            log('cookie:' + JSON.stringify(json_cookie));
            log('app:' + JSON.stringify(json_app));

            var aid = getUrlParam('aid');
            if (!aid) {
                aid = ['V0$$1:0$2:7$3:', json_app.buildVersion, '$11:6'].join('');
            }
            var loginParam = '';
            if (json_cookie) {
                var accountType = json_cookie.type;
                var str_cookie = json_cookie.cookie;
                if ("qq" == accountType) {
                    var uin = getCookieParam(str_cookie, "uin");
                    loginParam = ['&uin=', uin].join('');
                } else if ("wx" == accountType) {
                    var openid = getCookieParam(str_cookie, "openid");
                    var appid = getCookieParam(str_cookie, "appid");
                    loginParam = ['&openid=', openid, "&appid=", appid].join('');
                }
            }
            var vertype = "1"
            if (json_app) {
                if (json_app.isinreview == 1) {
                    vertype = 1;
                } else {
                    vertype = 0;
                }
            }
            var url = ['https://pay.video.qq.com/fcgi-bin/iaptype?otype=json', loginParam, '&vertype=', vertype, '&aid=', aid].join('');
            $.ajax({
                url: url,
                dataType: "jsonp",
                success: function(json) {
                    if (json && json.result.code == 0) {
                        suCb && suCb(json);
                    } else {
                        failCb && failCb();
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    failCb && failCb();
                }
            });
        });
        getAppInfo(function(json) {
            d_app.resolve(json);
        }, function() {
            d_app.resolve();
        });

        getMainCookie(function(json) {
            d_cookie.resolve(json);
        }, function() {
            d_cookie.resolve();
        });
    }

    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getData(suCb, failCb) {
        $.ajax({
            url: "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1716&otype=json",
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function userLoginModChk() {
        $('#user_level').addClass('u_icon_vip_lost vip_0');
        $('.user_vip_level').text(['LV', 0].join(''));
        $('.user_score').text("0");
        $('.tip_upgrade').hide();
        $('.tip_dailyscore').hide();
        $('.tip_monthlyticket').hide();
        $('.div_expire').hide();
    }

    function openUrl(url, style) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", {
                    url: url,
                    style: style
                }, function(json_msg) {
                    //location.href = url;
                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function showLoading(isShow) {
        var delay = 0;
        if (!isShow) {
            delay = 20;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);
    }

    function loadData() {
        getData(function(json) {
            var discount = null;
            if (isIos) {
                getAppInfo(function(json_app) {
                    if (json_app.isJBOS == 1) {
                        discount = json.discount.iphone_discount_break;
                    } else {
                        discount = json.discount.iphone_discount;
                    }
                    bindDiscount(discount);
                    storage.setItem("app_hlw_user_discount", JSON.stringify(discount));
                });
            } else {
                discount = json.discount.aphone_discount;
                bindDiscount(discount);
                storage.setItem("app_hlw_user_discount", JSON.stringify(discount));
            }
        });
    }

    function bindDiscount(discout) {
        if (discout) {
            for (var i = 0; i < discout.length; i++) {
                var item = discout[i];
                if (item.month == 12) {
                    $('.link_pay').attr('data-id', item.id);
                    $('.link_pay').attr('data-code', item.code ? item.code : "");

                    if (isAndroid) {
                        $('.link_pay').attr('data-wx-id', "1002");
                        $('.link_pay').attr('data-wx-code', "TXSP");
                    }
                }
            }

        }
    }

    function showTicketNum(ticketNum) {
        if (ticketNum != "") {
            $('.user_ticket').text(ticketNum);
        } else {
            $('.user_ticket').text('0');
        }
        $('.app_container').show();
        showLoading(false);
        $('.app_loading').hide();
        setTimeout(function() {
            $('.app_loading').hide();
        }, 100);
    }

    function saveWXFakeData(data) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                storage.setItem(key, data);
            }
        });
    }

    function removeWXFakeData() {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                if (storage.getItem(key)) {
                    storage.removeItem(key);
                }
            }
        });
    }

    function getWXFakeData(suCb, failCb) {
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_", openid].join('');
                if (storage.getItem(key)) {
                    var data = JSON.parse(storage.getItem(key));
                    suCb && suCb(data);
                } else {
                    failCb && failCb();
                }
            } else {
                failCb && failCb();
            }
        });
    }

    function bindVipData(json_vip) {
        if (json_vip.annualvip == 1) {
            $('#user_level').addClass('u_icon_vip_year');
            $('.mod_btn_list').hide(); //隐藏年费按钮
        } else {
            $('#user_level').addClass('u_icon_vip');
        }
        $(['.grade_list .lv_', json_vip.level].join('')).addClass('current');
        $('#user_level').addClass(['vip_', json_vip.level].join(''));
        $('.user_vip_level').text(['LV', json_vip.level].join(''));
        var score = "0";
        if (json_vip.score > 0) {
            score = json_vip.score;
        }
        $('.user_score').text(score);
        $('.user_expire').text(json_vip.endTime.substr(0, 10));
        $('.user_dailyscore').text(json_vip.dailyscore);
        var payvip = new PayVip(json_vip);
        $('.user_upgrade').text(payvip.levelUp());
        $('.icon_down').hide();
        $('.user_monthlyticket').text(payvip.tickets());
    }

    function bindNotVip(json) {
        var level = "0";
        if (json.level > 0) {
            $('#user_level').addClass(['u_icon_vip_lost vip_', json.level].join(''));
            level = json.level;
        } else {
            $('#user_level').addClass('u_icon_vip_lost vip_0');
        }
        $('.user_vip_level').text(['LV', level].join(''));
        if (json.score > 0) {
            $('.user_score').text(json.score);
            $('.user_dailyscore').text(json.dailyscore);
            $('.icon_down').show();
            var payvip = new PayVip(json);
            $('.user_upgrade').text(payvip.levelUp());
            $('.tip_upgrade').html(['<span class="user_upgrade">', payvip.degrade('days'), '</span>天后降级'].join(''));
            $('.user_monthlyticket').text('0');
        } else {
            $('.user_score').text("0");
            $('.tip_upgrade').hide();
            $('.tip_dailyscore').hide();
            $('.tip_monthlyticket').hide();
        }
        $('.div_expire').hide();
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var ua = navigator.userAgent;
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }
            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = ["https://btrace.qq.com/collect?&sIp=",
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }

    function reportPay(payParam) {
        try {
            var accountType = "";
            var pay_uin = "";
            var openid = "";
            var appid = "";
            var type = 1;
            var step = 1;
            var days = payParam.month * 31;
            var ap = payParam.ap;
            var renew = 1;
            if (ap == 1) {
                renew = 3;
            }
            var payitem = "" + renew + "*" + days;

            getMainCookie(function(json_msg) {
                if (json_msg) {
                    var str_cookie = json_msg.cookie;
                    if (json_msg.type == 'wx') {
                        accountType = 2;
                        openid = getCookieParam(str_cookie, "openid");
                        appid = getCookieParam(str_cookie, "appid");
                    } else if (json_msg.type == 'qq') {
                        accountType = 1;
                        pay_uin = getCookieParam(str_cookie, "uin");
                    }
                    reportQA(pay_uin, openid, appid, type, accountType, payitem, step);
                }
            });
        } catch (ex) {}
    }

    function reportQA(pay_uin, openid, appid, type, accounttype, payitem, step) {
        var url = "https://pay.video.qq.com/fcgi-bin/payreport?otype=json";
        var guid = "";
        var plat = 7;
        var appBuildVerion = "";
        if (isAndroid) {
            plat = 8;
            appBuildVerion = getAppVersionBuild();
        }
        var reportCgi = [url,
            "&pay_uin=", getUin(pay_uin),
            "&openid=", openid,
            "&appid=", appid,
            "&type=", type,
            "&accounttype=", accounttype,
            "&payitem=", payitem,
            "&step=", step,
            "&plat=", plat,
            "&versioncode=", appBuildVerion
        ].join('');
        getDeviceInfo(function(json) {
            guid = json.guid;
            reportCgi = [reportCgi, "&guid=", guid].join('');
            reportQARequest(reportCgi);
        }, function() {
            reportQARequest(reportCgi);
        });
    }

    function reportQARequest(url) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {} else {}
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }

    function filterXSS(str) {
        return str.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\'/g, "&apos;");
    }

    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }
});
