define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var PayVip = require('./common/payvip');
    var lazyLoad = require('./common/lazyload');
    //aid,上报相关
    var reportApi_new = require('./common/report/client');
    var aidReport = require('./common/report/aid').init();

    var normalizer = require('./common/urlFactory').createNormalizer();

    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var hasLoadMore = false;
    var PAGE_SZIE = 10;
    var totalPage = 0;
    var initPage = 1;
    //只有页面加载时触发loading
    var lock = false;
    var appVersionBuild = getAppVersionBuild();
    var g_isVipVisitor = getUrlParam('isVisitor') || false;
    var g_isVip = "no";
    var g_guid = "";
    var isResume = false;

    $(document).ready(function() {
        window.reload = function() {
            location.reload();
        };
        window.reinit = function() {};

        init();
        getGuid();
        initReport();


        //获取缓存信息
        getCacheOrder(function(cache_order) {
            $(".js_nonetwork").hide();
            $('.app_container').show();
            showLoading(false);
            bindOrderData(cache_order);
        }, function() {
            showLoading(true);
        });

        $(".js_nonetwork").tap(function() {
            if ($(".js_nonetwork").is(":visible")) {
                initPage = 1;
                init();
            }
        });

        $(document).delegate('[data-url]', 'tap', function() {
            var url = $(this).attr('data-url');
            var checkupGrade = $(this).attr('data-checkup');
            if (checkupGrade != "4") {
                return false;
            }
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openView', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
            return false;
        });

        //onPageResumeListener();
    });

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function initReport() {
        try {
            reportApi_new.expose({ f_aid: aidReport.replace(/\$/g, '|||'), f_hottag: "order_page" });
        } catch (err) {}
    }

    function getDefaultAid() {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var aidDefault = ['V0$$1:0$2:', platform, '$3:', getAppVersion(), '$11:6'].join('');
        return aidDefault;
    }

    function init() {
        tenvideoReady(function() {
            appCallBack();
        });
    }

    function onPageResumeListener() {
        tenvideoReady(function() {
            TenvideoJSBridge.on("onPageResume", function() {
                isResume = true;
                $(".js_nonetwork").hide();
                //获取缓存信息
                getCacheOrder(function(cache_order) {
                    $('.app_container').show();
                    bindOrderData(cache_order);
                });
                appCallBack();
            });
        });
    }

    function getGuid() {
        tenvideoReady(function() {
            getDeviceInfo(function(json) {
                g_guid = json.guid;
                storage.setItem("guid", json.guid);
            });
        });

    }

    function appCallBack() {
        //$('.app_container').show();
        getPayVip(function(json) {
            if (json.vip == 1) {
                g_isVip = "yes";
            } else {
                g_isVip = "no";
            }
            initPage = 1;
            loadData();

        }, function() {
            initPage = 1;
            loadData();
        });
    }

    function loadData() {
        if ((initPage > totalPage) && (initPage != 1)) {
            return;
        }
        $(".js_nonetwork").hide();
        if (g_isVipVisitor == "true") {
            var visitor_uin = "";
            var visitor_skey = "";
            var visitor_g_tk = getToken(visitor_skey);
            var param = {
                "type": "",
                "uin": visitor_uin,
                "g_tk": visitor_g_tk,
                "pnum": initPage
            };
            orderRequest(param, function(json_order) {
                $('.app_container').show();
                showLoading(false);
                var orders = json_order.order;
                var order_count = orders.length;
                if (order_count == 0) {
                    return;
                }
                if (initPage == 1) {
                    //$(".mod_record_list").html("");
                    cacheOrder(orders);
                }
                bindOrderData(orders);
                lazyLoad.reset();
                lazyLoad.init(["img"]);
                var imgElements = $("img");
                var len = imgElements.length;
                var $lastImg = imgElements[len - 1];
                var offset = $($lastImg).offset().top;
                if (!!hasLoadMore) {
                    lazyLoad.more.reset(offset);
                } else {
                    hasLoadMore = true;
                    lazyLoad.more.init(offset, function() {
                        initPage++;
                        loadData();
                    });
                }
            }, function() {
                showLoading(false);
                $('.app_container').hide();
            });
        } else {
            getMainCookie(function(json_user) {
                var cookieStr = json_user.cookie;
                var accountType = json_user.type;
                var uin = "";
                var skey = "";
                var g_tk = "";
                if (accountType == "qq") {
                    uin = getUin(getCookieParam(cookieStr, "uin"));
                    skey = getCookieParam(cookieStr, "skey");
                    g_tk = getToken(skey);
                } else {
                    g_tk = getToken(skey);
                }
                var param = {
                    "type": accountType,
                    "uin": uin,
                    "g_tk": g_tk,
                    "pnum": initPage
                };
                orderRequest(param, function(json_order) {
                    $('.app_container').show();
                    showLoading(false);
                    var orders = json_order.order;
                    var order_count = orders.length;
                    var totalCount = json_order.total;
                    if (order_count == 0) {
                        return;
                    }
                    totalPage = (totalCount % PAGE_SZIE) == 0 ? (totalCount / PAGE_SZIE) : (Math.floor(totalCount / PAGE_SZIE) + 1);
                    if (initPage == 1) {
                        cacheOrder(orders);
                    }
                    bindOrderData(orders);
                    lazyLoad.reset();
                    lazyLoad.init(["img"]);
                    var imgElements = $("img");
                    var len = imgElements.length;
                    var $lastImg = imgElements[len - 1];
                    var offset = $($lastImg).offset().top;
                    if (!!hasLoadMore) {
                        lazyLoad.more.reset(offset);
                    } else {
                        hasLoadMore = true;
                        lazyLoad.more.init(offset, function() {
                            initPage++;
                            loadData();
                        });

                    }
                }, function() {
                    showLoading(false);
                    $('.app_container').hide();
                    $(".js_nonetwork").show();
                });
            });
        }

    }

    function orderRequest(param, sucCb, failCb) {
        var url = "";
        var cgiUrl = "https://pay.video.qq.com/fcgi-bin/order?otype=json&t=1&psize=10";
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        url = [cgiUrl, "&platform=", platform].join('');
        if (platform == 8) {
            url += "&versioncode=" + appVersionBuild;
        }
        if (platform == 7) {
            if (g_isVipVisitor == "true") {
                url += "&isVisitor=1";
            }
        }
        var userInfo = "";
        userInfo = ["&g_tk=", param.g_tk, "&uin=", param.uin, "&pnum=", param.pnum].join('');
        url += userInfo;
        if (storage.getItem("guid")) {
            url += "&guid=" + storage.getItem("guid");
            orderAjax(url, sucCb, failCb);
        } else {
            getDeviceInfo(function(json) {
                var guid = json.guid;
                url += "&guid=" + guid;
                orderAjax(url, sucCb, failCb);
            }, function() {
                orderAjax(url, sucCb, failCb);
            });
        }

    }

    function orderAjax(url, sucCb, failCb) {
        if (initPage != 1) {
            $("#data_loading").show();
        }
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.ret == 0) {
                    $("#data_loading").hide();
                    sucCb && sucCb(json);
                } else {
                    $("#data_loading .more_loading .txt").html("数据加载失败");
                    $("#data_loading").show();
                    //failCb && failCb();
                }
            },
            error: function() {
                $("#data_loading").hide();
                failCb && failCb();
            }
        });
    }

    function bindOrderData(orders) {
        var order_count = orders.length;
        if (order_count == 0) {
            return;
        }
        var tpl = "";
        for (var i = 0; i < order_count; i++) {
            var item = orders[i];
            var cost = item.cost;
            var buyMehtod = "用券购买";
            if (item.cost && cost != "0") {
                buyMehtod = "支付购买";
            } else if (item.paychannel && item.paychannel.indexOf('give') != -1) {
                buyMehtod = "好友赠送";
            }
            var url = ['tenvideo2://?action=1&cover_id=', item.cid, '&demandVersion=2.6.0'].join('');
            if (item.product_type == 4) { //直播的拉起协议
                url = ['txvideo://v.qq.com/TencentLiveActivity?pid=', item.cid].join('');
                if (isIos) {
                    url = ['tenvideo2://?action=11&program_id=', item.cid].join('');
                }
            }
            tpl += '<div class="record_list">';
            tpl += '<dl class="list_item cf" data-url="' + url + '" data-checkup="' + item.checkup_grade + '">';
            tpl += '<dt>';
            tpl += '<span class="figure_pic">';
            tpl += '<span class="pic" style="background-image: url(' + getPosterUrl(normalizer(item.pic)) + ');"></span>';
            tpl += '<img style="display:none:;" src="" alt="">'; //加载需要
            tpl += getIconTag(item.pay_type, item.product_type);
            tpl += '</span>';
            tpl += '</dt>';
            tpl += '<dd>';
            tpl += '<p class="tit">' + item.title + '</p>';
            tpl += '<p class="txt">于' + getStartDate(item.begin_time) + buyMehtod + '</p>';
            tpl += '<p class="tips js_order_tips">' + isOrderValid(item) + '</p>';
            if (item.checkup_grade == "4") {
                tpl += '<i class="icon_arrow js_icon_arrow"></i>';
            }
            tpl += '</dd>';
            tpl += '</dl>';
            tpl += '</div>';
        }
        if (tpl.length > 0) {
            if (initPage == 1) {
                $(".mod_record_list").html(tpl);
            } else {
                $(".mod_record_list").append(tpl);
            }
        }
    }

    function cacheOrder(orders) {
        getMainCookie(function(json_user) {
            var cookieStr = json_user.cookie;
            var accountType = json_user.type;
            var uid = "";
            if (json_user.type == 'wx') {
                uid = getCookieParam(cookieStr, "openid");
            } else if (json_user.type == 'qq') {
                uid = getCookieParam(cookieStr, "uin");
            }
            if (uid) {
                var key = ["order_", uid].join('');
                storage.setItem(key, JSON.stringify(orders));
            }
        });
    }

    function getCacheOrder(suCb, failCb) {
        tenvideoReady(function() {
            if (g_isVipVisitor == "true") {
                return false;
            }
            if ($.trim($(".mod_record_list").html()).length > 0) {
                $('.app_container').show();
                showLoading(false);
                return false;
            }
            getMainCookie(function(json_user) {
                var cookieStr = json_user.cookie;
                var accountType = json_user.type;
                var uid = "";
                if (json_user.type == 'wx') {
                    uid = getCookieParam(cookieStr, "openid");
                } else if (json_user.type == 'qq') {
                    uid = getCookieParam(cookieStr, "uin");
                }
                var key = ["order_", uid].join('');
                if (storage.getItem(key)) {
                    var data = JSON.parse(storage.getItem(key));
                    suCb && suCb(data);
                }
            }, function() {
                failCb && failCb();
            });
        });
    }

    function getPosterUrl(picUrl) {
        var suffixIndex = picUrl.lastIndexOf(".");
        if (suffixIndex != -1) {
            var picPrefix = picUrl.substring(0, suffixIndex);
            var picSurfix = picUrl.substring(suffixIndex);
            var newUrl = [picPrefix, "_e", picSurfix].join('');
            return newUrl;
        }
    }

    function getIconTag(status, productType) {
        var tag = "";
        if (productType == 4) {
            tag = '<sup class="mark_vip_coupon">付费</sup>';
        } else if (status == 5 || status == 6) {
            tag = '<sup class="mark_vip_free">会员</sup>';
        } else if (status == 4) {
            tag = '<sup class="mark_vip_coupon">用券</sup>';
        } else if (status == 7) {
            tag = '<sup class="mark_vip_coupon">付费</sup>';
        }
        return tag;
    }

    function getStartDate(dateStr) {
        return dateStr.substr(0, 10);
    }

    function isOrderValid(order) {
        var hint = "";
        if (order.checkup_grade != 4) {
            hint = '<span class="txt_orange">已下架</span>';
        } else if (order.pay_type == 5) {
            if (g_isVip == "yes") {
                hint = '<span class="txt_green">VIP免费观看</span>';
            } else {
                if (order.end_time) {
                    var endTimeOrder = order.end_time;
                    var myDateOrder = new Date();
                    var endDateOrder = new Date(Date.parse(endTimeOrder.replace(/-/g, "/")));
                    if (Date.parse(myDateOrder) - Date.parse(endDateOrder) < 0) {
                        hint = '<span class="txt_green">可于' + endTimeOrder.substr(0, endTimeOrder.length - 3) + '前观看</span>';
                    } else {
                        hint = '<span class="txt_orange">已过期</span>';
                    };
                }
            }

        } else if (order.pay_type == 6) {
            hint = '<span class="txt_green">VIP免费观看</span>';
        } else if (order.pay_type == 4 || order.pay_type == 7) {
            if (order.end_time) {
                var endTime = order.end_time;
                var myDate = new Date();
                var endDate = new Date(Date.parse(endTime.replace(/-/g, "/")));
                if (Date.parse(myDate) - Date.parse(endDate) > 0) {
                    hint = '<span class="txt_orange">已过期</span>';
                } else {
                    hint = '<span class="txt_green">可于' + endTime.substr(0, endTime.length - 3) + '前观看</span>';
                }
            }
        } else if (order.pay_type == 8) {
            hint = '<span class="txt_green">免费观看</span>';
        }
        return hint;
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq", "wx"]
        }, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            //alert(JSON.stringify(json));
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }


    function getAppInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                storage.setItem("app_info_isjbos", json.result.isJBOS);
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }


    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function time33(skey) {
        // 哈希time33算法
        for (var i = 0, len = skey.length, hash = 5381; i < len; ++i) {
            hash += (hash << 5) + skey.charAt(i).charCodeAt();
        };
        return hash & 0x7fffffff;
    }

    function getToken(skey) {
        return time33(skey);
    }

    function openUrl(url, style) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", {
                    url: url,
                    style: style
                }, function(json_msg) {
                    //location.href = url;
                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function showLoading(isShow) {
        /*var delay = 0;
        if (!isShow) {
            delay = 100;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);*/
        if (isShow) {
            $('.g_container_loading').show();
        } else {
            $('.g_container_loading').hide();
        }
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var ua = navigator.userAgent;
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }
            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.info', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = ["https://btrace.qq.com/collect?&sIp=",
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }

    function reportPay(payParam) {
        try {
            var accountType = "";
            var pay_uin = "";
            var openid = "";
            var appid = "";
            var type = 1;
            var step = 1;
            var days = payParam.month * 31;
            var ap = payParam.ap;
            var renew = 1;
            if (ap == 1) {
                renew = 3;
            }
            var payitem = "" + renew + "*" + days;

            getMainCookie(function(json_msg) {
                if (json_msg) {
                    var str_cookie = json_msg.cookie;
                    if (json_msg.type == 'wx') {
                        accountType = 2;
                        openid = getCookieParam(str_cookie, "openid");
                        appid = getCookieParam(str_cookie, "appid");
                    } else if (json_msg.type == 'qq') {
                        accountType = 1;
                        pay_uin = getCookieParam(str_cookie, "uin");
                    }
                    reportQA(pay_uin, openid, appid, type, accountType, payitem, step);
                }
            });
        } catch (ex) {}
    }

    function reportQA(pay_uin, openid, appid, type, accounttype, payitem, step) {
        var url = "https://pay.video.qq.com/fcgi-bin/payreport?otype=json";
        var guid = "";
        var plat = 7;
        var appBuildVerion = "";
        if (isAndroid) {
            plat = 8;
            appBuildVerion = getAppVersionBuild();
        }
        var reportCgi = [url,
            "&pay_uin=", getUin(pay_uin),
            "&openid=", openid,
            "&appid=", appid,
            "&type=", type,
            "&accounttype=", accounttype,
            "&payitem=", payitem,
            "&step=", step,
            "&plat=", plat,
            "&versioncode=", appBuildVerion
        ].join('');
        getDeviceInfo(function(json) {
            guid = json.guid;
            reportCgi = [reportCgi, "&guid=", guid].join('');
            reportQARequest(reportCgi);
        }, function() {
            reportQARequest(reportCgi);
        });
    }

    function reportQARequest(url) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {} else {}
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }

    function filterXSS(str) {
        return str.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\'/g, "&apos;");
    }

    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }

    function consolelog(txt) {
        var url = "https://film.qq.com/weixin/?log=" + txt;
        $.get(url);
    }
});
