define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var aidReport = getUrlParam('aid') || "";

    if (getUrlParam('page')) {
        var page = getUrlParam('page')
        initPage(page);
    } else {
        initPage('dapian');
    }

    init();
    initReport();
    window.reload = function() {
        location.reload();
    };
    window.reinit = function() {
        init();
    };

    $(document).delegate("[data-url]", "tap", function() {
        var url = $(this).attr('data-url');
        //openUrl(url);
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openView", {
                    url: url
                }, function(json_msg) {});
            } catch (err) {
                location.href = url;
            }
        }, 0);
        return false;
    });

    $('.js_gameCenter_link').tap(function() {
        if (isAndroid) {
            var url = 'https://iwan.qq.com/m/vadr/game_center.html?_bid=22';
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openUrl', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
        }
    });

    $('.pay_btn').tap(function() {
        if (getUrlParam('back')) {
            var url = 'tenvideo2://?action=20';
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke("openView", {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
        } else {
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke("goBack");
                } catch (err) {}
            }, 0);
        }
    });

    $(document).delegate("[hottag]", "tap", function() {
        var hotTag = $(this).attr('hottag');
        if (aidReport.length > 0) {
            hotTag += ['.', aidReport].join('');
        }
        try {
            pgvSendClick({
                virtualDomain: "film.qq.com",
                hottag: hotTag
            });
        } catch (err) {}
        return false;
    });

    function initPage(page) {
        page = page ? page : 'dapian';
        $('.div_' + page).show();
        $('.mod_btn_list').show();

        if (page == "dapian") {
            var isInitMovie = false;
            if (storage.getItem("app_hlw_user_movie")) {
                var data_movie = JSON.parse(storage.getItem("app_hlw_user_movie"));
                var list_movie = buildList(data_movie);
                $('.list_movie').html(list_movie);
                isInitMovie = true;
            }

            getPageData("movie", function(json) {
                if (isInitMovie == false) {
                    var list = buildList(json);
                    $('.list_movie').html(list);
                }
                storage.setItem("app_hlw_user_movie", JSON.stringify(json));
            });
        } else if (page == "meiju") {
            var isInitTV = false;
            if (storage.getItem("app_hlw_user_tv")) {
                var data_tv = JSON.parse(storage.getItem("app_hlw_user_tv"));
                var list_tv = buildList(data_tv);
                $('.list_tv').html(list_tv);
                isInitTV = true;
            }

            getPageData("meiju", function(json) {
                if (isInitTV == false) {
                    var list = buildList(json);
                    $('.list_tv').html(list);
                }
                storage.setItem("app_hlw_user_tv", JSON.stringify(json));
            });
        } else if (page == "quan") {
            var isInitTicketMovie = false;
            if (storage.getItem("app_hlw_user_ticket_movie")) {
                var data_ticketmovie = JSON.parse(storage.getItem("app_hlw_user_ticket_movie"));
                var list_ticketmovie = buildList(data_ticketmovie);
                $('.list_ticket_movie').html(list_ticketmovie);
                isInitTicketMovie = true;
            }
            getPageData("ticket_movie", function(json) {
                if (isInitTicketMovie == false) {
                    var list = buildList(json);
                    $('.list_ticket_movie').html(list);
                }
                storage.setItem("app_hlw_user_ticket_movie", JSON.stringify(json));
            });
        } else if (page == "jilupian") {
            var isInitDocumentary = false;
            if (storage.getItem("app_hlw_user_documentary")) {
                var data_documentary = JSON.parse(storage.getItem("app_hlw_user_documentary"));
                var list_documentary = buildList(data_documentary);
                $('.list_documentary').html(list_documentary);
                isInitDocumentary = true;
            }
            getPageData("documentary", function(json) {
                if (isInitDocumentary == false) {
                    var list = buildList(json);
                    $('.list_documentary').html(list);
                }
                storage.setItem("app_hlw_user_documentary", JSON.stringify(json));
            });
        } else if (page == "quanju") {
            var isInitHotTv = false;
            if (storage.getItem("app_hlw_user_hot_tv")) {
                var data_hot_tv = JSON.parse(storage.getItem("app_hlw_user_hot_tv"));
                var list_hot_tv = buildList(data_hot_tv);
                $('.list_hot_tv').html(list_hot_tv);
                isInitHotTv = true;
            }
            getPageData("hot_tv", function(json) {
                if (isInitHotTv == false) {
                    var list = buildList(json);
                    $('.list_hot_tv').html(list);
                }
                storage.setItem("app_hlw_user_hot_tv", JSON.stringify(json));
            });
        }
    }

    function buildList(items) {
        var num = 3;
        if (items.length < num) {
            num = items.length;
        }
        var list = '';
        for (var i = 0; i < num; i++) {
            var item = items[i];
            var url = ['tenvideo2://?action=1&cover_id=', item.cid, '&demandVersion=2.6.0'].join(''); //['https://film.qq.com/weixin/detail/', item.cid.substr(0, 1), '/', item.cid, '.html'].join('');
            var tag = "";
            if (item.status == 5 || item.status == 6) {
                tag = '<sup class="mark_vip_free">会员</sup>';
            } else if (item.status == 4) {
                tag = '<sup class="mark_vip_coupon">用券</sup>';
            }
            list += ['<li class="item"><a href="javascript:;" data-url="', url, '" class="figure"><span class="figure_pic"><img src="', item.pic, '" alt="', item.title, '">', tag, '</span><span class="figure_title figure_title_multirow">', item.title, '</span></a></li>'].join('');
        };
        return list;
    }

    function getData(suCb, failCb) {
        $.ajax({
            url: "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1739&otype=json",
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getPageData(type, suCb, failCb) {
        var items = [];
        var url_diy = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1739&otype=json";
        var url_load = "";
        if (type == 'movie') {
            url_load = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=866&mi_type=-1&mi_status=1&mi_year=-1&mi_area=-1&mi_sort=1&page=0&pagesize=3&otype=json";
        } else if (type == 'meiju') {
            url_load = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=2273&mi_type=-1&mi_status=-1&mi_year=-1&mi_area=-1&mi_sort=1&page=0&pagesize=3&otype=json";
        } else if (type == 'ticket_movie') {
            url_load = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=866&mi_type=-1&mi_status=0&mi_year=-1&mi_area=-1&mi_sort=1&page=0&pagesize=3&otype=json";
        } else if (type == 'documentary') {
            url_load = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1926&mi_type=-1&mi_status=-1&mi_year=-1&mi_area=-1&mi_sort=1&page=0&pagesize=3&otype=json";
        } else if (type == 'hot_tv') {
            url_load = "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1626&mi_type=-1&mi_status=1&mi_year=-1&mi_area=-1&mi_sort=1&page=0&pagesize=3&otype=json";
        }
        $.when($.ajax({
            url: url_diy,
            dataType: "jsonp"
        }), $.ajax({
            url: url_load,
            dataType: "jsonp"
        })).done(function(d_json, l_json) {
            if (d_json && d_json[0].returncode == 0) {
                var list = null;
                if (type == 'movie') {
                    list = d_json[0].movie;
                } else if (type == "tv") {
                    list = d_json[0].tv;
                } else if (type == "ticket_movie") {
                    list = d_json[0].ticket_movie;
                }
                if (list) {
                    for (var i = 0; i < list.length; i++) {
                        var temp = list[i];
                        var item = {
                            cid: temp.cid,
                            title: temp.title,
                            pic: temp.pic,
                            status: temp.status
                        };
                        items.push(item);
                    };
                }
            }
            if (l_json && l_json[0].returncode == 0) {
                list = l_json[0].movies;
                if (list) {
                    for (var i = 0; i < list.length; i++) {
                        var temp = list[i];
                        var item = {
                            cid: temp.cover_id,
                            title: temp.title,
                            pic: temp.pic_l,
                            status: temp.c_status
                        };
                        items.push(item);
                    };
                }
            }

            if (items.length >= 3) {
                suCb && suCb(items);
            } else {
                failCb && failCb();
            }
        });
    }


    function init() {
        if (typeof TenvideoJSBridge == "object") {
            appCallBack();
        } else {
            if (document.addEventListener) {
                document.addEventListener("onTenvideoJSBridgeReady", appCallBack, false);
            } else if (document.attachEvent) {
                document.attachEvent("onTenvideoJSBridgeReady", appCallBack);
            }
        }
    }

    function appCallBack() {
        getPayVip(function(json) {
            if (json.result) {
                if (json.result.code == 0) {
                    var hotTag = "";
                    var hotTagPrifix = "hlw_app_priv_open_vip_";
                    if (json.vip == 1 || json.visitor.vip == 1) {
                        $('.pay_btn').text('续费VIP会员');
                        hotTag = ["hlw_app_priv_renew_vip_", "isVip"].join('');
                    } else {
                        $('.pay_btn').text('开通VIP会员');
                        hotTag = [hotTagPrifix, "notVip"].join('');
                    }
                    $('.pay_btn').attr('hottag', hotTag);
                }
            }
        });

        getUserInfo(function(json) {
            var data = json.qq;
            if (data) {
                report(data.uin);
            } else {
                report(0);
            }
        }, function() {
            report(0);
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq"]
        }, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            log(["getPayVip:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function showLoading(isShow) {
        var delay = 0;
        if (!isShow) {
            delay = 10;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);
    }

    function openUrl(url) {
        showLoading(true);
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", {
                    url: url
                }, function(json_msg) {
                    //location.href = url;
                    showLoading(false);
                });
            } catch (err) {
                showLoading(false);
                location.href = url;
            }
        }, 0);
    }

    /**
     * @description 获得相对路径的绝对路径
     * @param {string} url 相对路径
     **/
    function getAbsoluteUrl(url) {
        var div = document.createElement('div');
        div.innerHTML = ['<a href=', url, '></a>'].join('');
        return div.firstChild.href;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = ["https://btrace.qq.com/collect?&sIp=",
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }

    function initReport() {
        var hotTag = "app";
        if (aidReport.length > 0) {
            hotTag = ["app.", aidReport].join('');
        }
        try {
            pgvSendClick({
                virtualDomain: "film.qq.com",
                hottag: hotTag
            });
        } catch (err) {}

    }


    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }
});
