define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var PayVip = require('./common/payvip');
    var cookie = require('./common/cookie');
    var utils = require('utils');
    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var isiPad = ua.indexOf("iPad") != -1 ? true : false;
    var useh5pay = false;
    var g_isJBOS = false;
    //只有页面加载时触发loading
    var lock = false;
    var g_isVisitorVip = false;
    var isVipReport = false;
    var aidReport = getUrlParam('aid') || "";
    var wxOfferId = "1450002155";
    var qqOfferId = "1450005771";
    var default_hlw_param = utils.getDefaultHlwParam();
    var g_pay_wx_offerId = "";
    var g_pay_qq_offerId = "";
    var g_mpid = ""; //ma
    var g_hlw_param = "";
    var g_isPayDialogOpen = false;

    var package_discount = {
        "aphone_discount": [{
            "desc": "1个月20元",
            "month": "1",
            "id": "1100-1001",
            "code": "1100",
            "discount": "10"
        }, {
            "desc": "3个月57元(19元/月)",
            "month": "3",
            "id": "1100-1002",
            "code": "1100",
            "discount": "33"
        }, {
            "desc": "12个月198元(16.5元/月)",
            "month": "12",
            "id": "1100-1003",
            "code": "1100",
            "discount": "162"
        }],
        "iphone_discount": [{
            "desc": "25元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "5"
        }, {
            "desc": "60元(20元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "30"
        }, {
            "desc": "168元(14元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "192"
        }],
        "iphone_discount_break": [{
            "desc": "20元",
            "id": "com.tenvideoios.OneMonthPay1",
            "month": "1",
            "discount": "10"
        }, {
            "desc": "57元(19元/月)",
            "id": "com.tenvideoios.ThreeMonthPay1",
            "month": "3",
            "discount": "33"
        }, {
            "desc": "168元(14元/月)",
            "id": "com.tenvideoios.OneYearPay1",
            "month": "12",
            "discount": "192"
        }]
    };

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function appCallBack() {
        if (!lock) {
            lock = true;
            // showLoading(true);
            //loadData();
            initDiscountConfigNew();
        }
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getUserInfo", {
            type: ["qq", "wx"]
        }, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function openPayH5(param) {
        TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {} else {}
        });
    }

    function goH5Pay(param, extraParam) {
        param.ap = 1;
        extraParam = extraParam || "";
        getAppInfo(function(json_app) {
            var aid = getUrlParam('aid');
            //var month = param.month;
            //var ap = param.ap;
            if (!aid) {
                aid = ['V0$$1:0$2:7$3:', json_app.buildVersion, '$11:6'].join('');
            } else {
                aid = decodeURIComponent(aid);
                if (aid.indexOf('$11:') == -1) {
                    if (json_app.isJBOS == 1) {
                        aid += '$11:4';
                    } else {
                        aid += '$11:6';
                    }
                }
            }
            //goPayLink(param, aid, extraParam);
            paymentChoose(param, aid, extraParam);
        });
    }

    function paymentChoose(param, aid, extraParam) {
        //需要判断是否是走弹窗版开通页
        $.ajax({
            url: "https://vip.video.qq.com/fcgi-bin/comm_cgi?name=white_list&cmd=1&rule=activity_pay",
            dataType: "jsonp",
            success: function(json) {
                if (json.ret == 0) {
                    if (json.has_auth) { //在灰度范围内
                        if (json.has_auth == 1) {
                            goPayLinkDialog(param, aid, extraParam);
                        } else {
                            goPayLink(param, aid, extraParam);
                        }
                    } else {
                        goPayLink(param, aid, extraParam);
                    }
                } else {
                    goPayLink(param, aid, extraParam);
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                goPayLink(param, aid, extraParam);
            }
        });
    }

    function goPayLinkDialog(param, aid, extraParam) {
        var openParam = {};
        openParam.ru = 'https://film.qq.com/app/payback.html';
        openParam.as = 1;
        openParam.hh = 1;
        openParam.showwxpaytitle = 1;
        if (isNewSdkVersion()) {
            //传sdkpay=1不需要传wxAppid参数
            wxOfferId = "1450002788";
            openParam.sdkpay = 1;
        } else {
            openParam.wxAppid = "wx68ff4e3ba9f84df4";
        }
        var month = param.month;
        var ap = param.ap;
        var d_cookie = $.Deferred();
        $.when(d_cookie).done(function(json_cookie) {
            var cookieStr = json_cookie.cookie;
            var productid = param.id;
            if (!productid) {
                if (month == 1) {
                    productid = '1000';
                } else if (month == 3) {
                    productid = '1001';
                } else if (month == 12) {
                    productid = '1002';
                }
            }
            if (json_cookie.type == "wx") {
                var openid = getCookieParam(cookieStr, "openid");
                var access_token = getCookieParam(cookieStr, "access_token");
                var appid = getCookieParam(cookieStr, "appid");
                if (g_pay_wx_offerId.length > 0) {
                    wxOfferId = utils.getOfferId(g_pay_wx_offerId);
                }
                openParam.account = "wechat";
                openParam.service = "TXSP";
                openParam.appid = wxOfferId;
                openParam.productid = productid;
                openParam.openid = openid;
                openParam.openkey = access_token;
                openParam.sessionid = "hy_gameid";
                openParam.sessiontype = "wc_actoken";
                openParam.wxAppid2 = appid;
                openParam.pf = "wechat_wx-2001-wx-2011-hlw";
            } else {
                if (g_pay_qq_offerId.length > 0) {
                    qqOfferId = utils.getOfferId(g_pay_qq_offerId);
                }
                var uin = getUin(getCookieParam(cookieStr, "uin"));
                if (!uin || uin <= 10000) {
                    uin = parseInt(getCookieParam(cookieStr, "uin").replace(/^o0*/g, ""), 10);
                }
                openParam.account = "qq";
                openParam.service = "TXSP";
                openParam.pf = "wechat_wx-2001-wx-2011-hlw";
                openParam.appid = qqOfferId;
                openParam.productid = productid;
                openParam.u = uin;
            }

            openParam.ap = ap;
            openParam.aid = aid;
            /*openParam.aph = 1;
            openParam.showad = 1;
            openParam.hct = 1;*/
            openParam.hideInfo = 1;
            if (g_hlw_param.length > 0) {
                openParam.hlw_params = g_hlw_param;
            } else {
                openParam.hlw_params = default_hlw_param;
            }
            //TODO:设置测试环境
            //openParam.sandbox = false;
            openParam.onClose = function() {
                //TODO::关闭窗口 reload
                g_isPayDialogOpen = false;
            }
            if (!g_isPayDialogOpen) {
                Midas.openSubscribe(openParam);
                g_isPayDialogOpen = true;
            }

        });

        getMainCookie(function(json_cookie) {
            d_cookie.resolve(json_cookie);
        }, function() {
            d_cookie.resolve();
        });
    }


    function goPayLink(param, aid, extraParam) {
        var ru = encodeURIComponent('https://film.qq.com/app/payback.html');
        var url = 'https://pay.qq.com/h5/index.shtml?m=buy&as=1&hh=1&showwxpaytitle=1' + '&wxAppid=wx68ff4e3ba9f84df4';
        if (isNewSdkVersion()) {
            url = 'https://pay.qq.com/h5/index.shtml?m=buy&as=1&hh=1&showwxpaytitle=1';
            url += '&sdkpay=1';
            wxOfferId = "1450002788";
        }
        var month = param.month;
        var ap = param.ap;
        var d_cookie = $.Deferred();
        $.when(d_cookie).done(function(json_cookie) {
            var cookieStr = json_cookie.cookie;
            var productid = param.id;
            if (json_cookie.type == "wx") {
                var openid = getCookieParam(cookieStr, "openid");
                var access_token = getCookieParam(cookieStr, "access_token");
                var appid = getCookieParam(cookieStr, "appid");
                if (!productid) {
                    if (month == 1) {
                        productid = '1000';
                    } else if (month == 3) {
                        productid = '1001';
                    } else if (month == 12) {
                        productid = '1002';
                    }
                }
                if (g_pay_wx_offerId.length > 0) {
                    wxOfferId = utils.getOfferId(g_pay_wx_offerId);
                }
                url += ['&c=subscribe&service=TXSP&appid=', wxOfferId, '&productid=', productid, '&openid=', openid, '&openkey=', access_token, '&sessionid=hy_gameid&sessiontype=wc_actoken&wxAppid2=', appid, '&pf=wechat_wx-2001-wx-2011-hlw'].join('');
            } else {
                if (g_pay_qq_offerId.length > 0) {
                    qqOfferId = utils.getOfferId(g_pay_qq_offerId);
                }
                var uin = getUin(getCookieParam(cookieStr, "uin"));
                if (!uin || uin <= 10000) {
                    uin = parseInt(getCookieParam(cookieStr, "uin").replace(/^o0*/g, ""), 10);
                }
                url += ["&c=qqsubscribe&service=TXSP&pf=wechat_wx-2001-wx-2011-hlw&appid=", qqOfferId, "&u=", uin, '&productid=', productid].join('');
            }

            url += ["&ap=", ap, "&aid=", encodeURIComponent(aid), "&ru=", ru, "&aph=1&showad=1&hct=1"].join('');
            if (g_hlw_param.length > 0) {
                url += "&hlw_params=" + encodeURIComponent(g_hlw_param);
            } else {
                url += "&hlw_params=" + encodeURIComponent(default_hlw_param);
            }
            //url += "&sandbox=1";
            if (isIos) {
                openUrlBySdk(url, 1, "1");
            } else {
                openUrl(url, 1);
            }

        });

        getMainCookie(function(json_cookie) {
            d_cookie.resolve(json_cookie);
        }, function() {
            d_cookie.resolve();
        });
    }

    function openPayAndroid(param) {
        var appVersion = getAppVersion();
        if (appVersion >= "4.2.0") {
            isAccountLogin(function(json_login) {
                goH5Pay(param);
            }, function() {
                TenvideoJSBridge.invoke("actionLogin", {
                    "type": "tv"
                }, function(json_msg) {
                    var json = JSON.parse(json_msg);
                    if (json.errCode == 0) {}
                });
            });

        } else {
            TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                var json = JSON.parse(json_msg);
                if (json.errCode == 0) {} else {}
            });
        }
    }

    function getAppInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getAppInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                storage.setItem("app_info_isjbos", json.result.isJBOS);
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getIapType(suCb, failCb) {
        var d_app = $.Deferred();
        var d_cookie = $.Deferred();

        $.when(d_app, d_cookie).done(function(json_app, json_cookie) {
            // log('cookie:' + JSON.stringify(json_cookie));
            // log('app:' + JSON.stringify(json_app));

            var aid = getUrlParam('aid');

            if (!aid) {
                aid = ['V0$$1:0$2:7$3:', json_app.buildVersion, '$11:6'].join('');
            }
            var loginParam = '';
            if (json_cookie) {
                var accountType = json_cookie.type;
                var str_cookie = json_cookie.cookie;
                if ("qq" == accountType) {
                    var uin = getCookieParam(str_cookie, "uin");
                    loginParam = ['&uin=', uin].join('');
                } else if ("wx" == accountType) {
                    var openid = getCookieParam(str_cookie, "openid");
                    var appid = getCookieParam(str_cookie, "appid");
                    loginParam = ['&openid=', openid, "&appid=", appid].join('');
                }
            }
            var vertype = "1";
            if (json_app) {
                if (json_app.isinreview == 1) {
                    vertype = 1;
                } else {
                    vertype = 0;
                }
            }
            var url = ['https://pay.video.qq.com/fcgi-bin/iaptype?otype=json', loginParam, '&vertype=', vertype, '&aid=', aid].join('');
            $.ajax({
                url: url,
                dataType: "jsonp",
                success: function(json) {
                    if (json && json.result.code == 0) {
                        suCb && suCb(json);
                    } else {
                        failCb && failCb();
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    failCb && failCb();
                }
            });
        });
        getAppInfo(function(json) {
            d_app.resolve(json);
        }, function() {
            d_app.resolve();
        });

        getMainCookie(function(json) {
            d_cookie.resolve(json);
        }, function() {
            d_cookie.resolve();
        });
    }

    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getData(suCb, failCb) {
        $.ajax({
            url: "https://sns.video.qq.com/fcgi-bin/dlib/dataout_pc?auto_id=1716&otype=json",
            dataType: "jsonp",
            success: function(json) {
                if (json && json.returncode == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    /**
     * @description 获得相对路径的绝对路径
     * @param {string} url 相对路径
     **/
    function getAbsoluteUrl(url) {
        var div = document.createElement('div');
        div.innerHTML = ['<a href=', url, '></a>'].join('');
        return div.firstChild.href;
    }

    function openUrl(url, style) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        var param = {
            url: url,
            style: style
        };
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", param, function(json_msg) {
                    //location.href = url;
                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function openUrlBySdk(url, style, mode) {
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }

        //签约添加参数
        //currentJumpURL_Mode: "1"
        var param = {
            url: url,
            style: style,
            currentJumpURL_Mode: mode
        };

        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", param, function(json_msg) {

                });
            } catch (err) {
                location.href = url;
            }
        }, 0);
    }

    function showLoading(isShow) {
        var delay = 0;
        if (!isShow) {
            delay = 20;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);
    }

    function loadData() {
        getData(function(json) {
            var discount = null;
            if (isIos) {
                getAppInfo(function(json_app) {
                    if (json_app.isJBOS == 1) {
                        discount = json.discount.iphone_discount_break;
                    } else {
                        discount = json.discount.iphone_discount;
                    }
                    bindDiscount(discount);
                    storage.setItem("app_hlw_user_discount", JSON.stringify(discount));
                });
            } else {
                discount = json.discount.aphone_discount;
                bindDiscount(discount);
                storage.setItem("app_hlw_user_discount", JSON.stringify(discount));
            }
        });
    }

    function bindDiscount(discout) {
        if (discout) {
            for (var i = 0; i < discout.length; i++) {
                var item = discout[i];
                if (item.month == 12) {
                    $('.pay_btn').attr('data-id', item.id);
                    $('.pay_btn').attr('data-code', item.code ? item.code : "");

                    if (isAndroid) {
                        $('.pay_btn').attr('data-wx-id', "1002");
                        $('.pay_btn').attr('data-wx-code', "TXSP");
                    }
                }
            }

        }
    }

    function initDiscountConfigNew() {
        var isInitDiscount = false;
        tenvideoReady(function() {
            getPayVip(function(json_vip) {
                var pay_type = "0";
                if (isIos) {
                    getAppInfo(function(json_app) {
                        if (json_app.isJBOS == 1) {
                            //获取非iap价格
                            g_isJBOS = true;
                            utils.getHlwDiscountAjax(pay_type, function(json_discounts) {
                                bindDiscount(json_discounts, json_vip, false);
                            }, function() {
                                utils.getHlwDiscountDefault(true, function(default_pack) {
                                    bindDiscount(default_pack, json_vip, false);
                                });
                            });
                        } else {
                            getIapType(function(json_iap) {
                                if (json_iap.useh5 == 1) {
                                    useh5pay = true;
                                    if (typeof json_vip != "undefined") {
                                        var isVisitorVip = false;
                                        if (json_vip.result) {
                                            if (json_vip.result.code == 0) {
                                                if (json_vip.visitor && json_vip.visitor.vip == 1) {
                                                    isVisitorVip = true;
                                                    g_isVisitorVip = true;
                                                } else {
                                                    g_isVisitorVip = false;
                                                }
                                            }
                                        }
                                        if (isVisitorVip) {
                                            pay_type = 1;
                                            useh5pay = false;
                                        }
                                    }
                                } else {
                                    pay_type = 1;
                                    useh5pay = false;
                                    if (json_vip.lenth > 0) {
                                        if (json_vip.result) {
                                            if (json_vip.result.code == 0) {
                                                if (json_vip.visitor && json_vip.visitor.vip == 1) {
                                                    g_isVisitorVip = true;
                                                } else {
                                                    g_isVisitorVip = false;
                                                }
                                            }
                                        }
                                    }
                                }
                                utils.getHlwDiscountAjax(pay_type, function(json_discounts) {
                                    if (useh5pay) {
                                        bindDiscount(json_discounts, json_vip, false);
                                    } else {
                                        bindDiscount(json_discounts, json_vip, false);
                                    }
                                }, function() {
                                    utils.getHlwDiscountDefault(useh5pay, function(default_pack) {
                                        if (useh5pay) {
                                            bindDiscount(default_pack, json_vip, false);
                                        } else {
                                            bindDiscount(default_pack, json_vip, false);
                                        }
                                    });
                                });
                            }, function() {
                                utils.getHlwDiscountAjax(pay_type, function(json_discounts) {
                                    bindDiscount(json_discounts, json_vip);
                                }, function() {
                                    utils.getHlwDiscountDefault(useh5pay, function(default_pack) {
                                        bindDiscount(default_pack, json_vip);
                                    });
                                });
                            });
                        }
                    });
                } else {
                    utils.getHlwDiscountAjax(pay_type, function(json_discounts) {
                        bindDiscount(json_discounts, json_vip, true);
                    }, function() {
                        utils.getHlwDiscountDefault(true, function(default_pack) {
                            bindDiscount(default_pack, json_vip, true);
                        });
                    });
                }
            });
        });
    }

    function bindDiscount(discout_list, json_vip) {
        if (discout_list.hlw_params && discout_list.hlw_params.length > 0) {
            g_hlw_param = discout_list.hlw_params;
        }
        var btnHint = "开通";
        if (typeof json_vip != "undefined") {
            if (json_vip.visitor && json_vip.visitor.vip == 1) {
                btnHint = "续费";
            } else if (json_vip.vip && json_vip.vip == 1) {
                btnHint = "续费";
            }
        }
        if (discout_list.price_list) {
            var payInfo = discout_list.price_list;
            var productPackage = "";
            for (var i = 0; i < payInfo.length; i++) {
                var item = payInfo[i];
                var productId = "";
                if (item.amount && item.amount == "12" && item.type == "month") {
                    $('.pay_btn').attr("data-month-price", item.single_price);
                    if (item.product_id && item.product_id.length > 0) {
                        productId = item.product_id;
                        g_pay_wx_offerId = item.wx_offerid;
                        g_pay_qq_offerId = item.qq_offerid;
                        g_mpid = item.ma;
                    } else {
                        if (isIos && !g_isJBOS) {
                            if (item.month == 12) {
                                productId = "com.tenvideoios.OneYearPay1";
                            }
                        } else {
                            if (item.month == 12) {
                                productId = "1002";
                            }
                        }
                    }
                    $('.pay_btn').attr('data-id', productId);
                }
            }
        }
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var ua = navigator.userAgent;
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }
            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function reportPay(payParam) {
        try {
            var accountType = "";
            var pay_uin = "";
            var openid = "";
            var appid = "";
            var type = 1;
            var step = 1;
            var days = payParam.month * 31;
            var ap = payParam.ap;
            var renew = 1;
            if (ap == 1) {
                renew = 3;
            }
            var payitem = "" + renew + "*" + days;

            getMainCookie(function(json_msg) {
                if (json_msg) {
                    var str_cookie = json_msg.cookie;
                    if (json_msg.type == 'wx') {
                        accountType = 2;
                        openid = getCookieParam(str_cookie, "openid");
                        appid = getCookieParam(str_cookie, "appid");
                    } else if (json_msg.type == 'qq') {
                        accountType = 1;
                        pay_uin = getCookieParam(str_cookie, "uin");
                    }
                    reportQA(pay_uin, openid, appid, type, accountType, payitem, step);
                }
            });
        } catch (ex) {}
    }

    function reportQA(pay_uin, openid, appid, type, accounttype, payitem, step) {
        var url = "https://pay.video.qq.com/fcgi-bin/payreport?otype=json";
        var guid = "";
        var plat = 7;
        var appBuildVerion = "";
        if (isAndroid) {
            plat = 8;
            appBuildVerion = getAppVersionBuild();
        }
        var reportCgi = [url,
            "&pay_uin=", getUin(pay_uin),
            "&openid=", openid,
            "&appid=", appid,
            "&type=", type,
            "&accounttype=", accounttype,
            "&payitem=", payitem,
            "&step=", step,
            "&plat=", plat,
            "&versioncode=", appBuildVerion
        ].join('');
        getDeviceInfo(function(json) {
            guid = json.guid;
            reportCgi = [reportCgi, "&guid=", guid].join('');
            reportQARequest(reportCgi);
        }, function() {
            reportQARequest(reportCgi);
        });
    }

    function reportQARequest(url) {
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {} else {}
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {

            }
        });
    }

    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    //是否海外用户
    function isLimit(suCb, failCb) {
        var limit = cookie.get('oversea_limit');
        if (limit) {
            if (limit == '1') {
                suCb && suCb();
            } else {
                failCb && failCb();
            }
        }
        $.ajax({
            url: 'https://vv.video.qq.com/checktime?_t=1&otype=json',
            dataType: "jsonp",
            success: function(json) {
                if (json && json.s == "o" && json.limit != 0) {
                    cookie.set("oversea_limit", '1', {
                        domain: location.host,
                        path: '/'
                    });
                    !limit && suCb && suCb();
                } else {
                    cookie.set("oversea_limit", '0', {
                        domain: location.host,
                        path: '/'
                    });
                    !limit && failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                !limit && failCb && failCb();
            }
        });
    }

    function showLimit(param) {
        //tap存在点透问题，换成click
        $(".m_layer_mask").show();
        $(".js_overseas_layer").show();
        $('.js_overseas_layer .js_overseas_buy').unbind('click');
        $('.js_overseas_layer .js_overseas_cancel').unbind('click');
        $('.js_overseas_buy').click(function() {
            if ($('.js_overseas_layer').is(":visible")) {
                $(".m_layer_mask").hide();
                $(".js_overseas_layer").hide();
                //TODO::pay
                actionBuy(param);
            }
        });
        $('.js_overseas_cancel').click(function() {
            if ($('.js_overseas_layer').is(":visible")) {
                $(".m_layer_mask").hide();
                $(".js_overseas_layer").hide();
            }
        });
    }



    function showNetErr(isShow) {
        if (isShow) {
            $('.app_nonetwork').show();
            $('.app_container').hide();
        } else {
            $('.app_nonetwork').hide();
            $('.app_container').show();
        }
        $('.app_nonetwork').on('tap', function() {
            location.reload();
        });
    }

    function showScore(json) {
        var payvip = new PayVip(json);
        var scoreVal = json.score > 0 ? json.score : 0;
        $('.bar_c .txt').text('' + scoreVal + '');
        $('.bar_c .bar_inner').css('width', payvip.percent());
        $('.bar_c .bar_pic').css('left', payvip.percent());
        $('.bar_l .level').html('<span class="num">LV' + json.level + '</span>' + payvip.prevScore());
        if (json.vip == 1) {
            if (json.annualvip == 1) {
                $('.mod_btn_list a').html('续费年费VIP会员');
                $('.mod_btn_list a').attr('hottag', 'hlw_app_score_renew_vip');
            }
            if (json.level >= payvip.maxLevel()) {
                $('.bar_c .bar_inner').css('width', '100%');
                $('.bar_c .bar_pic').css('left', '100%');
                $('.bar_l .level').html('<span class="num">LV' + (json.level - 1) + '</span>6000');
                $('.bar_r .level').html('<span class="num">LV' + json.level + '</span>10800');
                $('.pro_info').html('当前速度<span class="num">' + json.dailyscore + '</span>点/天，已到达最高级');
            } else {
                $('.bar_r .level').html('<span class="num">LV' + (json.level + 1) + '</span>' + payvip.nextScore());
                $('.pro_info').html('当前速度<span class="num">' + json.dailyscore + '</span>点/天，' + payvip.levelUp() + ' 天后即可升级到 LV' + (json.level + 1));
            }
            $('.grade_list li').removeClass('current');
            $('.grade_list li:nth-child(' + (Math.min(json.level, payvip.maxLevel()) + 1) + ')').addClass('current');
        } else {
            var hotTag = "hlw_app_score_open_vip";
            if (scoreVal > 600) {
                $('.pro_info').html('正以<span class="num">' + (-json.dailyscore) + '</span>点/天速度下降，' + payvip.degrade() + '天后降级到LV' + (json.level - 1) + '<br>开通VIP立即恢复成长，<a class="scoreGoBack" href="javascript:;" hottag="' + hotTag + '">立即开通</a>');
            } else if (scoreVal > 0 && scoreVal <= 600) {
                $('.pro_info').html('正以<span class="num">' + (-json.dailyscore) + '</span>点/天速度下降，' + payvip.degrade() + '天后成长值将降为0<br>开通VIP立即恢复成长，<a class="scoreGoBack" href="javascript:;" hottag="' + hotTag + '">立即开通</a>');
            } else {
                $('.bar_c .txt').text("0");
                $('.pro_info').hide();
            }
            if (json.level >= payvip.maxLevel()) {
                $('.bar_c .bar_inner').css('width', '100%');
                $('.bar_c .bar_pic').css('left', '100%');
                $('.bar_l .level').html('<span class="num">LV' + (json.level - 1) + '</span>6000');
                $('.bar_r .level').html('<span class="num">LV' + json.level + '</span>10800');
            } else {
                $('.bar_r .level').html('<span class="num">LV' + (json.level + 1) + '</span>' + payvip.nextScore());
            }
            $('.scoreGoBack').on('tap', function() {
                if (getUrlParam('back')) {
                    var url = 'tenvideo2://?action=20';
                    setTimeout(function() {
                        try {
                            TenvideoJSBridge.invoke("openView", {
                                url: url
                            }, function(json_msg) {});
                        } catch (err) {
                            location.href = url;
                        }
                    }, 0);
                } else {
                    setTimeout(function() {
                        try {
                            TenvideoJSBridge.invoke("goBack");
                        } catch (err) {}
                    }, 0);
                }
            });
        }


    }

    function initReport() {
        var hotTag = "app";
        if (aidReport.length > 0) {
            hotTag = ["appScore.", aidReport].join('');
        }
        try {
            pgvSendClick({
                virtualDomain: "film.qq.com",
                hottag: hotTag
            });
        } catch (err) {}

    }

    function getDefaultAid() {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var aidDefault = ['V0$$1:0$2:', platform, '$3:', getAppVersion(), '$11:6'].join('');
        return aidDefault;
    }


    function init() {
        tenvideoReady(function() {
            appCallBack();
            getMainCookie(function(json_msg) {
                var str_cookie = json_msg.cookie;
                var uid = "";
                if (json_msg.type == 'wx') {
                    uid = getCookieParam(str_cookie, "openid");
                } else if (json_msg.type == 'qq') {
                    uid = getCookieParam(str_cookie, "uin");
                }
                if (uid) {
                    var key = ["payvip_info_", uid].join('');
                    if (storage.getItem(key)) {
                        showScore(JSON.parse(storage.getItem(key)));
                    }
                }
            });
            getPayVip(function(json) {
                if (json.result) {
                    if (json.result.code == 0) {
                        showNetErr(false);
                        if (json.vip == 1) {
                            isVipReport = true;
                        } else {
                            isVipReport = false;
                        }
                        getMainCookie(function(json_msg) {
                            var str_cookie = json_msg.cookie;
                            var uid = "";
                            if (json_msg.type == 'wx') {
                                uid = getCookieParam(str_cookie, "openid");
                            } else if (json_msg.type == 'qq') {
                                uid = getCookieParam(str_cookie, "uin");
                            }
                            if (uid) {
                                var key = ["payvip_info_", uid].join('');
                                storage.setItem(key, JSON.stringify(json));
                            }
                        });
                        showScore(json);
                    }
                }
            }, function() {
                showNetErr(true);
            });
            getMainUserInfo(function(json) {
                var data = json.userInfo;
                if (data) {
                    var defaultFace = "style/app_v/img/user/default_160.png";
                    var face = data.headImgUrl ? data.headImgUrl : defaultFace;
                    $('.bar_c .pic img').attr('src', face);
                }
            });
        });
    }

    function actionBuy(param) {
        if (isIos) {
            if (useh5pay) {
                isAccountLogin(function(json_login) {
                    goH5Pay(param);
                }, function() {
                    TenvideoJSBridge.invoke("actionLogin", {
                        "type": "tv"
                    }, function(json_msg) {
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {
                            //未登录的用户登录后先返回个人中心页面
                        }
                    });
                });
            } else {
                if (g_isJBOS) { //越狱手机走h5支付
                    isAccountLogin(function(json_login) {
                        goH5Pay(param);
                    }, function() {
                        TenvideoJSBridge.invoke("actionLogin", {
                            "type": "tv" //get multi-account login entrance
                        }, function(json_msg) {
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {}
                        });
                    });
                } else {
                    TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                        var json = JSON.parse(json_msg);
                        if (json.errCode == 0) {} else {}
                    });

                }
            }
        } else {
            openPayAndroid(param);
        }

        reportPay(param);
        return false;
    }

    function isNewSdkVersion() {
        var appVersion = getAppVersion();
        var isNew = false;
        if (isIos && utils.versionCompare(appVersion, "4.5.5")) {
            isNew = true;
        } else if (isAndroid && utils.versionCompare(appVersion, "4.6.0")) {
            isNew = true;
        }
        return isNew;
    }

    $(document).ready(function() {
        if (isAndroid) {
            $('.js_gamePri_link').show();
            $('.grade_list').removeClass('grade_list_3').addClass('grade_list_4');
        }
        init();
        initReport();
        window.reload = function() {
            location.reload();
        };
        window.reinit = function() {
            init();
        };
        $('.pay_btn').tap(function() {
            var param = {
                month: $(this).attr('data-amount'),
                id: $(this).attr('data-id'),
                code: $(this).attr('data-code'),
                ap: 0,
                product_price: $(this).attr('data-month-price')
            };
            isLimit(function() {
                showLimit(param);
            }, function() {
                actionBuy(param);
            });
        });
        $('.js_ticket_link').tap(function() {
            var isVisitor = false;
            if (g_isVisitorVip) {
                isVisitor = true;
            }
            openUrl(["ticket.html?isVisitor=", isVisitor].join(''), 1);
        });
        $('.js_giveMovie_link').tap(function() {
            var isVisitor = false;
            if (g_isVisitorVip) {
                isVisitor = true;
            }
            openUrl(["givemovie.html?isVisitor=", isVisitor].join(''), 1);
        });
        $('.js_gamePri_link').tap(function() {
            if (isAndroid) {
                var url = 'https://iwan.qq.com/m/vadr/game_center.html?_bid=22';
                openUrl(url, 1);
            }
        });
        $(document).delegate("[hottag]", "tap", function() {
            var hotTag = $(this).attr('hottag');
            if (isVipReport) {
                hotTag += "_isVip";
            } else {
                hotTag += "_notVip";
            }
            if (aidReport.length > 0) {
                hotTag += ['.', aidReport].join('');
            }
            try {
                pgvSendClick({
                    virtualDomain: "film.qq.com",
                    hottag: hotTag
                });
            } catch (err) {}
            return false;
        });
    });


});
