define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    var storage = window.localStorage;
    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;

    var qqUin = "";
    var qqSkey = "";
    var qqVipShiftInfo = "";
    var NETWOKR_ERR = "网络请求超时，请稍后重试";

    $(document).ready(function() {

        $('.qq_to_wx_confirm').tap(function(){
            $('.m_layer_mask').hide();
            $('#qq_to_wx_sec_confirm').hide();
            //show loading
            showLoading(true);
            var type = 2;
            var cookie_msg = JSON.parse(storage.getItem("hlw_qq_shift_cookie_info"));
            qqUin = cookie_msg.uin;
            qqSkey = cookie_msg.skey;
            var param = ["uin=",qqUin,"&skey=",qqSkey,"&type=",type].join('');
            shiftQQVip2WX(param,function(json_msg){
                var shitfInfo = storage.getItem("hlw_qq_shift_info");
                saveWXFakeData(shitfInfo);
                //delay 2 seconds hide loading
                setTimeout(function(){
                    showLoading(false);
                    showSucToast(["成功将VIP身份转移至微信帐号，原QQ号",getUin(qqUin),"VIP身份已失效。"].join(''));
                    //notify app
                    refreshVipInfo();
                    removeShiftInfo();
                    removePtLoginChkFrame();
                },200);
            },function(json_err){
                showLoading(false);
                $('.m_layer_mask').hide();
                $('#qq_to_wx_layer').hide();
                if (json_err) {
                   var errCode = json_err.result.code;
                   var msg = getErrMsg(errCode,getUin(qqUin));
                   showErrToast(msg);
                   removeWXFakeData();
                } else {
                    showErrToast(NETWOKR_ERR);
                }

            });
        });

        $('.qq_to_wx_sec_confirm').tap(function(){
            $('#qq_to_wx_layer').hide();
            $('.m_layer_mask').show();
            $('#qq_to_wx_sec_confirm').show();
        });

        $('.qq_to_wx_cancel').tap(function(){
            $('.m_layer_mask').hide();
            $('#qq_to_wx_sec_confirm').hide();
            //closePage();
        });

        $('.shift_succ_confirm').tap(function(){
            $('.m_layer_mask').hide();
            $('#qq_to_wx_success_layer').hide();
            closePage();
        });

        $('.shift_err_cancel').tap(function(){
            $('.m_layer_mask').hide();
            $('#qq_to_wx_err_layer').hide();
            closePage();
        });

        $('.shift_err_retry').tap(function(){
            $('.m_layer_mask').hide();
            $('#qq_to_wx_err_layer').hide();
            transformQQ2WXRetry();
        });

        init();
        window.reload = function() {
            location.reload();
        };
        window.addEventListener('message',function(event) {
            e.preventDefault();
            var rtnDate = event.data;
            var uin = rtnDate.uin;
            var skey = rtnDate.skey;
            shiftFromPt(uin,skey);
        },false);
    });

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == "undefined") {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function init() {
         tenvideoReady(function() {
            appCallBack();
        });
    }

    function appCallBack() {
        transformQQ2WX();
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            log(["getMainUserInfo:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            log(["getMainCookie:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function qqVip2WXLogin(suCb, failCb){
        TenvideoJSBridge.invoke("qqVip2WX", null, function(json_msg) {
            log(["qqVip2WX:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb(json);
            }
        });
    }

    function refreshVipInfo(){
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("refreshVipInfo");
            } catch (err) {}
        }, 0);
    }

    function shiftQQVip2WX(param,suCb,failCb){
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }

        getDeviceInfo(function(json){
            var guid = json.guid;
            var url = ["https://pay.video.qq.com/fcgi-bin/transuin2wx?otype=json&platform=", platform, "&guid=",guid,"&", param].join('');
            shiftQQVip2WXCb(url,suCb,failCb);
        },function(){
            var url = ["https://pay.video.qq.com/fcgi-bin/transuin2wx?otype=json&platform=", platform, "&", param].join('');
            shiftQQVip2WXCb(url,suCb,failCb);
        });
    }

    function shiftQQVip2WXCb(url,suCb,failCb){
        $.ajax({
            url: url,
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    suCb && suCb(json);
                } else {
                    failCb && failCb(json);
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function shiftFromPt(uin,skey){
        var type = 1;
        var param = ["uin=",uin,"&skey=",skey,"&type=",type].join('');
        showLoading(true);
        shiftQQVip2WX(param,function(json_shift){
            storage.setItem("hlw_qq_shift_info",JSON.stringify(json_shift));
            //storage.setItem("hlw_qq_shift_cookie_info",JSON.stringify(json_msg));
            getShiftInfo(uin,skey,function(shift_info){
                storage.setItem("hlw_qq_shift_cookie_info",JSON.stringify(shift_info));
            }),
            setTimeout(function(){
                showLoading(false);
                openUrl("shift.html",1);
            },200);

        },function(json_shift_err){
            showLoading(false);
            if (!!json_shift_err) {
               var errCode = json_shift_err.result.code;
               var msg = getErrMsg(errCode,getUin(qqUin));
               showErrToast(msg);
            } else {
                showErrToast(NETWOKR_ERR);
            }

        });
    }

    function isQQInstalled(suCb, failCb){
        var pkgName = "";
        if (isIos) {
            pkgName = "mqq";
        }else {
            pkgName = "com.tencent.mobileqq";
        }
        var pkgUrl = "mqq://";
        TenvideoJSBridge.invoke("isInstalled", {
            "pkgName":pkgName,
            "pkgUrl":pkgUrl
        }, function(json_msg) {
            log(["isInstalled:", json_msg].join(''));
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb(json);
            }
        });
    }

    function transformQQ2WX(){
        if (storage.getItem("hlw_qq_shift_info")
            && storage.getItem("hlw_qq_shift_cookie_info")) {
            qqVipShiftInfo = JSON.parse(storage.getItem("hlw_qq_shift_info"));
            var cookie_msg = JSON.parse(storage.getItem("hlw_qq_shift_cookie_info"));
            var endTime = qqVipShiftInfo.endTime;
            var ticketNum = qqVipShiftInfo.ticket_count;
            var wxAccount = cookie_msg.wx;
            var qqAccount = cookie_msg.qq;
            if (endTime) {
                $('.shift_endTime_qq').text(endTime.substr(0, 10));
                $('.shift_ticket_qq').text([ticketNum,"张"].join(''));
                $('.shift_nick_qq').text(qqAccount.nickname?qqAccount.nickname:qqAccount.nickName);
                var defaultImgUrl = "style/app_v/img/user/default_160.png";
                var qqHeadImgUrl = qqAccount.headImgUrl?qqAccount.headImgUrl:defaultImgUrl;
                $('.shift_face_qq').attr("src",qqHeadImgUrl);
                $('.shift_nick_wx').text(wxAccount.nickname?wxAccount.nickname:wxAccount.nickName);
                var wxHeadImgUrl = wxAccount.headImgUrl?wxAccount.headImgUrl:defaultImgUrl;
                $('.shift_face_wx').attr("src",wxHeadImgUrl);
            }
        }
    }

    function transformQQ2WXRetry(){
        isQQInstalled(function(json_msg){
            var isInstalled = json_msg.installed;
            if (!isInstalled) {
                var timestamp  = (new Date()).valueOf();
                var ptLoginChkSrc = ["https://film.qq.com/app/ptlogincheck.html?stamp=",timestamp].join('');
                createPtLoginChkFrame(ptLoginChkSrc);
                var backUrl = encodeURIComponent(location.toString());
                var openPtLogin = ["https://film.qq.com/app/ptlogin.html?ru=",backUrl,"&stamp=",timestamp].join('');
                openUrl(openPtLogin,1);
            } else {
                qqVip2WXLogin(function(json_msg){
                    var cookieData = json_msg.cookie;
                    qqUin = getCookieParam(cookieData,"uin");
                    qqSkey = getCookieParam(cookieData,"skey");
                    var type = 1;
                    var param = ["uin=",qqUin,"&skey=",qqSkey,"&type=",type].join('');

                    showLoading(true);
                    shiftQQVip2WX(param,function(json_shift){
                        showLoading(false);
                        var endTime = json_shift.endTime;
                        var ticketNum = json_shift.ticket_count;
                        var wxAccount = json_msg.wx;
                        var qqAccount = json_msg.qq;
                        if (endTime) {
                            $('.shift_endTime_qq').text(endTime.substr(0, 10));
                            $('.shift_ticket_qq').text([ticketNum,"张"].join(''));
                            $('.shift_nick_qq').text(qqAccount.nickname);
                            var defaultImgUrl = "style/app_v/img/user/default_160.png";
                            var qqHeadImgUrl = qqAccount.headImgUrl?qqAccount.headImgUrl:defaultImgUrl;
                            $('.shift_face_qq').attr("src",qqHeadImgUrl);
                            $('.shift_nick_wx').text(wxAccount.nickname);
                            var wxHeadImgUrl = wxAccount.headImgUrl?wxAccount.headImgUrl:defaultImgUrl;
                            $('.shift_face_wx').attr("src",wxHeadImgUrl);
                        }
                    },function(json_shift_err){
                        showLoading(false);
                        if (json_shift_err) {
                           var errCode = json_shift_err.result.code;
                           var msg = getErrMsg(errCode,getUin(qqUin));
                           showErrToast(msg);
                        } else {
                            showErrToast(NETWOKR_ERR);
                        }

                    });

                },function(json_err){
                    showLoading(false);
                });
            }
        });
    }

    function getShiftInfo(uin, skey, sucCb, failCb){
        var d_wx = $.Deferred();
        var d_qq = $.Deferred();
        $.when(d_wx, d_qq).done(function(json_wx, json_qq) {
            log('wx:' + JSON.stringify(json_wx));
            log('qq:' + JSON.stringify(json_qq));
            var SHIFT_INFO = {};
            SHIFT_INFO.uin = uin;
            SHIFT_INFO.skey = skey;
            var defaultFace = "style/app_v/img/user/default_160.png";
            SHIFT_INFO.qq = {
                "nickname": json_qq.nick,
                "headImgUrl":json_qq.qqface?json_qq.qqface:defaultFace
            };
            var wxAccount = json_wx.userInfo;
            SHIFT_INFO.wx = {
                "nickname":wxAccount.nickname,
                "headImgUrl":wxAccount.headImgUrl?wxAccount.headImgUrl:defaultFace
            };
            sucCb && sucCb(SHIFT_INFO);
        });
        getQQNick(skey,function(json) {
            d_qq.resolve(json);
        }, function() {
            d_qq.resolve();
        });
        getMainUserInfo(function(json) {
            d_wx.resolve(json);
        }, function() {
            d_wx.resolve();
        });
    }

    function saveWXFakeData(data){
        getMainCookie(function(json_msg){
            var str_cookie = json_msg.cookie;
             if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_",openid].join('');
                storage.setItem(key,data);
            }
        });
    }

    function removeWXFakeData(){
        getMainCookie(function(json_msg){
            var str_cookie = json_msg.cookie;
             if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_",openid].join('');
                if (storage.getItem(key)) {
                    storage.removeItem(key);
                }
            }
        });
    }

    function getWXFakeData(suCb,failCb){
        getMainCookie(function(json_msg){
            var str_cookie = json_msg.cookie;
             if (json_msg.type == 'wx') {
                var openid = getCookieParam(str_cookie, "openid");
                var key = ["app_hlw_qq_to_wx_info_",openid].join('');
                if (storage.getItem(key)) {
                    var data = JSON.parse(storage.getItem(key));
                    suCb && suCb(data);
                }else{
                    failCb && failCb();
                }
            }else {
                failCb && failCb();
            }
        });
    }

    function createPtLoginChkFrame(src){
        $('.app_container').after($("<iframe width='0' height='0' id='ptLoginStorageFrame' scrolling='no' frameborder='0'></iframe>"));
        $("#ptLoginStorageFrame").attr("src", src);
    }

    function removePtLoginChkFrame(){
        $("#ptLoginStorageFrame").remove();
    }

    function time33(skey) {
        // 哈希time33算法
        for (var i = 0, len = skey.length, hash = 5381; i < len; ++i) {
            hash += (hash << 5) + skey.charAt(i).charCodeAt();
        };
        return hash & 0x7fffffff;
    }
    function getToken(skey){
        return time33(skey);
    }

    function getQQNick(skey,sucCb, failCb) {
        $.ajax({
            url: "https://c.video.qq.com/cgi-bin/login?otype=json&nes=1&low_login=1&callback=jsonp",
            data: {
                g_tk:getToken(skey)
            },
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result && json.result.code == 0) {
                    sucCb && sucCb(json);
                } else {
                    failCb && failCb();
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function getErrMsg(errCode, uin){
        var uinStr = uin?uin:"";
        var errMsg = ["内部错误(错误码:",errCode,")。"].join('');
        if (errCode == "-11") {
            errMsg = "系统繁忙，请退出并重新登录后再次尝试。";
        } else if (errCode == "10001") {
            errMsg = ["QQ号",uinStr,"已转移过VIP会员，不能再次转移。"].join('');
        } else if (errCode == "10002") {
            errMsg = "wx没有转移权限。";
        } else if (errCode == "10003") {
            errMsg = "系统繁忙，请稍候重试。";
        } else if (errCode == "11007") {
            errMsg = ["QQ号",uinStr,"未开通VIP会员，无法转移。"].join('');
        } else if (errCode == "11012") {
            errMsg = "暂时不支持后付费用户转移";
        } else if (errCode == "11013") {
            errMsg = "超过时间范围";
        }
        return errMsg;
    }

    function showErrToast(msg){
        $('#shit_err_msg').text(msg);
        $('.m_layer_mask').show();
        $('#qq_to_wx_err_layer').show();
    }

    function showSucToast(msg){
        $("#shit_success_msg").text(msg);
        $('.m_layer_mask').show();
        $("#qq_to_wx_success_layer").show();
    }

    function removeShiftInfo(){
        storage.removeItem("hlw_qq_shift_info");
        storage.removeItem("hlw_qq_shift_cookie_info");
    }

    function getDeviceInfo(suCb,failCb){
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function showLoading(isShow) {
        var delay = 0;
        if (!isShow) {
            delay = 10;
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("setLoading", {
                    visible: isShow
                });
            } catch (err) {}
        }, delay);
    }

    function closePage(){
        TenvideoJSBridge.invoke("close",null);
    }

    function goBack(){
        TenvideoJSBridge.invoke("goBack",null);
    }

    function openUrl(url) {
        showLoading(true);
        if (url.indexOf('://') == -1) {
            url = getAbsoluteUrl(url);
        }
        setTimeout(function() {
            try {
                TenvideoJSBridge.invoke("openUrl", {
                    url: url
                }, function(json_msg) {
                    //location.href = url;
                    showLoading(false);
                });
            } catch (err) {
                showLoading(false);
                location.href = url;
            }
        }, 0);
    }

    /**
     * @description 获得相对路径的绝对路径
     * @param {string} url 相对路径
     **/
    function getAbsoluteUrl(url) {
        var div = document.createElement('div');
        div.innerHTML = ['<a href=', url, '></a>'].join('');
        return div.firstChild.href;
    }

    function getUin(uinStr){
        var ret = "";
        if (uinStr) {
            var reg=/^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    function removeQueryParam(sourceURL ,key) {
        var rtn = sourceURL.split("?")[0],
            param,
            params_arr = [],
            queryString = (sourceURL.indexOf("?") !== -1) ? sourceURL.split("?")[1] : "";
        if (queryString !== "") {
            params_arr = queryString.split("&");
            for (var i = params_arr.length - 1; i >= 0; i -= 1) {
                param = params_arr[i].split("=")[0];
                if (param === key) {
                    params_arr.splice(i, 1);
                }
            }
            rtn = rtn + "?" + params_arr.join("&");
        }
        return rtn;
    }

    function report(uin) {
        if (isIos) {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 1);
        } else if (isAndroid) {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 2);
        } else {
            reportBoss(uin, 'app.hlw.user.privilege', 'plat', 0);
        }
    }

    /**
     * BOSS上报
     * @param {} uin UIN
     * @param {} biz 业务名称
     * @param {} op 操作名称
     * @param {} sta 操作状态 数字
     */
    function reportBoss(uin, biz, op, sta) {
        var g_btrace_BOSS = new Image(1, 1);
        g_btrace_BOSS.src = ["https://btrace.qq.com/collect?&sIp=",
            "&iQQ=", uin,
            "&sBiz=", biz,
            "&sOp=", op,
            "&iSta=", sta,
            "&iTy=", 2429,
            "&iFlow=",
            "&sUrl=", encodeURIComponent(location.toString()),
            "&sRef=", encodeURIComponent(document.referrer),
            "&sPageId=",
            "&sPos=",
            "&_=", Math.random()
        ].join("");
    }


    //获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function log(content) {
        content = content.replace(/\r\n/g, " ");
        content = content.replace(/\n/g, " ");
        console.log(content);
    }
});
