define(function(require, exports, module) {
    // 通过 require 引入依赖
    require('zepto');
    //aid,上报相关
    //aid,上报相关
    var reportApi_new = require('./common/report/client');
    var reportConf_new = require('./common/report/report_conf');
    var reportConf_hottag = require('./common/report/report_conf').hottagConf;
    var aidReport = require('./common/report/aid').init();

    var ua = navigator.userAgent;
    var isIos = ua.indexOf("iPhone") != -1 ? true : false;
    var isAndroid = ua.indexOf("Android") != -1 ? true : false;
    var storage = window.localStorage;
    var normalizer = require('./common/urlFactory').createNormalizer();
    var utils = require('./utils');

    function getUin(uinStr) {
        var ret = "";
        if (uinStr) {
            var reg = /^o0*/g;
            if (reg.test(uinStr)) {
                ret = parseInt(uinStr.replace(/^o0*/g, ""), 10);
            } else {
                ret = uinStr;
            }
        }
        return ret;
    }

    function isAccountLogin(suCb, failCb) {
        getMainUserInfo(function(json) {
            if (json && json.userInfo) {
                suCb && suCb(json);
            } else {
                failCb && failCb();
            }
        }, function() {
            failCb && failCb();
        });
    }

    function getMainUserInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainUserInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getMainCookie(suCb, failCb) {
        TenvideoJSBridge.invoke("getMainCookie", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function getCookieParam(cookieStr, key) {
        var cookieObj = {},
            cookieSplit = [],
            // 以分号（;）分组
            cookieArr = cookieStr.split(";");
        for (var i = 0, len = cookieArr.length; i < len; i++) {
            if (cookieArr[i]) {
                // 以等号（=）分组
                cookieSplit = cookieArr[i].split("=");
                // Trim() 是自定义的函数，用来删除字符串两边的空格
                cookieObj[cookieSplit[0]] = cookieSplit[1];
            }
        }
        return cookieObj[key];
    }

    // 观影券展示
    function ticketShow(guid) {
        var skey = '';
        var param = {
            uin: '',
            guid: guid,
            platform: 7,
            isVisitor: '',
            g_tk: ''
        }
        if (isAndroid) {
            param.platform = 8;
        }
        if (param.platform == 7) {
            if (getUrlParam('isVisitor') == 'true') {
                param.isVisitor = 1;
            }
        }
        isAccountLogin(function() {
            getMainCookie(function(json_user) {
                var cookieStr = json_user.cookie;
                var accountType = json_user.type;
                if (accountType == "qq") {
                    param.uin = getUin(getCookieParam(cookieStr, "uin"));
                    skey = getCookieParam(cookieStr, "skey");
                    param.g_tk = getToken(skey);
                } else {
                    param.g_tk = getToken(skey);
                }
                getTicketData(param, function(json) {
                    fillTicketDom(json);
                });
            });
        }, function() {
            getTicketData(param, function(json) {
                fillTicketDom(json);
            });
        });
    }

    function fillTicketDom(json) {
        var ticketItem = '';
        if (json.list) {
            for (var i = 0, l = json.list.length; i < l; i++) {
                ticketItem += '<li class="list_item"><span class="txt">VIP赠券<span class="time">' + json.list[i].end + '</span>过期</span><span class="num">' + json.list[i].ticket_cnt + '</span></li>';
            }
            if (ticketItem != '') {
                $('.coupon_list').html(ticketItem);
                $('.mod_coupon_no').hide();
            } else {
                $('.mod_coupon_no').show();
            }
        } else {
            $('.mod_coupon_no').show();
        }
    }

    // 用券影片展示
    function ticketFilmShow() {
        getTicketFilmData().then(function(json) {
            fillTicketFilm(json);
        });
    }

    //取专辑竖图小尺寸地址
    function picSizeSet(url, size) {
        // puui.qpic.cn域名图片规则
        //http://tapd.oa.com/MediaContent/markdown_wikis/#1010093801005051145
        var sizeArr = [75, 92, 116, 130, 161, 175, 220, 260, 350, 450, 770];
        if (sizeArr.indexOf(size) < 0) {
            size = 350;
        }
        return url.replace(/\/0$/, '/' + size);
    }

    function fillTicketFilm(movies) {
        var filmItem = '';
        if (movies) {
            for (var i = 0, l = movies.length; i < l; i++) {
                var hotTag = reportConf_hottag.vipMovie_detail;
                var url = ['tenvideo2://?action=1&cover_id=', movies[i].cover_id, '&demandVersion=2.6.0'].join('');
                var cover_pic = picSizeSet(movies[i].pic_l, 130);
                filmItem += '<li class="item"><a href="javascript:;" data-url="' + url + '" class="figure" hottag="' + hotTag + '" f_cid="' + movies[i].cover_id + '"><span class="figure_pic"><img src="' + normalizer(cover_pic) + '" alt="' + movies[i].title + '">' + getIconTag(movies[i].aphone40_imgtag) + '</span><span class="figure_title figure_title_multirow">' + movies[i].title + '</span></a></li>';
            }
            if (filmItem != '') {
                $('.mod_figure').html(filmItem);
                $('.mod_tit_item').show();
            }
        }
    }

    function getIconTag(imgTagParam) {

        return utils.getCoverCorner(imgTagParam);
    }

    // 获取观影券信息
    function getTicketData(param, suCb, failCb) {
        $.ajax({
            url: normalizer("https://pay.video.qq.com/fcgi-bin/user_ticket?otype=json"),
            data: {
                low_login: 1,
                uin: param.uin,
                _t: 5,
                status: 1,
                psize: 20,
                guid: param.guid,
                platform: param.platform,
                isVisitor: param.isVisitor,
                versioncode: getAppVersionBuild(),
                g_tk: param.g_tk
            },
            dataType: "jsonp",
            success: function(json) {
                if (json && json.result.code == 0) {
                    getMainCookie(function(json_msg) {
                        var str_cookie = json_msg.cookie;
                        var uid = "";
                        if (json_msg.type == 'wx') {
                            uid = getCookieParam(str_cookie, "openid");
                        } else if (json_msg.type == 'qq') {
                            uid = getCookieParam(str_cookie, "uin");
                        }
                        if (uid) {
                            var key = ["ticket_info_", uid].join('');
                            storage.setItem(key, JSON.stringify(json));
                        }
                    });
                    suCb && suCb(json);
                    showNetErr(false);
                } else {
                    failCb && failCb();
                    showNetErr(true);
                }
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
                showNetErr(true);
            }
        });
    }

    // 获取用券、热播前6部
    function getTicketFilmData(amount) {
        var $defer = $.Deferred();
        amount = amount || 6;
        $.ajax({
            url: normalizer("http://list.video.qq.com/fcgi-bin/list_common_cgi?otype=json"),
            dataType: "jsonp",
            data: {
                novalue: 1,
                platform: 5,
                version: 10000,
                tid: 573,
                uappkey: 'd2a6457eb8ae927a',
                uappid: 20001172,
                intfname: 'hollywood_movie',
                sourcetype: 1,
                type: 1,
                pagesize: 6,
                offset: 0,
                sort: 17,
                itype: -1,
                iattribute: 1,
                iawards: -1
            }
        }).done(function(res) {
            var movies;
            if (res && res.ret == 0 && res.jsonvalue && res.jsonvalue.results) {
                movies = res.jsonvalue.results || [];
                movies = movies.filter(function(item) {
                    return item.fields;
                });
                movies = movies.map(function(item) {
                    var fields = item.fields || {};
                    fields.pic_l = fields.new_pic_vt;
                    return fields;
                });
                $defer.resolve(movies || []);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function initLevelList() {
        getPayVip(function(json) {
            // alert(JSON.stringify(json));
            if (json.vip == 1) {
                $('.js_rule_list li').removeClass('current');
                $('.js_rule_list li:nth-child(' + (json.level + 1) + ')').addClass('current');
            }
            if (json.vip == 1 && json.nextgivedate > 0) {
                var nextTime = new Date(json.nextgivedate * 1000);
                var nextTimeDate = nextTime.getFullYear() + '-' + pad(nextTime.getMonth() + 1) + '-' + pad(nextTime.getDate());
                $('.js_next_time .num').text(nextTimeDate);
                $('.js_next_time').show();
            }
        });
    }

    // 日期左补0
    function pad(n) {
        return n < 10 ? '0' + n : n;
    }

    function showNetErr(isShow) {
        if (isShow) {
            $('.app_nonetwork').show();
            $('.app_container').hide();
        } else {
            $('.app_nonetwork').hide();
            $('.app_container').show();
        }
        $('.app_nonetwork').on('tap', function() {
            location.reload();
        });
    }

    function getAppVersion() {
        var versionCode = "4.1.0";
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var ua = navigator.userAgent;
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (isAndroid) {
                    if (verTmpArr.length >= 4) {
                        versionCode = [verTmpArr[0], ".", verTmpArr[1], ".", verTmpArr[2]].join('');
                    }
                } else if (isIos) {
                    versionCode = verTmp;
                }
            }
        }
        return versionCode;
    }

    function getAppVersionBuild() {
        var versionCode = 8400;
        if (/ QQLiveBrowser\//.test(navigator.userAgent)) {
            var posBrowser = ua.indexOf("QQLiveBrowser");
            var tmp = ua.substring(posBrowser);
            var arrRtn = tmp.split('/');
            if (arrRtn.length >= 2) {
                var verTmp = arrRtn[1];
                var verTmpArr = verTmp.split('.');
                if (verTmpArr.length >= 4) {
                    versionCode = verTmpArr[3];
                }
            }
        }
        return versionCode;
    }

    function getDeviceInfo(suCb, failCb) {
        TenvideoJSBridge.invoke("getDeviceInfo", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    // 获取url中的参数
    function getUrlParam(name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg); //匹配目标参数
        if (r != null) return unescape(r[2]);
        return null; //返回参数值
    }

    function appCallBack() {
        initLevelList();
        getMainCookie(function(json_msg) {
            var str_cookie = json_msg.cookie;
            var uid = "";
            if (json_msg.type == 'wx') {
                uid = getCookieParam(str_cookie, "openid");
            } else if (json_msg.type == 'qq') {
                uid = getCookieParam(str_cookie, "uin");
            }
            if (uid) {
                var ticketKey = ["ticket_info_", uid].join('');
                if (storage.getItem(ticketKey)) {
                    fillTicketDom(JSON.parse(storage.getItem(ticketKey)));
                }
            }
        });
        var url = "";
        url = ["tenvideo2://?action=3&channelId=100120&filter=channel_type",
            encodeURIComponent("="), "movie",
            encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
            encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
            encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
            encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
            encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "1",
            encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
            encodeURIComponent("&"), "type", encodeURIComponent("="), "1"
        ].join('');
        if (isAndroid) {
            url = ["txvideo://v.qq.com/VideoListExhibitActivity?&channelId=100120&filter=channel_type",
                encodeURIComponent("="), "movie",
                encodeURIComponent("&"), "sort", encodeURIComponent("="), "17",
                encodeURIComponent("&"), "iarea", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "itype", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iyear", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "iattribute", encodeURIComponent("="), "1",
                encodeURIComponent("&"), "iawards", encodeURIComponent("="), "-1",
                encodeURIComponent("&"), "type", encodeURIComponent("="), "1",
                "&channelTitle=VIP会员&uiType=6"
            ].join('');
        }
        $('#more_ticket').attr('data-url', url);
        getDeviceInfo(function(json) {
            var guid = json.guid;
            ticketShow(guid);
        });
        ticketFilmShow();
    }

    function time33(skey) {
        // 哈希time33算法
        for (var i = 0, len = skey.length, hash = 5381; i < len; ++i) {
            hash += (hash << 5) + skey.charAt(i).charCodeAt();
        };
        return hash & 0x7fffffff;
    }

    function getToken(skey) {
        return time33(skey);
    }

    function getPayVip(suCb, failCb) {
        TenvideoJSBridge.invoke("getPayVip", null, function(json_msg) {
            var json = JSON.parse(json_msg);
            if (json.errCode == 0) {
                suCb && suCb(json.result);
            } else {
                failCb && failCb();
            }
        });
    }

    function tenvideoReady(fun) {
        fun = fun || function() {};
        if (typeof TenvideoJSBridge == 'undefined') {
            if (document.addEventListener) {
                document.addEventListener('onTenvideoJSBridgeReady', fun, false);
            } else if (document.attachEvent) {
                document.attachEvent('onTenvideoJSBridgeReady', fun);
            }
        } else {
            fun();
        }
    }

    function initReport() {
        try {
            reportApi_new.expose({ f_aid: aidReport.replace(/\$/g, '|||'), f_hottag: "ticket_page" });
        } catch (err) {}
    }

    function getDefaultAid() {
        var platform = 7;
        if (isAndroid) {
            platform = 8;
        }
        var aidDefault = ['V0$$1:0$2:', platform, '$3:', getAppVersion(), '$11:6'].join('');
        return aidDefault;
    }

    function init() {
        tenvideoReady(function() {
            appCallBack();
        });
    }

    $(document).ready(function() {
        init();
        initReport();
        window.reload = function() {
            location.reload();
        };
        window.reinit = function() {
            init();
        };
        $(document).delegate('[data-url]', 'tap', function() {
            var url = $(this).attr('data-url');
            setTimeout(function() {
                try {
                    TenvideoJSBridge.invoke('openView', {
                        url: url
                    }, function(json_msg) {});
                } catch (err) {
                    location.href = url;
                }
            }, 0);
        });
        $('.js_renew').on('tap', function() {
            if (getUrlParam('back')) {
                var url = 'tenvideo2://?action=20';
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("openView", {
                            url: url
                        }, function(json_msg) {});
                    } catch (err) {
                        location.href = url;
                    }
                }, 0);
            } else {
                setTimeout(function() {
                    try {
                        TenvideoJSBridge.invoke("goBack");
                    } catch (err) {}
                }, 0);
            }
        });
        $(document).delegate("[hottag]", "tap", function() {
            var hotTag = $(this).attr('hottag');
            var f_cid = $(this).attr('f_cid');
            var f_module = reportConf_new.getModule(hotTag);
            try {
                reportApi_new.click({ f_module: f_module,f_aid: aidReport, f_cid:f_cid});
            } catch (err) {}
            return false;
        });
    });

});
