/**
 *个人中心首页世界排名提示
 */
define(function(require, exports, module) {
    var utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer();

    var LAST_TIME_REQ_COUPON_TIP_KEY = '_app_last_time_req_voucher_tip';
    var LAST_REQ_COUPON_TIP_KEY = '_app_last_req_voucher_tip';
    var localStorage = window.localStorage;
    var tipsShowTid = 0;

    function _reqMyWorldRank() {
        var $defer = $.Deferred();

        $.ajax({
            url: normalizer('http://pay.video.qq.com/fcgi-bin/get_growth_rank?cmd=60542&low_login=1&otype=json'),
            dataType: 'jsonp',
            data: {
                platform1: utils.getPlatform()
            }
        }).done(function(res) {
            if (res && res.result && res.result.code == 0) {
                $defer.resolve({
                    my_world_rank:res.my_world_rank,
                    my_world_rank_diff:res.my_world_rank_diff
                });
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });

        return $defer.promise();
    }

    function _setStorageKey(key, sub) {
        utils.getUserid(function(uid) {
            var key_storage = [key, '_', uid].join('');
            sub && sub(key_storage);
        });
    }

    function _needShowCouponTip(sub) {
        var lastReqTime,
            weekRange;

        if (!localStorage) {
            return true;
        }
        _setStorageKey(LAST_TIME_REQ_COUPON_TIP_KEY, function(key) {
            lastReqTime = parseInt(localStorage.getItem(key));
            var isNeed = 1;
            if (!lastReqTime || isNaN(lastReqTime)) {
                isNeed = 1;
            }
            weekRange = _calcCurrWeekRange();
            if (lastReqTime >= weekRange[0] && lastReqTime <= weekRange[1]) {
                isNeed = 0;
            }
            sub && sub(isNeed);
        });
    }

    function _calcCouponVipInfo(vipEndtime,couponNum) {

    }

    function _markHasShowCouponTip() {
        if (!localStorage) {
            return;
        }
        _setStorageKey(LAST_TIME_REQ_COUPON_TIP_KEY, function(key) {
            localStorage.setItem(key, Date.now());
        });

    }

    function _markLastShowWorldRank(rank) {
        if (!localStorage) {
            return;
        }
        _setStorageKey(LAST_REQ_COUPON_TIP_KEY, function(key) {
            localStorage.setItem(key, rank);
        });
    }

    function _calcCurrWeekRange() {
        var today = new Date(),
            todayWeekday = today.getDay(),
            firstDayOfWeek,
            lastDayOfWeek;

        today.setHours(0);
        today.setMinutes(0);
        today.setSeconds(0);
        firstDayOfWeek = new Date(today.getTime());
        lastDayOfWeek = new Date(today.getTime());

        firstDayOfWeek.setDate(today.getDate() - todayWeekday);
        lastDayOfWeek.setDate(today.getDate() + (8 - todayWeekday));
        lastDayOfWeek.setSeconds(-1);

        return [firstDayOfWeek.getTime(), lastDayOfWeek.getTime()];
    }

    function _calcRankTrend(rankCurrent) {
        _setStorageKey(LAST_REQ_COUPON_TIP_KEY, function(key) {
            var rankStorage = localStorage.getItem(key);
            if (rankStorage) {
                if (rankStorage < rankCurrent) {
                    return "icon_demote";
                } else {
                    return "icon_upgrade";
                }
            } else {
                return "icon_upgrade";
            }

        });

    }

    function init() {
        _needShowCouponTip(function(isNeed) {
            if (isNeed == 1) {
                //TODO::会员有效期大于15天且有优惠券
                _markHasShowCouponTip();
                /*_reqMyWorldRank().done(function(rank) {
                    $('.js_worldRank_txt').text(rank.my_world_rank);
                    _markHasShowCouponTip();
                    _markLastShowWorldRank(rank.my_world_rank);
                    if(rank.my_world_rank_diff){
                        if(rank.my_world_rank_diff>0){
                            $('.js_worldRank_wrapper .icon_up_sm').show();
                        }else{
                            $('.js_worldRank_wrapper .icon_demote_sm').show();
                        }
                    }
                    $('.js_worldRank_wrapper').css({"opacity": "0" });
                    $('.js_worldRank_wrapper').show();
                    setTimeout(function(){
                        $('.js_worldRank_wrapper').css({ "opacity": "1","transition": "opacity 2s linear;"});
                    },0);

                    if (tipsShowTid == 0) {
                        tipsShowTid = setTimeout(function() {
                            $('.js_worldRank_wrapper').css({"opacity": "1" });
                            setTimeout(function(){
                                $('.js_worldRank_wrapper').css({ "opacity": "0","transition": "opacity 1s linear;"});
                                //$('.js_worldRank_wrapper').hide();
                            },0);
                        }, 5e3);//5后消失
                    }

                });*/
            }
        });
    }

    function clearCouponTipStorage() {
        tipsShowTid = 0;
        _setStorageKey(LAST_TIME_REQ_COUPON_TIP_KEY, function(key) {
            if (localStorage.getItem(key)) {
                localStorage.removeItem(key);
            }
        });
        _setStorageKey(LAST_REQ_COUPON_TIP_KEY, function(key) {
            if (localStorage.getItem(key)) {
                localStorage.removeItem(key);
            }
        });
    }

    module.exports = {
        init: init,
        clearCouponTipStorage: clearCouponTipStorage
    };
});
