package com.tencent.qqlive.ona.offline.aidl;

import com.tencent.qqlive.ona.offline.aidl.IOfflineCallback;
import com.tencent.qqlive.ona.offline.aidl.DownloadRichRecord;
import com.tencent.qqlive.ona.offline.aidl.StorageDevice;
import com.tencent.qqlive.ona.offline.aidl.DownloadRecordPageResponse;
import com.tencent.qqlive.ona.offline.aidl.FinishGroupInfo;
import com.tencent.qqlive.ona.offline.aidl.DownloadingGroupInfo;

interface IOfflineService{
    oneway void registerOfflineCallback(IOfflineCallback callback);
    DownloadRichRecord queryDownload(String vid, String format);
    DownloadRichRecord queryPreDownload(String preKey);
    boolean hasDownloadingRecord();
    boolean isDownloadingInFreeMobileNet();
    StorageDevice getCurrentStorage();
    boolean isCurrentStorageHasEnoughSpace(long newRecordSize);
    long getCurrentAvailableSize();
    oneway void addDownloadList(in List<DownloadRichRecord> downloadRichRecordList);
    oneway void startFirstRecord();
    oneway void startAllUnFinishedRecord();
    oneway void stopAllUnFinishedRecord();
    oneway void removeDownloadRecordList(in List<DownloadRichRecord> downloadRichRecordList);
    oneway void stopDownload(in DownloadRichRecord downloadRichRecord);
    oneway void resumeDownload(in DownloadRichRecord downloadRichRecord);
    String getCurrentStorageID();
    boolean isRecordWatched(String vid, String format);
    DownloadRecordPageResponse getUnfinishedRecordList(String pageContext);
    DownloadRecordPageResponse getFinishedRecordList(String groupId, String pageContext);
    List<FinishGroupInfo> getFinishedGroupList();
    DownloadingGroupInfo getDownloadingGroupInfo();
    oneway void removeAllUnFinishedRecord();
    oneway void removeFinishedGroupList(in List<String> groupIdList);
    long getAllCacheSize();
    oneway void updateDB(in DownloadRichRecord downloadRichRecord);
    oneway void clearCache();
    List<StorageDevice> getStorageDeviceList();
    oneway void switchCurrentStorage(String storageId);
    int getUnWatchedCount();
    boolean isUpdated();
    oneway void checkFinalInit(boolean needCheckFinalInitByOuter);
    oneway void handleFinalInit();
    oneway void mainProcessExit();
    oneway void resumePreDownload(in DownloadRichRecord downloadRichRecord);
    int getUnFinishedRecordCount();
    oneway void onSwitchFront();
    oneway void onSwitchBackground();
    int getAllRecordCount();
    int getAllRecordCountOfGroup(String groupId);
    oneway void setCanDownloadAndPlay(boolean downloadAndPlay);
    oneway void setTryAccelerate(boolean isAccelerate);
    boolean needShowSwitchStorageTips();
    oneway void clickSwitchStorageTips();
    boolean isP2PConfigFinish();
    int getDownloadingCount();
    oneway void setDownloadMultiCount(int count);
    oneway void updateHasPlayDuration(String vid, String format, int duration);
}