package com.tencent.qqlive.services.download;

import com.tencent.qqlive.services.download.IDownloadCallback;
import com.tencent.qqlive.services.download.TaskParam;

interface IDownloadService {
    oneway void setConfig(in Map config);
    oneway void registerCallback(IDownloadCallback callback);
    oneway void unregisterCallback(IDownloadCallback callback);
	oneway void cancelTask(String url, String packageName, String reportProps);
	oneway void pauseTask(String url, String packageName, String reportProps);
	oneway void addTask(in TaskParam taskParam);
	oneway void queryTaskState(String url, String packageName, int versionCode,IDownloadCallback callback);
	oneway void startUpdateCheck(in byte[] updateResponse, boolean isAutoMode);
	oneway void startUpdateAction(in byte[] updateResponse, boolean byYYB, long qqUin);
	oneway void destroy(boolean isForceEnd);
	oneway void cancelPreDownloadYYB();
	boolean isYYBInstalled();
	boolean isYYBDownloaded();
	oneway void checkAndDownloadYYB();
	oneway void installYYBApk();
	boolean hasQQDownloaderState();
}
